/*
 * xfdataf.c:
 *      This file contains the following major XFolder parts:
 *
 *      -  XFldDataFile SOM stuff
 *
 *      Check the other files starting with xf* for the
 *      other XFolder classes.
 *
 *      Copyright (C) 1997-98 Ulrich Mller.
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, in version 2 as it comes in the COPYING
 *      file of the XFolder main distribution.
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 */

/*
 *  This file was generated by the SOM Compiler and Emitter Framework.
 *  Generated using:
 *      SOM Emitter emitctm: 2.41
 */

#ifndef SOM_Module_xfdataf_Source
#define SOM_Module_xfdataf_Source
#endif
#define XFldDataFile_Class_Source
#define M_XFldDataFile_Class_Source

#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES
#define INCL_DOSEXCEPTIONS
#define INCL_DOSERRORS
#include <os2.h>

#include "xfdataf.ih"

#include "common.h"

/*
 * xfAddXFldDataFilePages:
 *           this actually adds the "XFolder" pages into the System notebook
 */

SOM_Scope ULONG  SOMLINK xfdataf_xfAddXFldDataFilePages(XFldDataFile *somSelf,
                                                        HWND hwndDlg)
{
    /* XFldDataFileData *somThis = XFldDataFileGetData(somSelf); */
    XFldDataFileMethodDebug("XFldDataFile","xfdataf_xfAddXFldDataFilePages");

    return (0);
}

/*
 * wpSetRealName:
 *           this instance method only changes the real name.
 *           This method is introduced by WPFileSystem and
 *           overridden by WPDataFile.
 */

SOM_Scope BOOL  SOMLINK xfdataf_wpSetRealName(XFldDataFile *somSelf,
                                              PSZ pszName)
{
    /* XFldDataFileData *somThis = XFldDataFileGetData(somSelf); */
    // XFldDataFileMethodDebug("XFldDataFile","xfdataf_wpSetRealName");
    #ifdef DEBUG_SOMMETHODS
        _Pmpf(("XFldDataFile::wpSetRealName to %s", pszName));
    #endif

    // _Pmpf(("XFldDataFile::wpSetRealName to %s", pszName));

    return (XFldDataFile_parent_WPDataFile_wpSetRealName(somSelf,
                                                         pszName));
}

/*
 * wpConfirmKeepAssoc:
 *           this instance method is called when a file is renamed
 *           and confirmations are on. It must return one of the
 *           following:
 *               KEEP_RENAMEFILESWITHEXT
 *                   the file is renamed, and the associations
 *                   which were valid for the old filename
 *                   are added to the menu page
 *               DISCARD_RENAMEFILESWITHEXT
 *                   the file is renamed, and old associations
 *                   are discarded (not added to the menu page)
 *               CANCEL_RENAMEFILESWITHEXT
 *                   the file is not renamed, and the title is
 *                   not changed
 */

SOM_Scope ULONG  SOMLINK xfdataf_wpConfirmKeepAssoc(XFldDataFile *somSelf)
{
    ULONG ulrc = 0;
    /* XFldDataFileData *somThis = XFldDataFileGetData(somSelf); */
    // XFldDataFileMethodDebug("XFldDataFile","xfdataf_wpConfirmKeepAssoc");
    #ifdef DEBUG_SOMMETHODS
        _Pmpf(("XFldDataFile::wpConfirmKeepAssoc for %s", _wpQueryTitle(somSelf)));
    #endif

    ulrc = XFldDataFile_parent_WPDataFile_wpConfirmKeepAssoc(somSelf);
    // _Pmpf(("  Original's return value: 0x%lX", ulrc));
    return (ulrc);
}

/*
 * wpConfirmRenameFileWithExt:
 *           this instance method is called when a file is renamed
 *           and confirmations are on. It should prompt the
 *           user whether to rename this file with possibly a
 *           different extension. It must return one of the
 *           following:
 *               CANCEL_RENAMEFILESWITHEXT
 *                   the file is not renamed, and the title is not changed
 *               DISCARD_RENAMEFILESWITHEXT
 *                   the file is renamed, and the old extension is discarded
 *               KEEP_RENAMEFILESWITHEXT
 *                   the file is renamed, but the old extension is kept
 */

SOM_Scope ULONG  SOMLINK xfdataf_wpConfirmRenameFileWithExt(XFldDataFile *somSelf)
{
    ULONG ulrc = 0;
    /* XFldDataFileData *somThis = XFldDataFileGetData(somSelf); */
    // XFldDataFileMethodDebug("XFldDataFile","xfdataf_wpConfirmRenameFileWithExt");
    #ifdef DEBUG_SOMMETHODS
        _Pmpf(("XFldDataFile::wpConfirmRenameFileWithExt for %s",
                _wpQueryTitle(somSelf)));
    #endif

    ulrc = XFldDataFile_parent_WPDataFile_wpConfirmRenameFileWithExt(somSelf);
    // _Pmpf(("  Original's return value: 0x%lX", ulrc));
    return (ulrc);
}

/*
 * wpclsInitData:
 *           initialize class instance data
 */

SOM_Scope void  SOMLINK xfdatafM_wpclsInitData(M_XFldDataFile *somSelf)
{
    // M_XFldDataFileData *somThis = M_XFldDataFileGetData(somSelf);
    M_XFldDataFileMethodDebug("M_XFldDataFile","xfdatafM_wpclsInitData");

    M_XFldDataFile_parent_M_WPDataFile_wpclsInitData(somSelf);
}

/*
 * wpclsQueryTitle:
 *           tell the WPS the new class name: System (XFolder)
 */

SOM_Scope PSZ  SOMLINK xfdatafM_wpclsQueryTitle(M_XFldDataFile *somSelf)
{
    // M_XFldDataFileData *somThis = M_XFldDataFileGetData(somSelf);
    M_XFldDataFileMethodDebug("M_XFldDataFile","xfdatafM_wpclsQueryTitle");

    /* strcpy(&(_szTitle[0]), M_XFldDataFile_parent_M_WPDataFile_wpclsQueryTitle(somSelf));
    strcat(&(_szTitle[0]), " (XFolder)");

    return (&(_szTitle[0])); */

    return (M_XFldDataFile_parent_M_WPDataFile_wpclsQueryTitle(somSelf));
}

