/*
 * xffsys.c:
 *      This file contains the following major XFolder parts:
 *
 *      -  XFldFileSystem SOM stuff
 *
 *      Check the other files starting with xf* for the
 *      other XFolder classes.
 *
 *      Copyright (C) 1997-98 Ulrich Mller.
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, in version 2 as it comes in the COPYING
 *      file of the XFolder main distribution.
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 */

/*
 *  This file was generated by the SOM Compiler and Emitter Framework.
 *  Generated using:
 *      SOM Emitter emitctm: 2.41
 */

#ifndef SOM_Module_xffsys_Source
#define SOM_Module_xffsys_Source
#endif
#define XFldFileSystem_Class_Source
#define M_XFldFileSystem_Class_Source

#define INCL_DOSFILEMGR
#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES
#define INCL_DOSEXCEPTIONS
#define INCL_DOSERRORS

// pmwin.h
#define INCL_WINWINDOWMGR
#define INCL_WINSHELLDATA       // profile funcs
#define INCL_WINCLIPBOARD

// dialogs and controls therein
#define INCL_WINDIALOGS
#define INCL_WINMENUS

// pmstddlg.h
#define INCL_WINSTDBOOK         // notebooks

#include <os2.h>

#include "xffsys.ih"
#include <wpshadow.h>

#include "common.h"

CHAR    szWPFileSystemStatusBarMnemonics[256] = "";

/*
 * xfTranslateStatusBarMnemonics:
 *           this method is called on an object to retrieve
 *           the "single-object" status bar info. pszText
 *           originally contains the (class-specific) mnemonic
 *           string returned by xfclsQueryStatusBarMnemonics.
 *           As opposed to the other mnemonics funcs, this is
 *           an _instance_ method because some translation
 *           might already be performed depending on the
 *           selected object.
 */

SOM_Scope ULONG  SOMLINK xffsys_xfTranslateStatusBarMnemonics(XFldFileSystem *somSelf,
                                                               PSZ pszText,
                                                               ULONG cbText)
/* single-object status bar text mnemonics understood by XFldFileSystem
   (in addition to those introduced by XFldObject):

     $r      object's real name

     $y      object type (.TYPE EA)
     $D      object creation date
     $T      object creation time
     $a      object attributes

     $Eb     EA size in bytes
     $Ek     EA size in kBytes
     $EK     EA size in KBytes
 */

{
    CHAR        // szSizeSelected[20] = "0",
                szThousand[10],
                szTemp[300];
    BOOL        fCont = TRUE;
    PSZ         p;

    /* XFldFileSystemData *somThis = XFldFileSystemGetData(somSelf); */
    XFldFileSystemMethodDebug("XFldFileSystem","xffsys_xfTranslateStatusBarMnemonics");

    // first do the WPObject translation
    XFldFileSystem_parent_XFldObject_xfTranslateStatusBarMnemonics(somSelf,
                                                                         pszText,
                                                                         cbText);

    do {
        strcpy(szTemp, "?");
        fCont = FALSE;

        if (p = strstr(pszText, "$r")) // real name
        {
            ULONG ulSize = sizeof(szTemp);
            _wpQueryRealName(somSelf, szTemp, &ulSize, FALSE);
            strrpl(pszText, "$r", szTemp);
            fCont = TRUE;
        }
        else if (p = strstr(pszText, "$y")) // attribs
        {
            PSZ p2 = NULL;
            p2 = _wpQueryType(somSelf);
            strrpl(pszText, "$y", (p2) ? p2 : "?");
            fCont = TRUE;
        }
        else if (p = strstr(pszText, "$D"))  // date
        {
            FILEFINDBUF4 ffb4;
            ULONG ulDateFormat =
                PrfQueryProfileInt(HINI_USER, "PM_National", "iDate", 0);
            CHAR szDateSep[10];
            PrfQueryProfileString(HINI_USER, "PM_National", "sDate", "/",
                szDateSep, sizeof(szDateSep)-1);

            _wpQueryDateInfo(somSelf, &ffb4);
            strFileDate(szTemp, &ffb4, ulDateFormat, szDateSep[0]);
            strrpl(pszText, "$D", szTemp);
            fCont = TRUE;
        }
        else if (p = strstr(pszText, "$T"))  // time
        {
            FILEFINDBUF4 ffb4;
            ULONG ulTimeFormat =
                PrfQueryProfileInt(HINI_USER, "PM_National", "iTime", 0);
            CHAR szTimeSep[10];
            PrfQueryProfileString(HINI_USER, "PM_National", "sTime", ":",
                szTimeSep, sizeof(szTimeSep)-1);

            _wpQueryDateInfo(somSelf, &ffb4);
            strFileTime(szTemp, &ffb4, ulTimeFormat, szTimeSep[0]);
            strrpl(pszText, "$T", szTemp);
            fCont = TRUE;
        }
        else if (p = strstr(pszText, "$a")) // attribs
        {
            ULONG fAttr = _wpQueryAttr(somSelf);
            szTemp[0] = (fAttr & FILE_ARCHIVED) ? 'A' : 'a';
            szTemp[1] = (fAttr & FILE_HIDDEN  ) ? 'H' : 'h';
            szTemp[2] = (fAttr & FILE_READONLY) ? 'R' : 'r';
            szTemp[3] = (fAttr & FILE_SYSTEM  ) ? 'S' : 's';
            szTemp[4] = '\0';
            strrpl(pszText, "$a", szTemp);
            fCont = TRUE;
        }
        else if (p = strstr(pszText, "$Eb")) // easize
        {
            ULONG ulEASize;
            ulEASize = _wpQueryEASize(somSelf);
            strths(szTemp, ulEASize, szThousand[0]);
            strrpl(pszText, "$Eb", szTemp);
            fCont = TRUE;
        }
        else if (p = strstr(pszText, "$Ek"))
        {
            ULONG ulEASize;
            ulEASize = _wpQueryEASize(somSelf);
            strths(szTemp, ((ulEASize+500)/1000), szThousand[0]);
            strrpl(pszText, "$Ek", szTemp);
            fCont = TRUE;
        }
        else if (p = strstr(pszText, "$EK"))
        {
            ULONG ulEASize;
            ulEASize = _wpQueryEASize(somSelf);
            strths(szTemp, ((ulEASize+512)/1024), szThousand[0]);
            strrpl(pszText, "$EK", szTemp);
            fCont = TRUE;
        }
    } while (fCont);

    return (0);
}

/*
 * wpSetTitle:
 *           for file-system objects, this instance method
 *           changes the title and real name of a file.
 *           Since the WPS keeps writing .LONGNAME attributes
 *           for the title even if it's not different from
 *           the real name, we override this method.
 */

SOM_Scope BOOL  SOMLINK xffsys_wpSetTitle(XFldFileSystem *somSelf,
                                          PSZ pszNewTitle)
{
    /* XFldFileSystemData *somThis = XFldFileSystemGetData(somSelf); */
    // XFldFileSystemMethodDebug("XFldFileSystem","xffsys_wpSetTitle");
    #ifdef DEBUG_SOMMETHODS
        _Pmpf(("XFldFileSystem::wpSetTitle to %s", pszNewTitle));
    #endif

    return (XFldFileSystem_parent_WPFileSystem_wpSetTitle(somSelf, pszNewTitle));
    /* XFldFileSystem_parent_XFldObject_wpSetTitle(somSelf,
                                                        pszNewTitle)); */
}

/*
 * wpSetTitle:
 *           similar to wpSetTitle, but here you can specify
 *           what confirmations will be issued.
 */

SOM_Scope BOOL  SOMLINK xffsys_wpSetTitleAndRenameFile(XFldFileSystem *somSelf,
                                                       PSZ pszNewTitle,
                                                       ULONG fConfirmations)
{
    /* XFldFileSystemData *somThis = XFldFileSystemGetData(somSelf); */
    // XFldFileSystemMethodDebug("XFldFileSystem","xffsys_wpSetTitleAndRenameFile");
    #ifdef DEBUG_SOMMETHODS
        _Pmpf(("XFldFileSystem::wpSetTitleAndRenameFile to %s, ulConfirm: %d",
                pszNewTitle, fConfirmations));
    #endif

    return (XFldFileSystem_parent_WPFileSystem_wpSetTitleAndRenameFile(somSelf,
                                                                       pszNewTitle,
                                                                       fConfirmations));
}


/*
 * wpSetRealName:
 *           this instance method only changes the real name.
 *           This method is introduced by WPFileSystem and
 *           overridden by WPDataFile.
 */

SOM_Scope BOOL  SOMLINK xffsys_wpSetRealName(XFldFileSystem *somSelf,
                                             PSZ pszName)
{
    /* XFldFileSystemData *somThis = XFldFileSystemGetData(somSelf); */
    // XFldFileSystemMethodDebug("XFldFileSystem","xffsys_wpSetRealName");
    #ifdef DEBUG_SOMMETHODS
        _Pmpf(("XFldFileSystem::wpSetRealName to %s", pszName));
    #endif

    return (XFldFileSystem_parent_WPFileSystem_wpSetRealName(somSelf,
                                                             pszName));
}

/*
 * wpModifyPopupMenu:
 *           add file-system object popup menu entries
 */

SOM_Scope BOOL  SOMLINK xffsys_wpModifyPopupMenu(XFldFileSystem *somSelf,
                                                 HWND hwndMenu,
                                                 HWND hwndCnr,
                                                 ULONG iPosition)
{
    BOOL brc;
    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
    HWND hwndAttribs;
    /* XFldFileSystemData *somThis = XFldFileSystemGetData(somSelf); */
    XFldFileSystemMethodDebug("XFldFileSystem","xffsys_wpModifyPopupMenu");

    brc = XFldFileSystem_parent_WPFileSystem_wpModifyPopupMenu(somSelf,
                                                         hwndMenu,
                                                         hwndCnr,
                                                         iPosition);
    /* return (XFldFileSystem_parent_XFldObject_wpModifyPopupMenu(somSelf,
                                                               hwndMenu,
                                                               hwndCnr,
                                                               iPosition)); */

    if (pGlobalSettings->CopyFilename)
    {
        WinInsertMenuSeparator(hwndMenu, MIT_END,
                    (pGlobalSettings->VarMenuOffset + ID_XFMI_OFS_SEPARATOR));

        WinInsertMenuItem(hwndMenu, MIT_END,
            (pGlobalSettings->VarMenuOffset + ID_XFMI_OFS_COPYFILENAME_MENU),
            (cmnQueryNLSStrings())->pszCopyFilename,
            0, 0);
    }

    return (brc);
}

/*
 * xfModifySettingsSubmenu:
 *           this new method is called from XFldObject's override
 *           of wpModifyPopupMenu every time a context menu is
 *           about to be opened. In this method, WPS classes may
 *           add new items to the new "Settings" submenu, whose
 *           wnd handle is passed to this method in
 *           hwndSettingsSubmenu. This method must return TRUE if
 *           any items were added, or FALSE otherwise.
 */

SOM_Scope BOOL  SOMLINK xffsys_xfModifySettingsSubmenu(XFldFileSystem *somSelf,
                                                       HWND hwndSettingsSubmenu,
                                                       HWND hwndCnr)
{
    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
    PNLSSTRINGS pNLSStrings = cmnQueryNLSStrings();
    HWND hwndAttrSubmenu;
    ULONG ulAttr = 0;
    /* XFldFileSystemData *somThis = XFldFileSystemGetData(somSelf); */
    XFldFileSystemMethodDebug("XFldFileSystem","xffsys_xfModifySettingsSubmenu");

    XFldFileSystem_parent_XFldObject_xfModifySettingsSubmenu(somSelf,
                                       hwndSettingsSubmenu, hwndCnr);

    WinInsertMenuSeparator(hwndSettingsSubmenu, MIT_END,
                (pGlobalSettings->VarMenuOffset + ID_XFMI_OFS_SEPARATOR));

    ulAttr = _wpQueryAttr(somSelf);
    hwndAttrSubmenu = WinInsertSubmenu(hwndSettingsSubmenu, MIT_END,
                (pGlobalSettings->VarMenuOffset + ID_XFM_OFS_ATTRIBUTES),
                        pNLSStrings->pszAttributes, 0,
                (pGlobalSettings->VarMenuOffset + ID_XFMI_OFS_ATTR_ARCHIVED),
                        pNLSStrings->pszAttrArchived, MIS_TEXT,
                            ((ulAttr & FILE_ARCHIVED) ? MIA_CHECKED : 0));
    WinInsertMenuItem(hwndAttrSubmenu, MIT_END,
                (pGlobalSettings->VarMenuOffset + ID_XFMI_OFS_ATTR_READONLY),
                        pNLSStrings->pszAttrReadOnly, MIS_TEXT,
                            ((ulAttr & FILE_READONLY) ? MIA_CHECKED : 0));
    WinInsertMenuItem(hwndAttrSubmenu, MIT_END,
                (pGlobalSettings->VarMenuOffset + ID_XFMI_OFS_ATTR_SYSTEM),
                        pNLSStrings->pszAttrSystem, MIS_TEXT,
                            ((ulAttr & FILE_SYSTEM) ? MIA_CHECKED : 0));
    WinInsertMenuItem(hwndAttrSubmenu, MIT_END,
                (pGlobalSettings->VarMenuOffset + ID_XFMI_OFS_ATTR_HIDDEN),
                        pNLSStrings->pszAttrHidden, MIS_TEXT,
                            ((ulAttr & FILE_HIDDEN) ? MIA_CHECKED : 0));

    return (TRUE);
}

/*
 * xfSelectingMenuItem:
 *           this new method is called on an object even before
 *           wpMenuItemSelected is called, i.e. right after a
 *           menu item has been selected by the user, and before
 *           the menu is dismissed.
 *           This call is the result
 *           of a WM_MENUSELECT intercept of the subclassed frame
 *           window procedure of an open folder. An object may
 *           intercept certain menu selections in order to process
 *           them without the menu being dismissed afterwards.
 *           Parameters:
 *              usItem        selected menu item
 *              fPostCommand  if this flag is TRUE, wpMenuItemSelected
 *                            will be called afterwards (do not modify)
 *              hwndMenu      wnd handle of the current menu control
 *              hwndCnr       wnd handle of the current container
 *              ulSelection   one of the following:
 *                    SEL_WHITESPACE the context menu was opened on the
 *                                   whitespace in an open container view
 *                                   of somSelf (which is a folder then)
 *                    SEL_SINGLESEL  the context menu was opened for a
 *                                   single selected object: somSelf can
 *                                   be any object then, including folders
 *                    SEL_MULTISEL   the context menu was opened on one
 *                                   of a multitude of selected objects;
 *                                   again, somSelf can be any object
 *                    SEL_SINGLEOTHER the context menu was opened for a
 *                                   single object _other_ than the selected
 *                                   objects
 *
 *           You must return one of the following:
 *              TRUE          dismiss the menu and, if (fPostCommand),
 *                            call wpMenuItemSelected
 *              FALSE         do not dismiss the menu and do not call
 *                            wpMenuItemSelected
 *           For menu items which have no meaning for this instance method,
 *           the return value of the parent method must be returned.
 */

SOM_Scope BOOL  SOMLINK xffsys_xfSelectingMenuItem(XFldFileSystem *somSelf,
                                                   USHORT usItem,
                                                   BOOL fPostCommand,
                                                   HWND hwndMenu,
                                                   HWND hwndCnr,
                                                   ULONG ulSelection)
{
    PGLOBALSETTINGS     pGlobalSettings = cmnQueryGlobalSettings();
    ULONG               ulMenuId2 = usItem - pGlobalSettings->VarMenuOffset;
    BOOL                brc = FALSE;     // "not processed" flag

    /* XFldFileSystemData *somThis = XFldFileSystemGetData(somSelf); */
    XFldFileSystemMethodDebug("XFldFileSystem","xffsys_xfSelectingMenuItem");

    switch (ulMenuId2) {
        case ID_XFMI_OFS_ATTR_ARCHIVED:
        case ID_XFMI_OFS_ATTR_SYSTEM:
        case ID_XFMI_OFS_ATTR_HIDDEN:
        case ID_XFMI_OFS_ATTR_READONLY: {
            ULONG ulFileAttr = _wpQueryAttr(somSelf);
            ULONG ulMenuAttr = (ULONG)WinSendMsg(hwndMenu, MM_QUERYITEMATTR,
                                        MPFROM2SHORT(usItem, FALSE),
                                        (MPARAM)MIA_CHECKED);

            // toggle file attribute and write back
            ulFileAttr ^= // XOR flag depending on menu item
                      (ulMenuId2 == ID_XFMI_OFS_ATTR_ARCHIVED) ? FILE_ARCHIVED
                    : (ulMenuId2 == ID_XFMI_OFS_ATTR_SYSTEM  ) ? FILE_SYSTEM
                    : (ulMenuId2 == ID_XFMI_OFS_ATTR_HIDDEN  ) ? FILE_HIDDEN
                    : FILE_READONLY;
            _wpSetAttr(somSelf, ulFileAttr);

            // toggle "checked" flag in menu
            ulMenuAttr ^= MIA_CHECKED;  // XOR checked flag;
            WinSendMsg(hwndMenu, MM_SETITEMATTR,
                                        MPFROM2SHORT(usItem, FALSE),
                                        MPFROM2SHORT(MIA_CHECKED, ulMenuAttr));
            // prevent dismissal of menu
            brc = FALSE;
        break; }

        default:
            brc = XFldFileSystem_parent_XFldObject_xfSelectingMenuItem(somSelf,
                                                                 usItem,
                                                                 fPostCommand,
                                                                 hwndMenu,
                                                                 hwndCnr,
                                                                 ulSelection);
    }

    return (brc);
}

/*
 * cmnCopyObjectFileName:
 *      copy an object's filename to clipboard. This method is
 *      called from XFldFileSystem's override of wpMenuItemSelected.
 *      Parameters:
 *          somSelf         the object which was passed to wpMenuItemSelected.
 *          hwndCnr         the container of the hwmdFrame of wpMenuItemSelected.
 *          fFullPath       flag for whether the full path shall be copied.
 */

BOOL cmnCopyObjectFileName(WPObject *somSelf, HWND hwndFrame, BOOL fFullPath)
{
    PSZ     pszDest = NULL;
    BOOL    fSuccess = FALSE,
            fSingleMode = TRUE;
    CHAR    szToClipboard[3000] = "";
    ULONG   ulLength;
    HAB     hab = WinQueryAnchorBlock(HWND_DESKTOP);

    // get the record core of somSelf
    PMINIRECORDCORE pmrcSelf = _wpQueryCoreRecord(somSelf);

    HWND hwndCnr = WinQueryCnrFromFrame(hwndFrame);

    // now we go through all the selected records in the container
    // and check if pmrcSelf is among these selected records;
    // if so, this means that we want to copy the filenames
    // of all the selected records.
    // However, if pmrcSelf is not among these, this means that
    // either the context menu of the _folder_ has been selected
    // or the menu of an object which is not selected; we will
    // then only copy somSelf's filename.

    PMINIRECORDCORE pmrcSelected = (PMINIRECORDCORE)CMA_FIRST;

    do {
        // get the first or the next _selected_ item
        pmrcSelected =
            (PMINIRECORDCORE)WinSendMsg(hwndCnr,
                    CM_QUERYRECORDEMPHASIS,
                    (MPARAM)pmrcSelected,
                    (MPARAM)CRA_SELECTED);

        if ((pmrcSelected != 0) && (((ULONG)pmrcSelected) != -1)) {

            CHAR       szRealName[CCHMAXPATH];
            ULONG      cbRealName = sizeof(szRealName);

            XFldObject *pObject = OBJECT_FROM_PREC(pmrcSelected);
            if (pObject)
                if (_somIsA(pObject, _WPShadow))
                    pObject = _wpQueryShadowedObject(pObject, TRUE);

            if (pObject)
                if (_somIsA(pObject, _WPFileSystem))
                    if (_wpQueryRealName(pObject, szRealName, &cbRealName, fFullPath))
                        sprintf(szToClipboard+strlen(szToClipboard), "%s ", szRealName);

            // compare the selection with pmrcSelf
            if (pmrcSelected == pmrcSelf)
                fSingleMode = FALSE;
        }
    } while ((pmrcSelected != 0) && (((ULONG)pmrcSelected) != -1));

    if (fSingleMode) {
        // if somSelf's record core does NOT have the "selected"
        // emphasis: this means that the user has requested a
        // context menu for an object other than the selected
        // objects in the folder, or the folder's context menu has
        // been opened: we will only copy somSelf then.
        CHAR       szRealName[CCHMAXPATH];
        ULONG      cbRealName = sizeof(szRealName);

        XFldObject *pObject = somSelf;
        if (_somIsA(pObject, _WPShadow))
            pObject = _wpQueryShadowedObject(pObject, TRUE);

        if (pObject)
            if (_somIsA(pObject, _WPFileSystem))
                if (_wpQueryRealName(pObject, szRealName, &cbRealName, fFullPath))
                    sprintf(szToClipboard, "%s ", szRealName);
    }

    ulLength = strlen(szToClipboard);
    if (ulLength) {
        szToClipboard[ulLength-1] = '\0'; // remove last space

        // copy to clipboard (stolen from PMREF)
        if (WinOpenClipbrd(hab)) {
            if (0 == DosAllocSharedMem(
                    (PVOID)&pszDest,       // pointer to shared memory object
                    NULL,                  // use unnamed shared memory
                    ulLength,              // include 0 byte (used to be last space)
                    PAG_WRITE  |           // allow write access
                    PAG_COMMIT |           // commit the shared memory
                    OBJ_GIVEABLE))         // make pointer giveable
            {
                strcpy(pszDest, szToClipboard);

                WinEmptyClipbrd(hab);

                fSuccess = WinSetClipbrdData(hab, // anchor-block handle
                    (ULONG)pszDest,               // pointer to text data
                    CF_TEXT,                      // data is in text format
                    CFI_POINTER);                 // passing a pointer

                WinCloseClipbrd(hab);
            }
        }
    }

    return (fSuccess);
}

/*
 * wpMenuItemSelected:
 *           process input when any menu item was selected
 */

SOM_Scope BOOL  SOMLINK xffsys_wpMenuItemSelected(XFldFileSystem *somSelf,
                                                  HWND hwndFrame,
                                                  ULONG ulMenuId)
{
    BOOL brc = FALSE;
    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
    /* XFldFileSystemData *somThis = XFldFileSystemGetData(somSelf); */
    XFldFileSystemMethodDebug("XFldFileSystem","xffsys_wpMenuItemSelected");

    if (ulMenuId == (pGlobalSettings->VarMenuOffset + ID_XFMI_OFS_COPYFILENAME_MENU))
    {
        cmnCopyObjectFileName(somSelf, hwndFrame, DosQueryShiftState());
        brc = TRUE;
    } else
        brc = XFldFileSystem_parent_WPFileSystem_wpMenuItemSelected(somSelf,
                                                          hwndFrame,
                                                          ulMenuId);

    return (brc);
}

/*
 * wpMenuItemHelpSelected:
 *           display help for a context menu item
 */

SOM_Scope BOOL  SOMLINK xffsys_wpMenuItemHelpSelected(XFldFileSystem *somSelf,
                                                      ULONG MenuId)
{
    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
    /* XFldFileSystemData *somThis = XFldFileSystemGetData(somSelf); */
    XFldFileSystemMethodDebug("XFldFileSystem","xffsys_wpMenuItemHelpSelected");

    if (MenuId == (pGlobalSettings->VarMenuOffset + ID_XFMI_OFS_COPYFILENAME_MENU))
    {
        PSZ pszHelpLibrary = cmnQueryHelpLibrary();
        BOOL fProcessed = FALSE;
        ULONG ulPanel = ID_XMH_COPYFILENAME;
        if (pszHelpLibrary)
            // path found: display help panel
            if (_wpDisplayHelp(somSelf, ulPanel, pszHelpLibrary))
                fProcessed = TRUE;

        if (!fProcessed)
            cmnMessageBoxMsg(HWND_DESKTOP, 104, 134, MB_OK);
        return TRUE;
    } else // none of our items: pass on to parent
        return (XFldFileSystem_parent_WPFileSystem_wpMenuItemHelpSelected(somSelf,
                                                              MenuId));
}

/*
 * xfclsAddsNewStatusBarMnemonics:
 *           this method returns flags for whether this class
 *           supports specific status bar mnemonics, i.e. objects
 *           of this class (and subclasses) display different
 *           information in status bar "single-object" mode
 *           than objects of parent classes. This method is
 *           called from the "Status bar" settings page in
 *           order to find out if different mnemonics can be
 *           set for this class.
 *           ORed return values are:
 *                SBS_ADDSMNEMONICS   class has own mnemonics
 *                SBS_MODIFIABLE      these mnemonics are modifiable
 *                                    (if not: they're static)
 */

SOM_Scope ULONG  SOMLINK xffsysM_xfclsAddsNewStatusBarMnemonics(M_XFldFileSystem *somSelf)
{
    // M_XFldFileSystemData *somThis = M_XFldFileSystemGetData(somSelf);
    M_XFldFileSystemMethodDebug("M_XFldFileSystem","xffsysM_xfclsAddsNewStatusBarMnemonics");

    return ( (somSelf == _XFldFileSystem)
             ? (SBS_ADDSMNEMONICS | SBS_MODIFIABLE)
             : 0);
}

/*
 * xfclsQueryStatusBarMnemonics:
 *           this returns the status bar mnemonics for "single object"
 *           info for objects of this class and subclasses. This string
 *           is either what has been specified on the "Status bar"
 *           notebook page or a default string from the XFolder NLS DLL.
 *           The WPObject version returns the generic string for all
 *           objects, but this is overridden for file-system objects to
 *           return something more meaningful.
 */

SOM_Scope ULONG  SOMLINK xffsysM_xfclsQueryStatusBarMnemonics(M_XFldFileSystem *somSelf,
                                                               PSZ pszText,
                                                               ULONG cbText)
{
    // M_XFldFileSystemData *somThis = M_XFldFileSystemGetData(somSelf);
    M_XFldFileSystemMethodDebug("M_XFldFileSystem","xffsysM_xfclsQueryStatusBarMnemonics");

    if (szWPFileSystemStatusBarMnemonics[0] == '\0')
        // load string if this is the first time
        if (PrfQueryProfileString(HINI_USERPROFILE, INIAPP, INIKEY_SBTEXT_WPDATAFILE,
                     NULL, &(szWPFileSystemStatusBarMnemonics),
                     sizeof(szWPFileSystemStatusBarMnemonics))
                == 0)
            // string not found in profile: load default from NLS resources
            WinLoadString(WinQueryAnchorBlock(HWND_DESKTOP), NLS_MODULE,
                        ID_XSSI_SBTEXTWPDATAFILE,
                        sizeof(szWPFileSystemStatusBarMnemonics),
                        szWPFileSystemStatusBarMnemonics);

    strncpy(pszText, szWPFileSystemStatusBarMnemonics, cbText);
    pszText[cbText-1] = '\0';

    return (cbText);
}

/*
 * xfclsSetStatusBarMnemonics:
 *           change the status bar mnemonics for "single object"
 *           info for objects of this class and subclasses to
 *           pszText. If *pszText points to null-length string, no
 *           status bar info will be displayed; if pszText is NULL,
 *           the menmonics will be reset to the default value.
 */

SOM_Scope ULONG  SOMLINK xffsysM_xfclsSetStatusBarMnemonics(M_XFldFileSystem *somSelf,
                                                             PSZ pszText)
{
    // M_XFldFileSystemData *somThis = M_XFldFileSystemGetData(somSelf);
    M_XFldFileSystemMethodDebug("M_XFldFileSystem","xffsysM_xfclsSetStatusBarMnemonics");

    /* strncpy(szWPFileSystemStatusBarMnemonics, pszText, sizeof(szWPFileSystemStatusBarMnemonics));
    szWPFileSystemStatusBarMnemonics[sizeof(szWPFileSystemStatusBarMnemonics)-1] = '\0'; */

    // provoke a reload of the settings
    // in xfclsQueryStatusBarMnemonics
    szWPFileSystemStatusBarMnemonics[0] = '\0';

    // set the class mnemonics in OS2.INI; if
    // pszText == NULL, the key will be deleted,
    // and xfclsQueryStatusBarMnemonics will use
    // the default value
    return (ULONG)PrfWriteProfileString(HINI_USERPROFILE, INIAPP, INIKEY_SBTEXT_WPDATAFILE,
            pszText);
}

/*
 * wpclsInitData:
 *           initialize class instance data
 */

SOM_Scope void  SOMLINK xffsysM_wpclsInitData(M_XFldFileSystem *somSelf)
{
    // M_XFldFileSystemData *somThis = M_XFldFileSystemGetData(somSelf);
    M_XFldFileSystemMethodDebug("M_XFldFileSystem","xffsysM_wpclsInitData");

    M_XFldFileSystem_parent_M_WPFileSystem_wpclsInitData(somSelf);
    // M_XFldFileSystem_parent_M_XFldObject_wpclsInitData(somSelf);

    szWPFileSystemStatusBarMnemonics[0] = '\0';
}

/*
 * wpclsQueryTitle:
 *           tell the WPS the new class name: System (XFolder)
 */

SOM_Scope PSZ  SOMLINK xffsysM_wpclsQueryTitle(M_XFldFileSystem *somSelf)
{
    // M_XFldFileSystemData *somThis = M_XFldFileSystemGetData(somSelf);
    M_XFldFileSystemMethodDebug("M_XFldFileSystem","xffsysM_wpclsQueryTitle");

    /* strcpy(&(_szTitle[0]), M_XFldFileSystem_parent_M_WPFileSystem_wpclsQueryTitle(somSelf));
    strcat(&(_szTitle[0]), " (XFolder)");

    return (&(_szTitle[0])); */

    return (M_XFldFileSystem_parent_M_WPFileSystem_wpclsQueryTitle(somSelf));
}

