
/*
 * xfobj.c:
 *      This file contains the following major XFolder parts:
 *
 *      -  XFldObject SOM stuff
 *      -  Generic XFolder Object window for message processing
 *
 *      Check the other files starting with xf* for the
 *      other XFolder classes.
 *
 *      Copyright (C) 1997-98 Ulrich Mller.
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, in version 2 as it comes in the COPYING
 *      file of the XFolder main distribution.
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 */

/*
 *  This file was generated by the SOM Compiler and Emitter Framework.
 *  Generated using:
 *      SOM Emitter emitctm: 2.42
 */

#ifndef SOM_Module_xfobj_Source
#define SOM_Module_xfobj_Source
#endif
#define XFldObject_Class_Source
#define M_XFldObject_Class_Source

#define INCL_DOSFILEMGR
#define INCL_DOSMODULEMGR
#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES
#define INCL_DOSEXCEPTIONS
#define INCL_DOSERRORS

// pmwin.h
#define INCL_WINWINDOWMGR
#define INCL_WINFRAMEMGR        // WM_FORMATFRAME etc.
#define INCL_WINSYS             // presparams
#define INCL_WINCOUNTRY
#define INCL_WINPOINTERS

#define INCL_WINSHELLDATA       // profile funcs
#define INCL_WINTIMER
#define INCL_WINCLIPBOARD
#define INCL_WININPUT           // WinQueryFocus etc.

// dialogs and controls therein
#define INCL_WINDIALOGS
#define INCL_WINMENUS
#define INCL_WINENTRYFIELDS
#define INCL_WINBUTTONS
// pmstddlg.h
#define INCL_WINSTDBOOK         // notebooks

// GPI
// #define INCL_GPILOGCOLORTABLE
// #define INCL_GPIPRIMITIVES

#include <os2.h>

#include "xfobj.ih"
#include "xfldr.h"
#include "xfdesk.h"
// #include <wpshadow.h>

#include "common.h"           // this includes other libs

#include "objdlgs.h"
#include "xfsort.h"
#include "wphandles.h"        // Henk Kelder's object handles stuff

// WPObject status bar mnemonics; we use a global
// variable for this, because otherwise each metaclass
// (being also an M_WPObject) will store its own
// mnemonics
CHAR    szWPObjectStatusBarMnemonics[CCHMAXMNEMONICS] = "";

// XFolder object window handle
HWND    hwndXFolderObject = NULLHANDLE;

/*
 * cmnPostObjectMsg:
 *      post msg to XFolder object window
 */

BOOL cmnPostObjectMsg(ULONG msg, MPARAM mp1, MPARAM mp2)
{
    BOOL rc = FALSE;

    if (hwndXFolderObject) {
        rc = WinPostMsg(hwndXFolderObject, msg, mp1, mp2);
    }
    return (rc);
}

/*
 * cmnSendObjectMsg:
 *      send msg to XFolder object window
 */

MRESULT cmnSendObjectMsg(ULONG msg, MPARAM mp1, MPARAM mp2)
{
    MRESULT mrc = MPNULL;

    if (hwndXFolderObject) {
        mrc = WinSendMsg(hwndXFolderObject, msg, mp1, mp2);
    }
    return (mrc);
}

/*
 * fnwpStartupDlg:
 *      dlg proc for the Startup status window
 */

MRESULT EXPENTRY fnwpStartupDlg(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    MRESULT mrc;

    switch (msg) {

        case WM_INITDLG: {
            // WinSetWindowULong(hwnd, QWL_USER, (ULONG)mp2);
            // we don't need this here, it's done by fnwpXFolderObject
            WinProgressBarFromStatic(WinWindowFromID(hwnd, ID_SDDI_PROGRESSBAR),
                            PBA_ALIGNCENTER | PBA_BUTTONSTYLE);
            mrc = WinDefDlgProc(hwnd, msg, mp1, mp2);
        break; }

        case WM_COMMAND:
            switch (SHORT1FROMMP(mp1)) {

                case DID_CANCEL: {
                    PPROCESSCONTENTINFO pPCI;
                    pPCI = (PPROCESSCONTENTINFO)WinQueryWindowULong(hwnd, QWL_USER);
                    if (pPCI)
                        pPCI->fCancelled = TRUE;
                    mrc = WinDefDlgProc(hwnd, msg, mp1, mp2);
                break; }

                default:
                    mrc = WinDefDlgProc(hwnd, msg, mp1, mp2);
            }
        break;

        case WM_SYSCOMMAND: {
            switch (SHORT1FROMMP(mp1)) {
                case SC_HIDE: {
                    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
                    pGlobalSettings->ShowStartupProgress = 0;
                    PrfWriteProfileData(HINI_USERPROFILE, INIAPP, INIKEY_GLOBALSETTINGS,
                                pGlobalSettings, sizeof(GLOBALSETTINGS));
                    mrc = WinDefDlgProc(hwnd, msg, mp1, mp2);
                break; }

                default:
                    mrc = WinDefDlgProc(hwnd, msg, mp1, mp2);
            }
        break; }

        case WM_CLOSE: {
            WinStoreWindowPos(INIAPP, INIKEY_STARTUPWNDPOS, hwnd);
            mrc = WinDefDlgProc(hwnd, msg, mp1, mp2);
        break; }

        default:
            mrc = WinDefDlgProc(hwnd, msg, mp1, mp2);
    }

    return (mrc);
}

/*
 * fncbStartup:
 *      callback function during Startup folder processing;
 *      updates the status window and opens objects
 */

MRESULT EXPENTRY fncbStartup(HWND hwndStatus, ULONG ulObject, MPARAM mpNow, MPARAM mpMax)
{
    CHAR szStarting2[200], szTemp[200];
    HWND rc = 0;
    #ifdef DEBUG_STARTUP
        _Pmpf(("  -- fncbStartup called"));
    #endif

    if (ulObject) {
        if (cmnCheckObject((WPObject*)_XFldDesktop))
        {
            PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();

            if (pGlobalSettings->ShowStartupProgress) {
                // update status text ("Starting xxx")
                WinSetActiveWindow(HWND_DESKTOP, hwndStatus);
                strcpy(szTemp, _wpQueryTitle((WPObject*)ulObject));
                strBeautifyTitle(szTemp);
                sprintf(szStarting2,
                    (cmnQueryNLSStrings())->pszStarting,
                    szTemp);
                WinSetDlgItemText(hwndStatus, ID_SDDI_STATUS, szStarting2);
            }

            // open object
            rc = _wpViewObject((WPObject*)ulObject, 0, OPEN_DEFAULT, 0);

            if (pGlobalSettings->ShowStartupProgress)
                WinSetActiveWindow(HWND_DESKTOP, hwndStatus);
            WinSendMsg(WinWindowFromID(hwndStatus, ID_SDDI_PROGRESSBAR),
                WM_UPDATEPROGRESSBAR, mpNow, mpMax);
        }
    }
    else {
        // last object: close window
        WinPostMsg(hwndStatus, WM_CLOSE, MPNULL, MPNULL);
        // done with startup: notify Worker thread
        cmnPostWorkerMsg(WOM_DONEWITHSTARTUP, MPNULL, MPNULL);
    }
    return (MRESULT)rc;
}

/*
 * fnwpQuickOpenDlg:
 *      dlg proc for the QuickOpen status window
 */

BOOL fQuickOpenCancelled = FALSE;

MRESULT EXPENTRY fnwpQuickOpenDlg(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    MRESULT mrc;

    switch (msg) {

        case WM_INITDLG: {
            // WinSetWindowULong(hwnd, QWL_USER, (ULONG)mp2);
            // we don't need this here, it's done by fnwpXFolderObject
            WinProgressBarFromStatic(WinWindowFromID(hwnd, ID_SDDI_PROGRESSBAR),
                            PBA_ALIGNCENTER | PBA_BUTTONSTYLE);
            mrc = WinDefDlgProc(hwnd, msg, mp1, mp2);
        break; }

        case WM_COMMAND:
            switch (SHORT1FROMMP(mp1)) {

                case DID_CANCEL: {
                    fQuickOpenCancelled = TRUE;
                    // this will cause the callback below to
                    // return FALSE
                break; }

                default:
                    mrc = WinDefDlgProc(hwnd, msg, mp1, mp2);
            }
        break;

        case WM_SYSCOMMAND: {
            switch (SHORT1FROMMP(mp1)) {
                case SC_HIDE: {
                    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
                    pGlobalSettings->ShowStartupProgress = 0;
                    PrfWriteProfileData(HINI_USERPROFILE, INIAPP, INIKEY_GLOBALSETTINGS,
                                pGlobalSettings, sizeof(GLOBALSETTINGS));
                    mrc = WinDefDlgProc(hwnd, msg, mp1, mp2);
                break; }

                default:
                    mrc = WinDefDlgProc(hwnd, msg, mp1, mp2);
            }
        break; }

        case WM_DESTROY: {
            WinStoreWindowPos(INIAPP, INIKEY_STARTUPWNDPOS, hwnd);
            mrc = WinDefDlgProc(hwnd, msg, mp1, mp2);
        break; }

        default:
            mrc = WinDefDlgProc(hwnd, msg, mp1, mp2);
    }

    return (mrc);
}

/*
 * fncbQuickOpen:
 *      callback func called by Worker thread for
 *      each object whose icon is queried.
 *      If this returns FALSE, processing is
 *      terminated.
 */

ULONG    ulQuickOpenNow = 0,
         ulQuickOpenMax = 0;
HWND     hwndQuickStatus = NULLHANDLE;

MRESULT EXPENTRY fncbQuickOpen(HWND hwndFolder,
                            ULONG ulObject,     //
                            MPARAM mpNow,       // current object count
                            MPARAM mpMax)       // maximum object count
{
    WinSendMsg(WinWindowFromID(hwndQuickStatus, ID_SDDI_PROGRESSBAR),
            WM_UPDATEPROGRESSBAR,
            (MPARAM)(
                        ulQuickOpenNow*100 +
                            ( (100 * (ULONG)mpNow) / (ULONG)mpMax )
                    ),
            (MPARAM)(ulQuickOpenMax*100));

    // if "Cancel" has been pressed, return FALSE
    return ((MPARAM)(!fQuickOpenCancelled));
}

/*
 * fnwpXFolderObject:
 *      wnd proc for the XFolder Object window on the Workplace thread.
 *      This window is neccessary because we need to handle some msgs
 *      on the Workplace thread, or PM will run into trouble, especially
 *      when manipulating WPS windows; however, we should not add user
 *      msgs to the subclassed frame wnd proc, because we never know whether
 *      the WPS or other subclassing software might use these msgs already.
 *      Hence, we create an object window, which we own all alone.
 */

BOOL     fLimitMsgOpen = FALSE;

MRESULT EXPENTRY fnwpXFolderObject(HWND hwndObject, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    MPARAM mrc = NULL;

    switch(msg) {

        /*
         * WM_CREATE:
         *      create bootup status wnd, show
         *      XFolder logo
         */

        case WM_CREATE: {
            mrc = WinDefWindowProc(hwndObject, msg, mp1, mp2);
        break; }

        /*
         * XOM_POCCALLBACK:
         *      this msg is posted from the Worker thread whenever
         *      a callback func needs to be called during those
         *      "process ordered content" functions (initiated by
         *      xfProcessOrderedContent); we need this message to
         *      have the callback func run on the Workplace thread.
         *      Parameters:
         *          PPROCESSCONTENTINFO mp1
         *                          structure with all the information;
         *                          this routine must set the hwndView field
         *          MPARAM mp2      always NULL
         */

        case XOM_POCCALLBACK: {
            PPROCESSCONTENTINFO ppci = (PPROCESSCONTENTINFO)mp1;
            if (ppci) {
                ppci->hwndView = (HWND)((*(ppci->pfnwpCallback))(ppci->ulCallbackParam,
                    (ULONG)ppci->pObject,
                    (MPARAM)ppci->ulObjectNow, (MPARAM)ppci->ulObjectMax));
            }
        break; }

        /*
         * XOM_BEGINSTARTUP:
         *      this is an XFolder msg posted by the Worker thread after
         *      the Desktop has been populated; this performs initialization
         *      of the Startup folder process, which will then be further
         *      performed by (again) the Worker thread
         */

        case XOM_BEGINSTARTUP: {
            PGLOBALSETTINGS pGlobalSettings =
                    cmnQueryGlobalSettings();
            XFolder         *pStartupFolder;

            #ifdef DEBUG_STARTUP
                DosBeep(1000, 1000);
            #endif

            if (!DosQueryShiftState())
            {
                if (pStartupFolder = _wpclsQueryFolder(_WPFolder, XFOLDER_STARTUPID, TRUE))
                {
                    // startup folder exists: create status window w/ progress bar,
                    // start folder content processing in worker thread
                    CHAR szTitle[200];
                    ULONG hPOC;
                    HWND hwndStartupStatus = WinLoadDlg(HWND_DESKTOP, NULLHANDLE,
                                    fnwpStartupDlg,
                                    NLS_MODULE,
                                    ID_XFD_STARTUPSTATUS,
                                    NULL);
                    if (pGlobalSettings->ShowStartupProgress) {
                        /* FRAMECDATA  pFcdata;
                        // USHORT  usFrameId;

                        WinQueryWindowText(hwndStartupStatus, sizeof(szTitle), szTitle);
                        pFcdata.cb = sizeof(FRAMECDATA);
                        pFcdata.flCreateFlags = FCF_TITLEBAR |  FCF_SYSMENU |
                                                FCF_HIDEBUTTON;
                        pFcdata.hmodResources = 0L;
                        pFcdata.idResources = 0;
                        WinCreateFrameControls(hwndStartupStatus,
                                &pFcdata, szTitle);
                        WinSetWindowBits(hwndStartupStatus, QWL_STYLE, 1, FCF_HIDEBUTTON);
                        WinSendMsg(hwndStartupStatus, WM_UPDATEFRAME,
                                    (MPARAM)FCF_HIDEBUTTON, MPNULL); */

                        WinRestoreWindowPos(INIAPP, INIKEY_STARTUPWNDPOS,
                                hwndStartupStatus);
                        WinShowWindow(hwndStartupStatus, TRUE);
                        WinSetActiveWindow(HWND_DESKTOP, hwndStartupStatus);
                        #ifdef DEBUG_STARTUP
                            DosBeep(2000, 1000);
                        #endif
                    }

                    hPOC = _xfBeginProcessOrderedContent(pStartupFolder,
                            pGlobalSettings->StartupDelay,
                            &fncbStartup,
                            (ULONG)hwndStartupStatus);

                    WinSetWindowULong(hwndStartupStatus, QWL_USER, hPOC);
                }
                else
                    // startup folder does not exist:
                    cmnPostWorkerMsg(WOM_DONEWITHSTARTUP, MPNULL, MPNULL);
            }
            else {
                DosBeep(1000, 300);
                // shift pressed: skip startup
                cmnPostWorkerMsg(WOM_DONEWITHSTARTUP, MPNULL, MPNULL);
            }
        break; }

        /*
         * XOM_BEGINQUICKOPEN:
         *      this is posted by the Worker thread after the startup
         *      folder has been processed; we will now go for the
         *      "Quick Open" folders by populating them and querying
         *      all their icons. If this is posted for the first time,
         *      mp1 must be NULL; for subsequent postings, mp1 contains the
         *      folder to be populated or (-1) if it's the last.
         */

        case XOM_BEGINQUICKOPEN: {
            PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();

            if (mp1 == NULL) {
                // first posting: prepare
                if (!DosQueryShiftState())
                {
                    XFolder *pQuick = NULL;

                    // count quick-open folders
                    ulQuickOpenNow = 0;
                    ulQuickOpenMax = 0;
                    for (pQuick = _xfclsQueryQuickOpenFolder(_XFolder, NULL);
                         pQuick;
                         pQuick = _xfclsQueryQuickOpenFolder(_XFolder, pQuick))
                    {
                        ulQuickOpenMax++;
                    }

                    if (ulQuickOpenMax) {
                        // if we have any quick-open folders: go
                        if (pGlobalSettings->ShowStartupProgress) {
                            PNLSSTRINGS pNLSStrings = cmnQueryNLSStrings();
                            hwndQuickStatus = WinLoadDlg(HWND_DESKTOP, NULLHANDLE,
                                            fnwpQuickOpenDlg,
                                            NLS_MODULE,
                                            ID_XFD_STARTUPSTATUS,
                                            NULL);
                            WinSetWindowText(hwndQuickStatus,
                                    pNLSStrings->pszQuickStatus);
                            WinRestoreWindowPos(INIAPP, INIKEY_STARTUPWNDPOS,
                                    hwndQuickStatus);

                            WinShowWindow(hwndQuickStatus, TRUE);
                            #ifdef DEBUG_STARTUP
                                DosBeep(2000, 1000);
                            #endif
                            WinSendMsg(WinWindowFromID(hwndQuickStatus, ID_SDDI_PROGRESSBAR),
                                WM_UPDATEPROGRESSBAR,
                                (MPARAM)0, (MPARAM)ulQuickOpenMax);
                            fQuickOpenCancelled = FALSE;
                        }

                        // get first quick-open folder
                        pQuick = _xfclsQueryQuickOpenFolder(_XFolder, NULL);
                        if (pQuick)
                            cmnPostObjectMsg(XOM_BEGINQUICKOPEN,
                                    (MPARAM)pQuick,
                                    MPNULL);
                        // else none defined: do nothing
                    }
                }
                else {
                    // shift pressed: skip startup
                    DosBeep(1000, 300);
                }
            } // end if (mp1 == NULL)
            else {
                // subsequent postings
                XFolder *pQuick = (XFolder*)mp1;

                if (    (((ULONG)pQuick) != -1)
                    &&  (!fQuickOpenCancelled)
                   )
                {
                    // subsequent postings: mp1 contains folder
                    if (pGlobalSettings->ShowStartupProgress)
                    {
                        CHAR szTemp[256];

                        _wpQueryFilename(pQuick, szTemp, TRUE);
                        WinSetDlgItemText(hwndQuickStatus, ID_SDDI_STATUS, szTemp);
                    }

                    // populate object in Worker thread
                    cmnPostWorkerMsg(WOM_QUICKOPEN,
                            (MPARAM)pQuick,
                            (MPARAM)fncbQuickOpen);
                    // the Worker thread will then post
                    // XOM_NEXTQUICKOPEN when it's done
                } else {
                    DosSleep(500);
                    // -1 => no more folders: clean up
                    if (pGlobalSettings->ShowStartupProgress)
                        WinPostMsg(hwndQuickStatus, WM_CLOSE, MPNULL, MPNULL);
                }
            }
        break; }

        case XOM_NEXTQUICKOPEN: {
            PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
            XFolder *pQuick = (XFolder*)mp1;

            if (pQuick) {
                ulQuickOpenNow++;

                if (pGlobalSettings->ShowStartupProgress) {
                    WinSendMsg(WinWindowFromID(hwndQuickStatus, ID_SDDI_PROGRESSBAR),
                        WM_UPDATEPROGRESSBAR,
                        (MPARAM)(ulQuickOpenNow*100),
                        (MPARAM)(ulQuickOpenMax*100));
                }

                // get next quick-open folder
                pQuick = _xfclsQueryQuickOpenFolder(_XFolder, pQuick);
                if (pQuick) {
                    cmnPostObjectMsg(XOM_BEGINQUICKOPEN,
                            (pQuick != NULL)
                                    ? (MPARAM)pQuick
                                    : (MPARAM)-1,
                            MPNULL);
                    break;
                }
            }

            // error or cancelled:
            if (pGlobalSettings->ShowStartupProgress)
                WinPostMsg(hwndQuickStatus, WM_CLOSE, MPNULL, MPNULL);
        break; }

        /*
         * XOM_ACTIVATESTATUSBAR:
         *      add / remove /repaint the folder status bar;
         *      this may be posted from threads other than the
         *      Workplace thread, because playing with frame controls
         *      from other threads will cause PM hangs.
         *      Parameters:
         *      ULONG mp1   0: disable status bar
         *                  1: enable status bar
         *                  2: update status bar
         *      HWND  mp2:  hwndView (frame) to update
         */

        case XOM_ACTIVATESTATUSBAR:
            #ifdef DEBUG_STATUSBARS
                _Pmpf(( "XOM_UPDATEALLSTATUSBARS" ));
            #endif
            cmnXomActivateStatusBar(mp1, mp2);
            // this func is in xfldr.c, where the neccessary
            // structs and funcs are accessible
        break;

        /*
         * XOM_LIMITREACHED:
         *      this is posted by cmnAppendMi2List when too
         *      many menu items are in use, i.e. the user has
         *      opened a zillion folder content menus; we
         *      will display a warning dlg, which will also
         *      destroy the open menu
         */

        case XOM_LIMITREACHED: {
            if (!fLimitMsgOpen) {
                // avoid more than one dlg window
                fLimitMsgOpen = TRUE;
                cmnSetHelpPanel(ID_XFH_LIMITREACHED);
                WinDlgBox(HWND_DESKTOP,         // parent is desktop
                      HWND_DESKTOP,             // owner is desktop
                      (PFNWP)fnwpDlgGeneric,    // dialog procedure, defd. at bottom
                      NLS_MODULE,  // from resource file
                      ID_XFD_LIMITREACHED,        // dialog resource id
                      (PVOID)NULL);             // no dialog parameters
                fLimitMsgOpen = FALSE;
            }
        break; }

        /*
         * XOM_EXCEPTIONCAUGHT:
         *      this is posted from the various XFolder threads
         *      when something trapped; it is assumed that
         *      mp1 is a PSZ to an error msg allocated with
         *      malloc(), and after displaying the error,
         *      (PSZ)mp1 is freed. If mp2 != NULL, the WPS will
         *      be restarted (this is demanded by XSHutdown traps).
         */

        case XOM_EXCEPTIONCAUGHT: {
            if (mp1) {
                if (mp2) {
                    if (WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
                                  (PSZ)mp1, (PSZ)"XFolder: Exception caught",
                                  0, MB_YESNO | MB_ICONEXCLAMATION | MB_MOVEABLE)
                             == MBID_YES)
                        DosExit(EXIT_PROCESS, 0);
                } else
                    DebugBox("XFolder: Exception caught", (PSZ)mp1);
                free((PSZ)mp1);
            }
        break; }

        /*
         * XOM_QUERYXFOLDERVERSION:
         *      this msg may be send to the XFolder object
         *      window from external programs to query the
         *      XFolder version number which is currently
         *      installed. We will return:
         *          mrc = MPFROM2SHORT(major, minor)
         *      which may be broken down by the external
         *      program using the SHORT1/2FROMMP macros.
         *      To get the handle of the XFolder object
         *      window, use
         *      WinWindowFromID(HWND_OBJECT, ID_XFOLDEROBJECT).
         */

        case XOM_QUERYXFOLDERVERSION: {
            mrc = MPFROM2SHORT(XFOLDER_VERSION_MAJOR, XFOLDER_VERSION_MINOR);
            // these are defined in dlgids.h
        break; }

        /*
         * XOM_EXTERNALSHUTDOWN:
         *      this msg may be posted to the XFolder object
         *      window from external programs to initiate
         *      the eXtended shutdown. mp1 is assumed to
         *      point to a block of shared memory containing
         *      a SHUTDOWNPARAMS structure.
         */

        case XOM_EXTERNALSHUTDOWN: {
            PSHUTDOWNPARAMS psdp = (PSHUTDOWNPARAMS)mp1;
            if ((ULONG)mp2 != 1234) {
                APIRET arc = DosGetSharedMem(psdp, PAG_READ | PAG_WRITE);
                if (arc == NO_ERROR) {
                    WinPostMsg(hwndObject, XOM_EXTERNALSHUTDOWN, mp1, (MPARAM)1234);
                    mrc = (MPARAM)TRUE;
                } else {
                    DebugBox("External XShutdown call", "Error calling DosGetSharedMem.");
                    mrc = (MPARAM)FALSE;
                }
            } else {
                // second call
                cmnInitiateShutdownExt(psdp);
                DosFreeMem(psdp);
            }
        break; }

        default:
            mrc = WinDefWindowProc(hwndObject, msg, mp1, mp2);
    }
    return (mrc);
}

/*
 * fnwpSettingsObjDetails:
 *      dlg func for XFldObject "Details" page
 */

/* XFLDWINDATA:
   structure for data exchange with XFolder instance data */
typedef struct _XFOBJWINDATA
{
    SOMAny          *somSelf;
    // XFolderData     *somThis;
    // XFolderData     Backup;    // no pointer, but real data!
    CHAR            szOldID[CCHMAXPATH];
    HWND            hwndCnr;
    CHAR            szOldObjectID[256];
    BOOL            fEscPressed;
    PRECORDCORE     preccExpanded;
} XFOBJWINDATA, *PXFOBJWINDATA;

MRESULT EXPENTRY fnwpSettingsObjDetails(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    PXFOBJWINDATA   pWinData = (PXFOBJWINDATA)WinQueryWindowULong(hwndDlg, QWL_USER);
    MRESULT         mrc = FALSE;

    switch(msg)
    {
        case WM_INITDLG: {
            /* we need to initialize SOM stuff to be able to
            access instance variables later */
            PSZ     pszObjectID;
            CNRINFO CnrInfo;
            pWinData = (PXFOBJWINDATA)_wpAllocMem((SOMAny*)mp2, sizeof(XFOBJWINDATA), NULL);
            WinSetWindowPtr(hwndDlg, QWL_USER, pWinData);

            pWinData->somSelf     = (SOMAny*)mp2;
            // somThis = XFldObjectGetData(pWinData->somSelf);
            // pWinData->somThis     = somThis;

            // now backup instance data
            // pWinData->Backup = *somThis;
            pszObjectID = _wpQueryObjectID(pWinData->somSelf);
            if (pszObjectID)
                strcpy(pWinData->szOldID, pszObjectID);
            else
                strcpy(pWinData->szOldID, "");

            pWinData->hwndCnr = WinWindowFromID(hwndDlg, ID_XSDI_DTL_CNR);
            // printf("Cnr: %d\n", pWinData->hwndCnr);
            WinSendMsg(pWinData->hwndCnr, CM_QUERYCNRINFO,
                        &CnrInfo, (MPARAM)sizeof(CnrInfo));
            CnrInfo.pSortRecord = (PVOID)fnCompareName;
            CnrInfo.flWindowAttr = CV_TREE | CV_TEXT | CA_TREELINE;
            CnrInfo.cxTreeIndent = 30;
            WinSendMsg(pWinData->hwndCnr, CM_SETCNRINFO,
                    &CnrInfo,
                    (MPARAM)(CMA_PSORTRECORD | CMA_FLWINDOWATTR | CMA_CXTREEINDENT));

            WinPostMsg(hwndDlg, WM_SETTINGS2DLG, 0, 0);
            mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);
        break; }

        case WM_SETTINGS2DLG: {
            HPOINTER hptrOld = WinQueryPointer(HWND_DESKTOP);
            WinSetPointer(HWND_DESKTOP, WinQuerySysPointer(HWND_DESKTOP, SPTR_WAIT, FALSE));
            cmnObjectUsage2Cnr(pWinData->hwndCnr, pWinData->somSelf);
            WinSetPointer(HWND_DESKTOP, hptrOld);
        }   // continue, no break

        case WM_ENABLEITEMS:
        break;

        case WM_DLG2SETTINGS: {
        break; }

        /*
         * WM_TIMER:
         *      timer for tree view auto-scroll
         */

        case WM_TIMER: {
            if ( ( pWinData->preccExpanded->flRecordAttr & CRA_EXPANDED) != 0 ) {
                PRECORDCORE     preccLastChild;
                WinStopTimer(WinQueryAnchorBlock(hwndDlg),
                        hwndDlg,
                        1);
                // scroll the tree view properly
                preccLastChild = WinSendMsg(pWinData->hwndCnr,
                        CM_QUERYRECORD,
                        pWinData->preccExpanded,   // expanded PRECORDCORE from CN_EXPANDTREE
                    MPFROM2SHORT(CMA_LASTCHILD, CMA_ITEMORDER));
                if (preccLastChild) {
                    // ULONG ulrc;
                    WinCnrScrollToRecord(pWinData->hwndCnr,
                            (PRECORDCORE)preccLastChild,
                            CMA_TEXT,   // record text rectangle only
                            TRUE);      // keep parent visible
                }
            }
        }

        case WM_CONTROL:
        {
            if (SHORT1FROMMP(mp1) == ID_XSDI_DTL_CNR)
                switch (SHORT2FROMMP(mp1)) {

                    case CN_EXPANDTREE: {
                        PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
                        mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);
                        if (pGlobalSettings->TreeViewAutoScroll) {
                            pWinData->preccExpanded = (PRECORDCORE)mp2;
                            WinStartTimer(WinQueryAnchorBlock(hwndDlg),
                                    hwndDlg,
                                    1,
                                    100);
                        }
                    break; }

                    case CN_BEGINEDIT: {
                        pWinData->fEscPressed = TRUE;
                        mrc = (MPARAM)0;
                    break;}

                    case CN_REALLOCPSZ: {
                        PCNREDITDATA pced = (PCNREDITDATA)mp2;
                        PSZ pszChanging = *(pced->ppszText);
                        strcpy(pWinData->szOldObjectID, pszChanging);
                        pWinData->fEscPressed = FALSE;
                        mrc = (MPARAM)TRUE;
                    break; }

                    case CN_ENDEDIT: {
                        if (!pWinData->fEscPressed) {
                            PCNREDITDATA pced = (PCNREDITDATA)mp2;
                            PSZ pszNew = *(pced->ppszText);
                            BOOL fChange = FALSE;
                            if (strcmp(pWinData->szOldObjectID, pszNew) != 0) {
                                if (    (pszNew[0] != '<')
                                     || (*(pszNew + strlen(pszNew)-1) != '>')
                                   )
                                    cmnMessageBoxMsg(hwndDlg, 108, 108, MB_OK);
                                else
                                    if (cmnMessageBoxMsg(hwndDlg, 107, 109, MB_YESNO) == MBID_YES)
                                        fChange = TRUE;

                                if (fChange) {
                                    _wpSetObjectID(pWinData->somSelf, pszNew);
                                } else {
                                    strcpy(((POBJECTUSAGERECORDCORE)(pced->pRecord))->szText,
                                            pWinData->szOldObjectID);
                                    WinSendMsg(pWinData->hwndCnr, CM_INVALIDATERECORD,
                                        (MPARAM)pced->pRecord,
                                        MPFROM2SHORT(1, CMA_TEXTCHANGED));
                                }
                            }
                        }
                        mrc = (MPARAM)0;
                    break; }

                    default:
                        mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);
                    } // end switch
            else
                mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);
        break; } // end of WM_CONTROL

        case WM_COMMAND: {
            switch (SHORT1FROMMP(mp1)) {
                case DID_REFRESH: { // "Refresh" button
                    HPOINTER hptrOld = WinQueryPointer(HWND_DESKTOP);
                    WinSetPointer(HWND_DESKTOP, WinQuerySysPointer(HWND_DESKTOP, SPTR_WAIT, FALSE));
                    WinSendMsg(pWinData->hwndCnr,
                            CM_REMOVERECORD,
                            NULL,
                            MPFROM2SHORT(0, // remove all reccs
                                    CMA_FREE));
                    cmnObjectUsage2Cnr(pWinData->hwndCnr, pWinData->somSelf);
                    WinSetPointer(HWND_DESKTOP, hptrOld);
                break; }
            }
        break; } // end of WM_COMMAND

        case WM_HELP: {
            PSZ pszHelpLibrary = cmnQueryHelpLibrary();
            // always display help for the whole page, not for single items
            if (!_wpDisplayHelp(pWinData->somSelf,
                    ID_XSH_SETTINGS_OBJINTERNALS,
                    pszHelpLibrary))
            {
                cmnMessageBoxMsg(HWND_DESKTOP, 104, 134, MB_OK);
            }
        break; }

        default:
            mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);
    }

    return (mrc);
}

/********************************************************************
 *                                                                  *
 *   here come the XFldObject instance methods                      *
 *                                                                  *
 ********************************************************************/

/*
 * xfResidesBelow:
 *                  returns TRUE if pChild resides either in
 *                  or somewhere below the folder hierarchy
 *                  of pFolder
 */

SOM_Scope BOOL SOMLINK xfobj_xfResidesBelow(XFldObject *somSelf, WPFolder *pFolder)
{
    BOOL        rc = FALSE;
    WPObject    *pObj;
    if ( (pFolder) && (somSelf))
    {
        pObj = somSelf;
        while (pObj)
        {
            if (pFolder == pObj)
            {
                rc = TRUE;
                break;
            }
            else
                pObj = _wpQueryFolder(pObj);
        }
    }
    return (rc);
}

/*
 * xfQueryLogicalDriveNumber:
 *           as opposed to wpQueryDisk, of which I really don't
 *           know what it returns, this returns the logical drive
 *           number (1 = A, 2 = B, etc.) on which the WPObject
 *           resides. This works also for objects which are not
 *           file-system based; for these, their folder is examined
 *           instead.
 */

SOM_Scope ULONG  SOMLINK xfobj_xfQueryLogicalDriveNumber(XFldObject *somSelf)
{
    WPFileSystem    *pFSObj = NULL;
    /* XFldObjectData *somThis = XFldObjectGetData(somSelf); */
    XFldObjectMethodDebug("XFldObject","xfobj_xfQueryLogicalDriveNumber");

    if (somSelf) {
        CHAR        szRealName[CCHMAXPATH];
        ULONG       ulSize = sizeof(szRealName)-1;
        ULONG       ulDrive;
        // FSALLOCATE  fsa;

        if (!_somIsA(somSelf, _WPFileSystem))
            pFSObj = _wpQueryFolder(somSelf);
        else
            pFSObj = somSelf;

        _wpQueryRealName(pFSObj, szRealName, &ulSize, TRUE);
        ulDrive = (szRealName[0] - 'A' + 1); // = 1 for "A", 2 for "B" etc.
        return (ulDrive);
    } else
        return (0);
}

/*
 * xfCreateFromTemplate:
 *                  enhanced wpCreateFromTemplate, which can automatically
 *                  make the title of the new object editable; this is NOT
 *                  a replacement of wpCreateFromTemplate, but only used
 *                  when XFolder creates objects.
 *                  Arguments:
 *                    *pFolder         the folder to create the new object in;
 *                    hwndFrame        the frame wnd handle from which mthd was called
 *                    usOpenSettings   0: do nothing after creation
 *                                     1: open settings notebook
 *                                     2: make title editable
 *                    *pptlMenuMousePos for Icon views: position to create objects at,
 *                                      may be NULL
 */

SOM_Scope WPObject*  SOMLINK xfobj_xfCreateFromTemplate(XFldObject *somSelf,
                                                        WPFolder* pFolder,
                                                        HWND hwndFrame,
                                                        USHORT usOpenSettings,
                                                        POINTL* pptlMenuMousePos)
{
    HPOINTER            hptrOld;
    WPObject            *pNewObject = NULL;
    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();

    // change the mouse pointer to "wait" state
    hptrOld = WinQueryPointer(HWND_DESKTOP);
    WinSetPointer(HWND_DESKTOP, WinQuerySysPointer(HWND_DESKTOP, SPTR_WAIT, FALSE));

    if ((pFolder) && (somSelf) && (hwndFrame))
    {
        CNRINFO         CnrInfo;
        BOOL            fIconPos = FALSE;
        // POINTL          ptlOldIconPos;
        HWND            hwndCnr = WinQueryCnrFromFrame(hwndFrame);

        WinQueryCnrInfo(hwndCnr, CnrInfo);

        // position newly created object in window?
        if ((hwndCnr) && (pGlobalSettings->TplPosition) && (pptlMenuMousePos)) {
            // printf("CnrInfo.flWindowAttr & CV_ICON: %lX\n", CnrInfo.flWindowAttr & CV_ICON);
            // printf("CnrInfo.flWindowAttr & CV_TREE: %lX\n", CnrInfo.flWindowAttr & CV_TREE);
            if (    ((CnrInfo.flWindowAttr & (CV_ICON | CV_TREE)) == CV_ICON)
                &&  (pptlMenuMousePos)
               )
            {
                // position new object in folder Icon view (not cnr name views)
                SWP swp;
                HWND hwndFrame2 = cmnQueryFrameFromView(pFolder, OPEN_CONTENTS);

                // the passed mouse coords are relative to screen,
                // so subtract frame wnd coords
                WinQueryWindowPos(hwndFrame2, &swp);
                pptlMenuMousePos->x -= swp.x;
                pptlMenuMousePos->y -= swp.y;
                // printf("hwndFrame2: %lX, swp x, y: %d, %d\n", hwndFrame2, swp.x, swp.y);

                // subtract cnr coords also
                WinQueryWindowPos(hwndCnr, &swp);
                pptlMenuMousePos->x -= swp.x;
                pptlMenuMousePos->y -= swp.y;
                // printf("hwndCnr: %lX, swp x, y: %d, %d\n", hwndCnr, swp.x, swp.y);

                // add cnr work area offset
                pptlMenuMousePos->x += CnrInfo.ptlOrigin.x;
                pptlMenuMousePos->y += CnrInfo.ptlOrigin.y;
                // printf("ptlOrigin.x, y: %d, %d\n", CnrInfo.ptlOrigin.x, CnrInfo.ptlOrigin.y);

                /* ptlOldIconPos = *(_wpQueryNextIconPos(pFolder)); */
                /* DosBeep(1000, 100);
                _wpSetNextIconPos(pFolder, pptlMenuMousePos);
                printf("pptlMenuMousePos x, y: %d, %d\n", pptlMenuMousePos.x, pptlMenuMousePos.y); */
                fIconPos = TRUE;
            }
        }

        // now create object from template
        pNewObject = _wpCreateFromTemplate(
                somSelf,     // template
                pFolder,     // folder to create object in
                FALSE);      // don't keep new object awake; it will be made
                             // dormant when the folder is closed (WPSREF says)

        // move new object to mouse pos, if allowed
        if ((fIconPos) && (pptlMenuMousePos))
        {
            // _wpSetNextIconPos(pFolder, &ptlOldIconPos);
            _wpCnrRemoveObject(pNewObject, hwndCnr);
            _wpCnrInsertObject(pNewObject, hwndCnr, pptlMenuMousePos, NULL, NULL);
        }

        // scroll cnr work area to make the new object visible
        if (hwndCnr)
            WinCnrScrollToRecord(hwndCnr,
                (PRECORDCORE)_wpQueryCoreRecord(pNewObject),
                CMA_TEXT,
                FALSE);

        /* the object is now created; depending on the
           Global settings, we will now either open
           the settings notebook of it or make its title
           editable */

        if (usOpenSettings == 1)
        {
            // open settings of the newly created object
            _wpViewObject(pNewObject,
                NULLHANDLE,
                OPEN_SETTINGS,
                0L);
        }
        else if (usOpenSettings == 2)
        {
            // make the title of the newly created object
            // editable (container "direct editing"), if
            // the settings allow it and the folder is open
            CNREDITDATA     CnrEditData;
            PFIELDINFO      pFieldInfo;

            if (hwndCnr)
            {
                // first check if the folder window whose
                // context menu was used is in Details view
                // or other
                if (CnrInfo.flWindowAttr & CV_DETAIL)
                {
                    // Details view: now, this is wicked; we
                    // need to find out the "Title" column of
                    // the container which we need to pass to
                    // the container for enabling direct editing
                    pFieldInfo = (PFIELDINFO)WinSendMsg(
                        hwndCnr,
                        CM_QUERYDETAILFIELDINFO,
                        MPNULL,
                        (MPARAM)CMA_FIRST);

                    // pFieldInfo now points to the first Details
                    // column; now we go through all the Details
                    // columns until we find one which is not
                    // read-only (which should be the title); we
                    // cannot assume "column two" or anything like
                    // this, because this folder might have
                    // Details settings which are different from
                    // the defaults
                    while ((pFieldInfo) && ((LONG)pFieldInfo != -1))
                    {
                        if (pFieldInfo->flData & CFA_FIREADONLY)
                            break; // while

                        // else get next column
                        pFieldInfo = (PFIELDINFO)WinSendMsg(
                            hwndCnr,
                            CM_QUERYDETAILFIELDINFO,
                            pFieldInfo,
                            (MPARAM)CMA_NEXT);
                    }

                    // in Details view, direct editing needs the
                    // column info plus a fixed constant
                    CnrEditData.pFieldInfo = pFieldInfo;
                    CnrEditData.id = CID_LEFTDVWND;
                }
                else {
                    // other than Details view: that's easy,
                    // we only need the container ID
                    CnrEditData.pFieldInfo = NULL;
                    CnrEditData.id = WinQueryWindowUShort(hwndCnr, QWS_ID);
                }

                CnrEditData.cb = sizeof(CnrEditData);
                CnrEditData.hwndCnr = hwndCnr;
                // pass the MINIRECORDCORE of the new object
                CnrEditData.pRecord = (PRECORDCORE)_wpQueryCoreRecord(pNewObject);
                // use existing (template default) title
                CnrEditData.ppszText = NULL;
                CnrEditData.cbText = 0;

                // finally, this message switches to
                // direct editing of the title
                WinPostMsg(hwndCnr,
                    CM_OPENEDIT,
                    (MPARAM)&CnrEditData,
                    MPNULL);
            } // end if (hwndCnr)
        } // end else if (usOpenSettings == 2)
    } // end if ((pFolder) && (somSelf))

    // after all this, reset the mouse pointer
    WinSetPointer(HWND_DESKTOP, hptrOld);
    return (pNewObject);
}

/*
 * xfAddObjectInternalsPage:
 *           this actually adds the "Internals" pages into all object notebooks,
 *           if the Global Settings allow it
 */

SOM_Scope ULONG  SOMLINK xfobj_xfAddObjectInternalsPage(XFldObject *somSelf,
                                                            HWND hwndNotebook)
{
    PAGEINFO pi;
    PSZ pszHelpLibrary = cmnQueryHelpLibrary();

    /* XFldObjectData *somThis = XFldObjectGetData(somSelf); */
    XFldObjectMethodDebug("XFldObject","xfobj_xfAddObjectInternalsPages");

    // insert Shutdown settings page
    memset((PCH)&pi, 0, sizeof(PAGEINFO));
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpSettingsObjDetails;
    pi.resid               = NLS_MODULE;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_OBJECTDETAILS;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MAJOR;   // major tab;
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = 0; // don't enumerate in status line
    pi.pszName             = cmnQueryNLSStrings()->pszInternals;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS_OBJINTERNALS;

    return (_wpInsertSettingsPage(somSelf, hwndNotebook, &pi));
}

/*
 * xfTranslateStatusBarMnemonics:
 *           this method is called on an object to retrieve
 *           the "single-object" status bar info. pszText
 *           originally contains the (class-specific) mnemonic
 *           string returned by xfclsQueryStatusBarMnemonics.
 *           As opposed to the other mnemonics funcs, this is
 *           an _instance_ method because some translation
 *           might already be performed depending on the
 *           selected object.
 */

SOM_Scope ULONG  SOMLINK xfobj_xfTranslateStatusBarMnemonics(XFldObject *somSelf,
                                                             PSZ pszText,
                                                             ULONG cbText)

/* single-object status bar text mnemonics understood by XFldObject:

     $t      object title
     $w      WPS class default title (e.g. "Data file")
     $W      WPS class name (e.g. WPDataFile)
 */

{
    CHAR        // szSizeSelected[20] = "0",
                // szThousand[10],
                szTemp[300];
    BOOL        fCont = TRUE;
    PSZ         p;

    /* XFldObjectData *somThis = XFldObjectGetData(somSelf); */
    XFldObjectMethodDebug("XFldObject","xfobj_xfTranslateStatusBarMnemonics");

    do {
        strcpy(szTemp, "?");
        fCont = FALSE;

        if (p = strstr(pszText, "$t"))          // object title
        {
            if (somSelf)
                strcpy(szTemp, _wpQueryTitle(somSelf));
            strBeautifyTitle(szTemp);
            strrpl(pszText, "$t", szTemp);
            fCont = TRUE;
        }
        else if (p = strstr(pszText, "$w"))     // class default title
        {
            if (somSelf) {
                SOMClass *Metaclass = _somGetClass(somSelf);
                if (Metaclass)
                    strrpl(pszText, "$w", _wpclsQueryTitle(Metaclass));
            }
            else strrpl(pszText, "$w", "?");
            fCont = TRUE;
        }
        else if (p = strstr(pszText, "$W"))     // class name
        {
            if (somSelf)
                strrpl(pszText, "$W", _somGetClassName(somSelf));
            else strrpl(pszText, "$W", "?");
            fCont = TRUE;
        }
    } while (fCont);

    return (1);
}

/*
 * wpFilterPopupMenu:
 *           remove default entries according to global settings
 */

SOM_Scope ULONG  SOMLINK xfobj_wpFilterPopupMenu(XFldObject *somSelf,
                                                   ULONG ulFlags,
                                                   HWND hwndCnr,
                                                   BOOL fMultiSelect)
{
    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
    XFldObjectData *somThis = XFldObjectGetData(somSelf);
    XFldObjectMethodDebug("XFldObject","xfobj_wpFilterPopupMenu");

    // store original return value in instance data,
    // because we need it later in wpModifyPopupMenu
    _ulMenuFilter = XFldObject_parent_WPObject_wpFilterPopupMenu(somSelf,
                                                         ulFlags,
                                                         hwndCnr,
                                                         fMultiSelect);
    // now suppress default menu items according to
    // Global Settings;
    // the DefaultMenuItems field in pGlobalSettings is
    // ready-made for this function; the "System" object
    // page for removing menu items sets this field with
    // the proper CTXT_xxx flags
    return (_ulMenuFilter
            & ~(    pGlobalSettings->DefaultMenuItems
                 |  ( (pGlobalSettings->ExtendSettings) ? CTXT_SETTINGS : 0)
               )
        );
}

/*
 * wpModifyPopupMenu:
 *           add my own popup menu entries
 */

SOM_Scope BOOL  SOMLINK xfobj_wpModifyPopupMenu(XFldObject *somSelf,
                                                  HWND hwndMenu,
                                                  HWND hwndCnr,
                                                  ULONG iPosition)
{
    HWND        hwndSettingsMenu;
    BOOL        rc;
    MENUITEM    mi;
    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
    PNLSSTRINGS pNLSStrings = cmnQueryNLSStrings();
    XFldObjectData *somThis = XFldObjectGetData(somSelf);
    XFldObjectMethodDebug("XFldObject","xfobj_wpModifyPopupMenu");

    // load resources
    // NLS_MODULE;

    rc = (XFldObject_parent_WPObject_wpModifyPopupMenu(somSelf,
                                                         hwndMenu,
                                                         hwndCnr,
                                                         iPosition));
    if (pGlobalSettings->RemoveLockInPlace) {
        // first we need a handle to the WPObject's "Lock in place"
        // submenu in the the folder's popup menu

        WinSendMsg(hwndMenu, MM_REMOVEITEM,
            MPFROM2SHORT(ID_WPM_LOCKINPLACE, FALSE),
            0);
    }

    // extend "Settings" submenu:
    // are settings supposed to be inserted at all?
    if (_ulMenuFilter & CTXT_SETTINGS) {      // rc of wpFilterPopupMenu
        if (pGlobalSettings->ExtendSettings)
        {
            ULONG ulStyle;
            hwndSettingsMenu = WinCreateMenu(hwndMenu, NULL);
            if (hwndSettingsMenu)
            {
                WinSetWindowUShort(hwndSettingsMenu, QWS_ID,
                        (pGlobalSettings->VarMenuOffset + ID_XFM_OFS_SETTINGS));

                // create "Notebook" item
                mi.iPosition = 0;
                mi.afStyle = MIS_TEXT;
                mi.afAttribute = 0;
                mi.id = 0x70;       // "Settings" ID
                mi.hwndSubMenu = 0;
                mi.hItem = 0;
                WinSendMsg(hwndSettingsMenu, MM_INSERTITEM, (MPARAM)&mi,
                        (MPARAM)pNLSStrings->pszSettingsNotebook);
            }

            if (_xfModifySettingsSubmenu(somSelf, hwndSettingsMenu, hwndCnr)) {
                // items were added for somSelf:
                // remove default "Settings" item
                WinSendMsg(hwndMenu, MM_REMOVEITEM,
                    MPFROM2SHORT(0x70,       // "Settings" ID
                        FALSE),
                    0);

                // now insert new "Settings" submenu into
                // main context menu
                mi.iPosition = 1;
                mi.afStyle = MIS_SUBMENU;
                mi.afAttribute = 0;
                mi.id = (pGlobalSettings->VarMenuOffset + ID_XFM_OFS_SETTINGS);
                mi.hwndSubMenu = hwndSettingsMenu;
                mi.hItem = 0;
                WinSendMsg(hwndMenu, MM_INSERTITEM, (MPARAM)&mi,
                        (MPARAM)pNLSStrings->pszSettings);

                ulStyle = WinQueryWindowULong(hwndSettingsMenu, QWL_STYLE);
                ulStyle |= MS_CONDITIONALCASCADE;
                WinSetWindowULong(hwndSettingsMenu, QWL_STYLE, ulStyle);

                // make the first item in the subfolder
                // the default of cascading submenu */
                WinSendMsg(hwndSettingsMenu,
                        MM_SETDEFAULTITEMID,
                        (MPARAM)(0x70), 0L);
            } else {
                // no submenu items inserted: insert regular
                // "Settings" item, because we suppressed it in
                // wpFilterPopupMenu
                WinInsertMenuItem(hwndMenu, 1,
                            0x70, pNLSStrings->pszSettings,
                            MIS_TEXT, 0);
            }
        }
    }

    #ifdef DEBUG_CONTEXT
        _wpInsertPopupMenuItems(somSelf, hwndMenu, 0,
            _xfclsQueryModuleHandle(_XFldObject), ID_XFM_DEBUG, 0);
    #endif

    return rc;
}

/*
 * xfSelectingMenuItem:
 *           this new method is called on an object even before
 *           wpMenuItemSelected is called, i.e. right after a
 *           menu item has been selected by the user, and before
 *           the menu is dismissed.
 *           This call is the result
 *           of a WM_MENUSELECT intercept of the subclassed frame
 *           window procedure of an open folder. An object may
 *           intercept certain menu selections in order to process
 *           them without the menu being dismissed afterwards.
 *           Parameters:
 *              usItem        selected menu item
 *              fPostCommand  if this flag is TRUE, wpMenuItemSelected
 *                            will be called afterwards (do not modify)
 *              hwndMenu      wnd handle of the current menu control
 *              hwndCnr       wnd handle of the current container
 *              ulSelection   one of the following:
 *                    SEL_WHITESPACE the context menu was opened on the
 *                                   whitespace in an open container view
 *                                   of somSelf (which is a folder then)
 *                    SEL_SINGLESEL  the context menu was opened for a
 *                                   single selected object: somSelf can
 *                                   be any object then, including folders
 *                    SEL_MULTISEL   the context menu was opened on one
 *                                   of a multitude of selected objects;
 *                                   again, somSelf can be any object
 *                    SEL_SINGLEOTHER the context menu was opened for a
 *                                   single object _other_ than the selected
 *                                   objects
 *
 *           You must return one of the following:
 *              TRUE          dismiss the menu and, if (fPostCommand),
 *                            call wpMenuItemSelected
 *              FALSE         do not dismiss the menu and do not call
 *                            wpMenuItemSelected
 *           For menu items which have no meaning for this instance method,
 *           the return value of the parent method must be returned.
 */

SOM_Scope BOOL  SOMLINK xfobj_xfSelectingMenuItem(XFldObject *somSelf,
                                                  USHORT usItem,
                                                  BOOL fPostCommand,
                                                  HWND hwndMenu,
                                                  HWND hwndCnr,
                                                  ULONG ulSelection)
{
    // XFldObjectData *somThis = XFldObjectGetData(somSelf);
    XFldObjectMethodDebug("XFldObject","xfobj_xfSelectingMenuItem");

    return (TRUE);
}

/*
 * xfModifySettingsSubmenu:
 *           this new method is called from XFldObject's override
 *           of wpModifyPopupMenu every time a context menu is
 *           about to be opened. In this method, WPS classes may
 *           add new items to the new "Settings" submenu, whose
 *           wnd handle is passed to this method in
 *           hwndSettingsSubmenu. This method must return TRUE if
 *           any items were added, or FALSE otherwise.
 */

SOM_Scope BOOL  SOMLINK xfobj_xfModifySettingsSubmenu(XFldObject *somSelf,
                                                      HWND hwndSettingsSubmenu,
                                                      HWND hwndCnr)
{
    // XFldObjectData *somThis = XFldObjectGetData(somSelf);
    XFldObjectMethodDebug("XFldObject","xfobj_xfModifySettingsSubmenu");

    // this is the base method, so we return FALSE
    return (FALSE);
}

/*
 * wpMenuItemSelected:
 *           process input when any menu item was selected
 */

SOM_Scope BOOL  SOMLINK xfobj_wpMenuItemSelected(XFldObject *somSelf,
                                                   HWND hwndFrame,
                                                   ULONG ulMenuId)
{
    PGLOBALSETTINGS     pGlobalSettings = cmnQueryGlobalSettings();
    BOOL                brc = FALSE;

    // XFldObjectData *somThis = XFldObjectGetData(somSelf);
    XFldObjectMethodDebug("XFldObject","xfobj_wpMenuItemSelected");

    switch (ulMenuId) {
        #ifdef DEBUG_CONTEXT
        case ID_XFMI_RECORDCORE: {
            int                 i;
            CHAR                szMsg[1024] = "No record core.",
                                szTitle[1024],
                                szBuf[20] = "0x00000000";
            PMINIRECORDCORE     pMRC = _wpQueryCoreRecord(somSelf);
            PCLASSFIELDINFO     pCFI, pCFI2;
            ULONG               ulCFISize = 0, ulErr;

            strcpy(szTitle, "Record core for ");
            strcat(szTitle, _wpQueryTitle(somSelf));

            strcpy(szMsg, "Size of core record (cb): ");
            UL2H(szBuf+2, pMRC->cb);
            strcat(szMsg, szBuf);

            strcat(szMsg, "\nSize of MINIRECORDCORE:   ");
            UL2H(szBuf+2, sizeof(MINIRECORDCORE));
            strcat(szMsg, szBuf);

            strcat(szMsg, "\nSize of RECORDCORE:       ");
            UL2H(szBuf+2, sizeof(RECORDCORE));
            strcat(szMsg, szBuf);

            strcat(szMsg, "\nNext record:              ");
            UL2H(szBuf+2, (ULONG)pMRC->preccNextRecord);
            strcat(szMsg, szBuf);

            strcat(szMsg, "\nIcon X pos:               ");
            UL2H(szBuf+2, pMRC->ptlIcon.x);
            strcat(szMsg, szBuf);

            strcat(szMsg, "\nIcon Y pos:               ");
            UL2H(szBuf+2, pMRC->ptlIcon.y);
            strcat(szMsg, szBuf);

            strcat(szMsg, "\n\nDetails CLASSFIELDINFO:");

            strcat(szMsg, "\nSize of structure:        ");
            _wpQueryDetailsData(somSelf, NULL, &ulCFISize);
            UL2H(szBuf+2, ulCFISize);
            strcat(szMsg, szBuf);

            pCFI = (PCLASSFIELDINFO)_wpAllocMem(somSelf, ulCFISize, &ulErr);
            pCFI2 = pCFI;
            _wpQueryDetailsData(somSelf, (PVOID)&pCFI2, &ulCFISize);

            _wpFreeMem(somSelf, (PVOID)pCFI);

            DebugBox(szTitle, szMsg);

            brc = TRUE;
        break; }

        case ID_XFMI_SHOWFOLDERDATA: {
            cmnPostWorkerMsg(WM_SHOWFOLDERDATA,
                (MPARAM)somSelf,
                MPNULL);
            brc = TRUE;
        break; }
        #endif

        default:
            brc = XFldObject_parent_WPObject_wpMenuItemSelected(somSelf,
                                                          hwndFrame,
                                                          ulMenuId);
    }

    return (brc);
}

/*
 * wpAddSettingsPages:
 *           this instance method inserts all the settings
 *           pages into an object's settings notebook.
 *           We will add the object's "Internals" page here.
 */

SOM_Scope BOOL  SOMLINK xfobj_wpAddSettingsPages(XFldObject *somSelf,
                                                 HWND hwndNotebook)
{
    PGLOBALSETTINGS     pGlobalSettings = cmnQueryGlobalSettings();
    // XFldObjectData *somThis = XFldObjectGetData(somSelf);
    XFldObjectMethodDebug("XFldObject","xfobj_wpAddSettingsPages");

    if (pGlobalSettings->ShowInternals)
        _xfAddObjectInternalsPage(somSelf, hwndNotebook);

    return (XFldObject_parent_WPObject_wpAddSettingsPages(somSelf,
                                                          hwndNotebook));
}

/*
 * fnwpTitleClashDlg:
 *      dlg proc for the "Title Clash" dialog
 *      (see wpConfirmObjectTitle below)
 */

MRESULT EXPENTRY fnwpTitleClashDlg(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    #define WM_DELAYEDFOCUS WM_USER+1
    MRESULT mrc = (MRESULT)0;

    switch (msg) {
        case WM_CONTROL: {
            switch (SHORT2FROMMP(mp1)) { // usNotifyCode
                case EN_SETFOCUS: {
                // == BN_CLICKED
                    if (SHORT1FROMMP(mp1) == ID_XFDI_CLASH_RENAMENEWTXT) {
                        WinSetDlgItemChecked(hwndDlg, ID_XFDI_CLASH_RENAMENEW, TRUE);
                    } else if (SHORT1FROMMP(mp1) == ID_XFDI_CLASH_RENAMEOLDTXT) {
                        WinSetDlgItemChecked(hwndDlg, ID_XFDI_CLASH_RENAMEOLD, TRUE);
                    } else if (SHORT1FROMMP(mp1) == ID_XFDI_CLASH_RENAMENEW) {
                        WinPostMsg(hwndDlg, WM_DELAYEDFOCUS,
                            (MPARAM)ID_XFDI_CLASH_RENAMENEWTXT, MPNULL);
                    } else if (SHORT1FROMMP(mp1) == ID_XFDI_CLASH_RENAMEOLD) {
                        WinPostMsg(hwndDlg, WM_DELAYEDFOCUS,
                            (MPARAM)ID_XFDI_CLASH_RENAMEOLDTXT, MPNULL);
                    }
                }
            }
        break; }

        case WM_DELAYEDFOCUS: {
            WinSetDlgItemFocus(hwndDlg, (HWND)mp1);
        break; }

        case WM_COMMAND: {
            mrc = (MRESULT)0;
            switch ((ULONG)mp1) {
                case DID_OK: {
                    ULONG ulSelection = DID_CANCEL,
                          ulLastFocusID = 0;
                    CHAR szLastFocusID[20] = "";
                    if (WinIsDlgItemChecked(hwndDlg, ID_XFDI_CLASH_RENAMENEW)) {
                        ulSelection = ID_XFDI_CLASH_RENAMENEW;
                        ulLastFocusID = ID_XFDI_CLASH_RENAMENEWTXT;
                    } else if (WinIsDlgItemChecked(hwndDlg, ID_XFDI_CLASH_RENAMEOLD)) {
                        ulSelection = ID_XFDI_CLASH_RENAMEOLD;
                        ulLastFocusID = ID_XFDI_CLASH_RENAMEOLDTXT;
                    } else {
                        ulSelection = ID_XFDI_CLASH_REPLACE;
                        ulLastFocusID = ID_XFDI_CLASH_REPLACE;
                    }

                    // store focus
                    sprintf(szLastFocusID, "%d",
                            ulLastFocusID);
                    PrfWriteProfileString(HINI_USER, INIAPP,
                                INIKEY_NAMECLASHFOCUS,
                                szLastFocusID);
                    // store window pos
                    WinStoreWindowPos(INIAPP, INIKEY_NAMECLASHWNDPOS, hwndDlg);
                    WinDismissDlg(hwndDlg, ulSelection);
                break; }

                case DID_CANCEL:
                    WinDismissDlg(hwndDlg, DID_CANCEL);
                break;
            }
        break; }

        case WM_HELP: {
            WPObject    *pHelpSomSelf = _wpclsQueryActiveDesktop(_WPDesktop);
            if (pHelpSomSelf) {
                PSZ pszHelpLibrary;
                BOOL fProcessed = FALSE;
                if (pszHelpLibrary = cmnQueryHelpLibrary())
                    // path found: display help panel
                    if (_wpDisplayHelp(pHelpSomSelf, ID_XFH_TITLECLASH, pszHelpLibrary))
                        fProcessed = TRUE;

                if (!fProcessed)
                    cmnMessageBoxMsg(HWND_DESKTOP, 104, 134, MB_OK);
            }
        break; }

        default:
            mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);
    }

    return (mrc);
}

/*
 * cmnIsFAT:
 *      returns TRUE if pszFileName resides on
 *      a FAT drive
 */

BOOL cmnIsFAT(PSZ pszFileName)
{
    BOOL brc = FALSE;
    CHAR szName[5];

    szName[0] = pszFileName[0];
    szName[1] = ':';
    szName[2] = '\0';

    #ifdef DEBUG_TITLECLASH
        _Pmpf(("cmnIsFAT for %s -> %s", pszFileName, szName));
    #endif
    {
        ULONG  ulOrdinal       = 0;     // ordinal of entry in name list
        // PBYTE  pszFSDName      = NULL;  // pointer to FS name
        // PBYTE  prgFSAData      = NULL;  // pointer to FS data
        APIRET rc              = NO_ERROR; // return code
        BYTE   fsqBuffer[sizeof(FSQBUFFER2) + (3 * CCHMAXPATH)] = {0};
        ULONG  cbBuffer   = sizeof(fsqBuffer);        // Buffer length)
        PFSQBUFFER2 pfsqBuffer = (PFSQBUFFER2)fsqBuffer;

        rc = DosQueryFSAttach(
                        szName,          // logical drive of attached FS
                        ulOrdinal,       // ignored for FSAIL_QUERYNAME
                        FSAIL_QUERYNAME, // return data for a Drive or Device
                        pfsqBuffer,      // returned data
                        &cbBuffer);      // returned data length

        if (rc == NO_ERROR)
        {
            // The data for the last three fields in the FSQBUFFER2
            // structure are stored at the offset of fsqBuffer.szName.
            // Each data field following fsqBuffer.szName begins
            // immediately after the previous item.
            PSZ pszFSDName = pfsqBuffer->szName + pfsqBuffer->cbName + 1;
            #ifdef DEBUG_TITLECLASH
                _Pmpf(("  cmnIsFAT -> File system: %s", pszFSDName));
            #endif
            if (strncmp(pszFSDName, "FAT", 3) == 0)
                brc = TRUE;
        }
    }
    return (brc);
}

/*
 * strMakeRealName:
 *      this copies pszSource to pszTarget, replacing
 *      all characters which are not supported by file
 *      systems with cReplace.
 *      pszTarget must be at least the same size as pszSource.
 *      If (fIsFAT), the file name will be made FAT-compliant (8+3).
 *      Returns TRUE if characters were replaced.
 */

BOOL strMakeRealName(PSZ pszTarget, PSZ pszSource, CHAR cReplace, BOOL fIsFAT)
{
    ULONG ul,
          cbSource = strlen(pszSource);
    LONG  lDotOfs = -1,
          lAfterDot = -1;
    BOOL  brc = FALSE;
    PSZ   pSource = pszSource,
          pTarget = pszTarget,
          pszInvalid = (fIsFAT)
                            ? "<>|+=:;,""/\\[] "  // invalid characters in FAT
                            : "<>|:""/\\"; // invalid characters in IFS's

    for (ul = 0; ul < cbSource; ul++) {

        if (fIsFAT) {
            // on FAT: truncate filename if neccessary
            if (*pSource == '.') {
                lDotOfs = ul;
                lAfterDot = 0;
                if (ul > 7) {
                    // only 8 characters allowed before dot,
                    // so set target ptr to dot pos
                    pTarget = pszTarget+8;
                }
            }
        }
        // and replace invalid characters
        if (strchr(pszInvalid, *pSource) == NULL)
            *pTarget = *pSource;
        else {
            *pTarget = cReplace;
            brc = TRUE;
        }
        pTarget++;
        pSource++;

        // on FAT, allow only three chars after dot
        if (lAfterDot != -1) {
            lAfterDot++;
            if (lAfterDot > 3)
                break;
        }

    }
    *pTarget = '\0';
    #ifdef DEBUG_TITLECLASH
        _Pmpf(("      strMakeRealName: returning %s", pszTarget));
    #endif

    if (fIsFAT)
        WinUpper(WinQueryAnchorBlock(HWND_DESKTOP),
            0, 0,
            pszTarget);
    return (brc);
}

/*
 * wpConfirmObjectTitle:
 *           this instance method is called by the WPS for each
 *           file operation (copy, move etc.). It must verify that
 *           the operation is valid WRT name clashs and display
 *           a confirmation dialog in case it is not.
 *           Apparently, this method is not overridden by subclasses,
 *           not even WPFileSystem.
 *           XFolder implements its own "Object exists" dialog here,
 *           if the Global Settings allow it.
 *           Parameters:
 *              *somSelf      in: the object being worked on
 *              *Folder       in: the folder being worked on
 *              **ppDuplicate out: if we return NAMECLASH_REPLACE,
 *                            we need to set this to the object to be replaced
 *              pszTitle      out: if we return NAMECLASH_RENAME,
 *                            we need to set this to somSelf's new title
 *              cbTitle       in: sizeof(*pszTitle)
 *              menuID        in: the user's operation, which is:
 *                              0x006B    move
 *                              0x006C    copy
 *                              0x006E    rename
 *                              0x013C    create shadow
 *           Returns:
 *              NAMECLASH_CANCEL    0
 *                  abort processing, have the WPS do nothing
 *              NAMECLASH_NONE      1
 *                  continue processing, but perform no further renaming etc.;
 *              NAMECLASH_RENAME    2
 *                  have the WPS change the title to pszTitle, which we need
 *                  to set here; note that this does NOT change the real name;
 *              NAMECLASH_REPLACE   8
 *                  have the WPS delete *ppDuplicate, which we need to set
 *                  here if we return this code; we need to find the duplicate
 *                  in this method then.
 */

SOM_Scope ULONG  SOMLINK xfobj_wpConfirmObjectTitle(XFldObject *somSelf,
                                                    WPFolder* Folder,
                                                    WPObject** ppDuplicate,
                                                    PSZ pszTitle,
                                                    ULONG cbTitle,
                                                    ULONG menuID)
{
    // although the docs mention these return codes, they are
    // only defined for Warp 4, so we might need to define them here:
    #ifndef NAMECLASH_CANCEL
        #define NAMECLASH_CANCEL    0
    #endif
    #ifndef NAMECLASH_NONE
        #define NAMECLASH_NONE      1
    #endif
    #ifndef NAMECLASH_RENAME
        #define NAMECLASH_RENAME    2
    #endif
    #ifndef NAMECLASH_REPLACE
        #define NAMECLASH_REPLACE   8
    #endif

    ULONG ulrc = NAMECLASH_NONE;

    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();

    // XFldObjectData *somThis = XFldObjectGetData(somSelf);
    XFldObjectMethodDebug("XFldObject","xfobj_wpConfirmObjectTitle");

    #ifdef DEBUG_TITLECLASH
    {
        CHAR szFolder2[CCHMAXPATH];
        _Pmpf(("Entering wpConfirmObjectTitle"));
        _Pmpf(("  somSelf == 0x%lX", somSelf));
        _Pmpf(("    pszTitle: %s", pszTitle));
        _wpQueryFilename(_wpQueryFolder(somSelf), szFolder2, TRUE);
        _Pmpf(("    in folder: %s", szFolder2));
        _Pmpf(("  menuID: 0x%lX", menuID));
    }
    #endif

    if (pGlobalSettings->ReplConfirms) {
        // confirmations replaced: use our own routine

        // nameclashs are only a problem for file-system objects,
        // and only if we're not creating shadows
        if (    (_somIsA(somSelf, _WPFileSystem))
             && (menuID != 0x13C) // "create shadow" code
           )
        {
            WPFileSystem *pobjExisting;
            CHAR szNewRealName[CCHMAXPATH],
                 szFolder[CCHMAXPATH];
            BOOL fFAT;

            if (Folder) {
                if (!_wpQueryFilename(Folder, szFolder, TRUE))
                    return (NAMECLASH_CANCEL);
            } else
                return (NAMECLASH_CANCEL);

            // before checking names, determine whether
            // the folder is on a FAT drive; we need this
            // flag for title-to-realname translations later
            fFAT = cmnIsFAT(szFolder);

            // now check if file already exists in pFolder
            strMakeRealName(szNewRealName,    // buffer
                            pszTitle,         // somSelf's title
                            '!',              // replace-with char
                            fFAT);
            #ifdef DEBUG_TITLECLASH
                _Pmpf(("  Checking for existence of %s", szNewRealName));
            #endif

            // does this file exist in pFolder?
            pobjExisting = _xfContainsFile(Folder, szNewRealName);
            if (pobjExisting)
            {
                #ifdef DEBUG_TITLECLASH
                    CHAR szFolder2[CCHMAXPATH];
                    _Pmpf(("  pObjExisting == 0x%lX", pobjExisting));
                    _Pmpf(("    Title: %s", _wpQueryTitle(pobjExisting) ));
                    _wpQueryFilename(_wpQueryFolder(pobjExisting), szFolder2, TRUE);
                    _Pmpf(("    in folder: %s", szFolder2));
                #endif

                // file exists: now we need to differentiate.
                // 1)   If we're copying, we need to always
                //      display the confirmation.
                // 2)   If we're renaming somSelf, we only
                //      display the confirmation if the
                //      existing object is != somSelf, because
                if  (   (menuID != 0x6E) // "rename" code
                     || (somSelf != pobjExisting)
                    )
                {
                    CHAR szTemp[600] = "",
                         szProposeTitle[CCHMAXPATH],
                         szProposeRealName[CCHMAXPATH],
                         szFileCount[20];
                    ULONG ulDlgReturn = 0;
                    ULONG ulLastFocusID = 0;
                    PSZ p, p2;
                    BOOL fReplaceValid = TRUE;
                    LONG lFileCount = -1;
                    HWND hwndConfirm;

                    // prepare file date/time etc. for
                    // display in window
                    FILEFINDBUF4 ffb4;
                    ULONG ulDateFormat =
                        PrfQueryProfileInt(HINI_USER, "PM_National", "iDate", 0);
                    ULONG ulTimeFormat =
                        PrfQueryProfileInt(HINI_USER, "PM_National", "iTime", 0);
                    CHAR szDateSep[10],
                         szTimeSep[10],
                         szThousand[10];
                    PrfQueryProfileString(HINI_USER, "PM_National", "sDate", "/",
                        szDateSep, sizeof(szDateSep)-1);
                    PrfQueryProfileString(HINI_USER, "PM_National", "sTime", ":",
                        szTimeSep, sizeof(szTimeSep)-1);
                    PrfQueryProfileString(HINI_USER, "PM_Default_National", "sThousand",
                            ",", szThousand, sizeof(szThousand)-1);

                    // load confirmation dialog
                    hwndConfirm = WinLoadDlg(HWND_DESKTOP, HWND_DESKTOP,
                                      fnwpTitleClashDlg,
                                      NLS_MODULE, ID_XFD_TITLECLASH,
                                      NULL);
                    WinQueryDlgItemText(hwndConfirm, ID_XFDI_CLASH_TXT1,
                                    sizeof(szTemp)-1, szTemp);
                    strrpl(szTemp, "%1", szNewRealName);
                    strrpl(szTemp, "%2", szFolder);
                    WinSetDlgItemText(hwndConfirm, ID_XFDI_CLASH_TXT1,
                                    szTemp);

                    // set object information fields
                    _wpQueryDateInfo(pobjExisting, &ffb4);
                    strFileDate(szTemp, &ffb4, ulDateFormat, szDateSep[0]);
                    WinSetDlgItemText(hwndConfirm, ID_XFDI_CLASH_DATEOLD,
                                    szTemp);
                    strFileTime(szTemp, &ffb4, ulTimeFormat, szTimeSep[0]);
                    WinSetDlgItemText(hwndConfirm, ID_XFDI_CLASH_TIMEOLD,
                                    szTemp);
                    strths(szTemp, (_wpQueryFileSize(pobjExisting)+512) / 1024,
                                szThousand[0]);
                    WinSetDlgItemText(hwndConfirm, ID_XFDI_CLASH_SIZEOLD,
                                    szTemp);

                    if (pobjExisting != somSelf) {
                        // if we're not copying within the same folder,
                        // give info on second object
                        _wpQueryDateInfo(somSelf, &ffb4);
                        strFileDate(szTemp, &ffb4, ulDateFormat, szDateSep[0]);
                        WinSetDlgItemText(hwndConfirm, ID_XFDI_CLASH_DATENEW,
                                        szTemp);
                        strFileTime(szTemp, &ffb4, ulTimeFormat, szTimeSep[0]);
                        WinSetDlgItemText(hwndConfirm, ID_XFDI_CLASH_TIMENEW,
                                        szTemp);
                        strths(szTemp, (_wpQueryFileSize(somSelf)+512) / 1024,
                                    szThousand[0]);
                        WinSetDlgItemText(hwndConfirm, ID_XFDI_CLASH_SIZENEW,
                                        szTemp);
                    } else {
                        // if we're copying within the same folder,
                        // set the "new object" fields empty
                        WinSetDlgItemText(hwndConfirm, ID_XFDI_CLASH_DATENEW, "");
                        WinSetDlgItemText(hwndConfirm, ID_XFDI_CLASH_TIMENEW, "");
                        WinSetDlgItemText(hwndConfirm, ID_XFDI_CLASH_SIZENEW, "");
                    }

                    // propose new name; we will use the title and
                    // add a ":num" before the extension and then
                    // transform that one into a real name and keep
                    // increasing "num" until no file with that
                    // real name exists (as the WPS does it too)
                    strcpy(szTemp, pszTitle);
                    // check if title contains a ':num' already
                    p2 = strchr(szTemp, ':');
                    if (p2) {
                        lFileCount = atoi(p2+1);
                        if (lFileCount) {
                            // if we have a valid number following ":", remove it
                            p = strchr(szTemp, '.');
                            if (p)
                                strcpy(p2, p);
                            else
                                *p2 = '\0';
                        }
                    }

                    // insert new number
                    p = strrchr(szTemp, '.');       // last dot == extension
                    lFileCount = 1;
                    do {
                        sprintf(szFileCount, ":%d", lFileCount);
                        if (p) {
                            // has extension: insert
                            ULONG ulBeforeDot = (p - szTemp);
                            if (   (fFAT)
                                && ((ulBeforeDot+strlen(szFileCount)) > 8)
                               )
                                ulBeforeDot = 8 - strlen(szFileCount);
                            strncpy(szProposeTitle, szTemp, ulBeforeDot);
                            szProposeTitle[ulBeforeDot] = '\0';
                            strcat(szProposeTitle, szFileCount);
                            strcat(szProposeTitle, p);
                        }
                        else {
                            // has no extension: append
                            strncpy(szProposeTitle, szTemp,
                                (fFAT) ? 8 : 255);
                            if (fFAT)
                                szProposeTitle[8] = '\0';
                            strcat(szProposeTitle, szFileCount);
                        }
                        lFileCount++;
                        // make real name from this title and check
                        // if that file exists; if so, try the next
                        // ":num"
                        strMakeRealName(szProposeRealName, szProposeTitle, '!',
                            // FAT filenames?
                            fFAT);
                    } while (   (_xfContainsFile(Folder, szProposeRealName))
                             && (lFileCount < 99)   // security check
                            );

                    // OK, we've found a new filename: set dlg items
                    WinSendDlgItemMsg(hwndConfirm, ID_XFDI_CLASH_RENAMENEWTXT,
                            EM_SETTEXTLIMIT,
                            (MPARAM)(250), MPNULL);
                    WinSetDlgItemText(hwndConfirm, ID_XFDI_CLASH_RENAMENEWTXT,
                            szProposeTitle);
                    WinSendDlgItemMsg(hwndConfirm, ID_XFDI_CLASH_RENAMEOLDTXT,
                            EM_SETTEXTLIMIT,
                            (MPARAM)(250), MPNULL);
                    WinSetDlgItemText(hwndConfirm, ID_XFDI_CLASH_RENAMEOLDTXT,
                            szProposeTitle);

                    // disable "Replace" and "Rename old"
                    // if we're copying within the same folder
                    if (pobjExisting == somSelf) {
                        WinEnableDlgItem(hwndConfirm, ID_XFDI_CLASH_REPLACE, FALSE);
                        WinEnableDlgItem(hwndConfirm, ID_XFDI_CLASH_RENAMEOLD, FALSE);
                        WinEnableDlgItem(hwndConfirm, ID_XFDI_CLASH_RENAMEOLDTXT, FALSE);
                        fReplaceValid = FALSE;
                    }

                    // find the selection the user has made last time;
                    // this INI key item is maintained by fnwpTitleClashDlg above
                    ulLastFocusID = PrfQueryProfileInt(HINI_USER, INIAPP,
                                        INIKEY_NAMECLASHFOCUS,
                                        ID_XFDI_CLASH_RENAMENEWTXT); // default value if not set
                    // if we have disabled some dlg items above, we might
                    // need to correct this
                    if (    (!fReplaceValid)
                         && (   (ulLastFocusID == ID_XFDI_CLASH_REPLACE)
                             || (ulLastFocusID == ID_XFDI_CLASH_RENAMEOLDTXT)
                            )
                       )
                        ulLastFocusID = ID_XFDI_CLASH_RENAMENEWTXT;
                    // set focus to that item
                    WinSetDlgItemFocus(hwndConfirm, ulLastFocusID);
                        // this will automatically select the corresponding
                        // radio button, see fnwpTitleClashDlg above

                    // go!
                    WinRestoreWindowPos(INIAPP, INIKEY_NAMECLASHWNDPOS, hwndConfirm);
                    WinShowWindow(hwndConfirm, TRUE);
                    ulDlgReturn = WinProcessDlg(hwndConfirm);

                    // check return value
                    switch (ulDlgReturn) {
                        case ID_XFDI_CLASH_RENAMENEW: {
                            // rename new: copy user's entry to buffer
                            // provided by the method
                            WinQueryDlgItemText(hwndConfirm, ID_XFDI_CLASH_RENAMENEWTXT,
                                            cbTitle-1, pszTitle);
                            ulrc = NAMECLASH_RENAME;
                        break; }

                        case ID_XFDI_CLASH_RENAMEOLD: {
                            // rename old: use wpSetTitle on existing object
                            WinQueryDlgItemText(hwndConfirm, ID_XFDI_CLASH_RENAMEOLDTXT,
                                            sizeof(szTemp)-1, szTemp);
                            _wpSetTitleAndRenameFile(pobjExisting, szTemp, 0);

                            if (menuID == 0x6E)     // "rename" code
                            {
                                CHAR szNewRealName[CCHMAXPATH];
                                strMakeRealName(szNewRealName, pszTitle, '!', TRUE);
                                _wpSetTitleAndRenameFile(somSelf, pszTitle, 0);
                            }
                            ulrc = NAMECLASH_NONE;
                        break; }

                        case ID_XFDI_CLASH_REPLACE:
                            *ppDuplicate = pobjExisting;
                            ulrc = NAMECLASH_REPLACE;
                        break;

                        case DID_CANCEL:
                            ulrc = NAMECLASH_CANCEL;
                        break;
                    }
                    WinDestroyWindow(hwndConfirm);
                } // end if  (   (menuID != 0x6E) // "rename" code
                  // || (somSelf != pobjExisting)
                  // )
            }
            else if (menuID == 0x6E)     // "rename" code
            {
                // if (!pobjExisting) and we're renaming
                CHAR szNewRealName[CCHMAXPATH];
                strMakeRealName(szNewRealName, pszTitle, '!', TRUE);
                if (_wpSetTitleAndRenameFile(somSelf, pszTitle, 0))
                    // no error:
                    ulrc = NAMECLASH_NONE;
                else
                    ulrc = NAMECLASH_CANCEL;
            }
        } // end if (_somIsA(somSelf, _WPFileSystem))
    }
    else {
        #ifdef DEBUG_TITLECLASH
            _Pmpf(("  Calling original"));
        #endif
        ulrc = XFldObject_parent_WPObject_wpConfirmObjectTitle(somSelf,
                                                            Folder,
                                                            ppDuplicate,
                                                            pszTitle,
                                                            cbTitle,
                                                            menuID);
    }

    #ifdef DEBUG_TITLECLASH
    {
        CHAR szFolder2[CCHMAXPATH];
        _Pmpf(("  Return value: %d", ulrc));
        _Pmpf(("  New somSelf == 0x%lX", somSelf));
        _Pmpf(("    New pszTitle: %s", pszTitle));
        _wpQueryFilename(_wpQueryFolder(somSelf), szFolder2, TRUE);
        _Pmpf(("    in folder: %s", szFolder2));

        if (ppDuplicate) {
            _Pmpf(("  ppDuplicate neu != NULL"));
            if (*ppDuplicate) {
                _Pmpf(("    *ppDuplicate neu == 0x%lX", *ppDuplicate));
                _Pmpf(("      Title neu: %s", _wpQueryTitle(*ppDuplicate) ));
                _wpQueryFilename(_wpQueryFolder(*ppDuplicate), szFolder2, TRUE);
                _Pmpf(("      in folder: %s", szFolder2));
            }
        }
        _Pmpf(("Done."));
    }
    #endif

    return (ulrc);
}

/*
 * wpObjectReady:
 *           this instance method is called by the system when
 *           object awakening is complete and object data seems
 *           to be stable in memory;
 *           we will have this object's pointer stored
 *           in a global list (maintained by the Worker thread)
 *           so that XShutdown knows which objects are currently awake
 */

SOM_Scope void  SOMLINK xfobj_wpObjectReady(XFldObject *somSelf,
                                              ULONG ulCode, WPObject* refObject)
{
    // XFldObjectData *somThis = XFldObjectGetData(somSelf);
    XFldObjectMethodDebug("XFldObject","xfobj_wpObjectReady");

    XFldObject_parent_WPObject_wpObjectReady(somSelf, ulCode,
                                             refObject);

    /* if (    (_somIsA(somSelf, _WPFolder))
         || (_somIsA(somSelf, _WPAbstract))
       ) */
    {
        cmnPostWorkerMsg(WOM_ADDAWAKEOBJECT,
                (MPARAM)somSelf,
                MPNULL);
        // _fAddedToAwakeList = TRUE;
    } /* else
        _fAddedToAwakeList = FALSE; */
}

/*
 * wpUnInitData:
 *           reverse to wpInitData, this instance method is
 *           called by the system when an object is made
 *           dormant; we will have this object removed from our
 *           global list of awake objects
 */

SOM_Scope void  SOMLINK xfobj_wpUnInitData(XFldObject *somSelf)
{
    // XFldObjectData *somThis = XFldObjectGetData(somSelf);
    XFldObjectMethodDebug("XFldObject","xfobj_wpUnInitData");

    // if (_fAddedToAwakeList)
        cmnPostWorkerMsg(WOM_REMOVEAWAKEOBJECT,
                (MPARAM)somSelf,
                MPNULL);

    XFldObject_parent_WPObject_wpUnInitData(somSelf);
}

/********************************************************************
 *                                                                  *
 *   here come the XFldObject class methods                         *
 *                                                                  *
 ********************************************************************/

/*
 * xfclsQueryModuleHandle:
 *           returns the module handle of the XFolder dynamic link library.
 *           If this is the first invocation, DosQueryModuleHandle is called
 *           to save the handle in class data for future invocations.
 */

SOM_Scope HMODULE  SOMLINK xfobjM_xfclsQueryModuleHandle(M_XFldObject *somSelf)
{
    M_XFldObjectData *somThis = M_XFldObjectGetData(somSelf);
    M_XFldObjectMethodDebug("M_XFldObject","xfobjM_xfclsQueryModuleHandle");

    // get module handle only if we don't already have it
    if (_hmod == NULLHANDLE) { // _hmod is part of the class data, see IDL file
        zString     zsPathName;
        somId       Id;

        /* retrieve registered path name of the module (DLL)
           and query the module handle */
        Id = somIdFromString("M_XFldObject");
        zsPathName = _somLocateClassFile(SOMClassMgrObject,
                                         Id,
                                         M_XFldObject_MajorVersion,
                                         M_XFldObject_MinorVersion);
        SOMFree(Id);
        if (DosQueryModuleHandle(zsPathName, &_hmod)) {
            return (HMODULE) 0;
        }
    }
    return (_hmod);
}

/*
 * xfclsAddsNewStatusBarMnemonics:
 *           this method returns flags for whether this class
 *           supports specific status bar mnemonics, i.e. objects
 *           of this class (and subclasses) display different
 *           information in status bar "single-object" mode
 *           than objects of parent classes. This method is
 *           called from the "Status bar" settings page in
 *           order to find out if different mnemonics can be
 *           set for this class.
 *           ORed return values are:
 *                SBS_ADDSMNEMONICS   class has own mnemonics
 *                SBS_MODIFIABLE      these mnemonics are modifiable
 *                                    (if not: they're static)
 */

SOM_Scope ULONG  SOMLINK xfobjM_xfclsAddsNewStatusBarMnemonics(M_XFldObject *somSelf)
{
    /* M_XFldObjectData *somThis = M_XFldObjectGetData(somSelf); */
    M_XFldObjectMethodDebug("M_XFldObject","xfobjM_xfclsAddsNewStatusBarMnemonics");

    return ( (somSelf == _XFldObject)
             ? (SBS_ADDSMNEMONICS | SBS_MODIFIABLE)
             : 0);
}

/*
 * xfclsQueryStatusBarMnemonics:
 *           this returns the status bar mnemonics for "single object"
 *           info for objects of this class and subclasses. This string
 *           is either what has been specified on the "Status bar"
 *           notebook page or a default string from the XFolder NLS DLL.
 *           The WPObject version returns the generic string for all
 *           objects, but this is overridden by several subclasses to
 *           return something more meaningful.
 */

SOM_Scope ULONG  SOMLINK xfobjM_xfclsQueryStatusBarMnemonics(M_XFldObject *somSelf,
                                                             PSZ pszText,
                                                             ULONG cbText)
{
    // M_XFldObjectData *somThis = M_XFldObjectGetData(somSelf);
    M_XFldObjectMethodDebug("M_XFldObject","xfobjM_xfclsQueryStatusBarMnemonics");

    if (szWPObjectStatusBarMnemonics[0] == '\0')
        // load string if this is the first time
        if (PrfQueryProfileString(HINI_USERPROFILE, INIAPP, INIKEY_SBTEXT_WPOBJECT,
                     NULL, &(szWPObjectStatusBarMnemonics),
                            sizeof(szWPObjectStatusBarMnemonics))
                == 0)
            // string not found in profile: load default from NLS resources
            WinLoadString(WinQueryAnchorBlock(HWND_DESKTOP), NLS_MODULE,
                        ID_XSSI_SBTEXTWPOBJECT,
                        sizeof(szWPObjectStatusBarMnemonics),
                        szWPObjectStatusBarMnemonics);

    strncpy(pszText, szWPObjectStatusBarMnemonics, cbText);
    pszText[cbText-1] = '\0';

    return (cbText);
}

/*
 * xfclsSetStatusBarMnemonics:
 *           change the status bar mnemonics for "single object"
 *           info for objects of this class and subclasses to
 *           pszText. If *pszText points to null-length string, no
 *           status bar info will be displayed; if pszText is NULL,
 *           the menmonics will be reset to the default value.
 */

SOM_Scope ULONG  SOMLINK xfobjM_xfclsSetStatusBarMnemonics(M_XFldObject *somSelf,
                                                           PSZ pszText)
{
    // M_XFldObjectData *somThis = M_XFldObjectGetData(somSelf);
    M_XFldObjectMethodDebug("M_XFldObject","xfobjM_xfclsSetStatusBarMnemonics");

    /* strncpy(szWPObjectStatusBarMnemonics, pszText, sizeof(szWPObjectStatusBarMnemonics));
    szWPObjectStatusBarMnemonics[sizeof(szWPObjectStatusBarMnemonics)-1] = '\0'; */

    // provoke a reload of the settings
    // in xfclsQueryStatusBarMnemonics
    szWPObjectStatusBarMnemonics[0] = '\0';

    // set the class mnemonics in OS2.INI; if
    // pszText == NULL, the key will be deleted,
    // and xfclsQueryStatusBarMnemonics will use
    // the default value
    return ((ULONG)PrfWriteProfileString(HINI_USERPROFILE, INIAPP, INIKEY_SBTEXT_WPOBJECT,
            pszText));
}

/*
 * wpclsInitData:
 *           we override this to activate the Worker thread;
 *           this is the first init method on the system after
 *           WPS bootup
 */

SOM_Scope void  SOMLINK xfobjM_wpclsInitData(M_XFldObject *somSelf)
{
    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();

    // M_XFldObjectData *somThis = M_XFldObjectGetData(somSelf);
    M_XFldObjectMethodDebug("M_XFldObject","xfobjM_wpclsInitData");

    M_XFldObject_parent_M_WPObject_wpclsInitData(somSelf);

    // since this code is reached for every single WPS class
    // that gets initialized, we need to check if we're being
    // called for the first time
    if (hwndXFolderObject == NULLHANDLE) {

        szWPObjectStatusBarMnemonics[0] = '\0';

        // create object window
        WinRegisterClass(WinQueryAnchorBlock(HWND_DESKTOP),
                         "XFolder Object",    // class name
                         (PFNWP)fnwpXFolderObject,    // Window procedure
                         0,                  // class style
                         0);                 // extra window words
        hwndXFolderObject = WinCreateWindow(
                            HWND_OBJECT,
                            "XFolder Object",
                            (PSZ)"",     // title
                            0,           // style
                            0,0,0,0,     // position
                            0,           // owner
                            HWND_BOTTOM, // z-order
                            ID_XFOLDEROBJECT, // window id
                            NULL,        // create params
                            NULL);       // pres params

        if (!hwndXFolderObject)
            DebugBox("XFolder: Error", "XFolder failed to create the XFolder object window.");

        // start other XFolder threads (in xfdesk.c)
        cmnInitializeXFolder();
    }

    // even if not first invocation (i.e. some class other
    // than WPObject gets initialized): notify Worker thread
    // of class initialization
    if (pGlobalSettings->ShowBootupStatus)
        cmnPostQuickMsg(QM_BOOTUPSTATUS, (MPARAM)somSelf, MPNULL);
}


