/*
 * xfprg.c:
 *      This file contains the following major XFolder parts:
 *
 *      -  XFldProgram SOM stuff
 *
 *      Check the other files starting with xf* for the
 *      other XFolder classes.
 *
 *      Copyright (C) 1997-98 Ulrich Mller.
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, in version 2 as it comes in the COPYING
 *      file of the XFolder main distribution.
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 */


/*
 *  This file was generated by the SOM Compiler and Emitter Framework.
 *  Generated using:
 *      SOM Emitter emitctm: 2.41
 */

#ifndef SOM_Module_xfpgm_Source
#define SOM_Module_xfpgm_Source
#endif
#define XFldProgram_Class_Source
#define M_XFldProgram_Class_Source

#define INCL_DOSFILEMGR
#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES
#define INCL_DOSEXCEPTIONS
#define INCL_DOSERRORS

// pmwin.h
#define INCL_WINWINDOWMGR
#define INCL_WINSHELLDATA       // profile funcs
#define INCL_WINPROGRAMLIST     // PROGDETAILS etc.

// dialogs and controls therein
#define INCL_WINDIALOGS

// pmstddlg.h
#define INCL_WINSTDBOOK         // notebooks
#include <os2.h>

#include "xfpgm.ih"
// #include "xfobj.h"

#include "common.h"           // this includes other libs

CHAR    szWPProgramStatusBarMnemonics[CCHMAXMNEMONICS] = "";

/*
 * xfAddXFldProgramPages:
 *           this actually adds the "XFolder" pages into the System notebook
 */

SOM_Scope ULONG  SOMLINK xfpgm_xfAddXFldProgramPages(XFldProgram *somSelf,
                                                     HWND hwndDlg)
{
    /* XFldProgramData *somThis = XFldProgramGetData(somSelf); */
    XFldProgramMethodDebug("XFldProgram","xfpgm_xfAddXFldProgramPages");

    /* Return statement to be customized: */
    return (0);
}

/*
 * xfTranslateStatusBarMnemonics:
 *           this method is called on an object to retrieve
 *           the "single-object" status bar info. pszText
 *           originally contains the (class-specific) mnemonic
 *           string returned by xfclsQueryStatusBarMnemonics.
 *           As opposed to the other mnemonics funcs, this is
 *           an _instance_ method because some translation
 *           might already be performed depending on the
 *           selected object.
 */

SOM_Scope ULONG  SOMLINK xfpgm_xfTranslateStatusBarMnemonics(XFldProgram *somSelf,
                                                             PSZ pszText,
                                                             ULONG cbText)
/* single-object status bar text mnemonics understood by XFldFileSystem
   (in addition to those introduced by XFldObject):

    $p      executable program file (as specified in the Settings)
    $P      parameter list (as specified in the Settings)
    $d      working directory (as specified in the Settings)
 */

{
    CHAR        szTemp[300];
    BOOL        fCont = TRUE;
    PSZ         p;
    PPROGDETAILS pProgDetails = NULL;
    ULONG       ulSize;

    /* XFldProgramData *somThis = XFldProgramGetData(somSelf); */
    XFldProgramMethodDebug("XFldProgram","xfpgm_xfTranslateStatusBarMnemonics");

    XFldProgram_parent_XFldObject_xfTranslateStatusBarMnemonics(somSelf,
                                                                        pszText,
                                                                        cbText);

    do {
        strcpy(szTemp, "?");
        fCont = FALSE;

        if (p = strstr(pszText, "$p"))  // program executable
        {
            if (!pProgDetails)
                if ((_wpQueryProgDetails(somSelf, (PPROGDETAILS)NULL, &ulSize)))
                    if ((pProgDetails = (PPROGDETAILS)_wpAllocMem(somSelf, ulSize, NULL)) != NULL)
                        _wpQueryProgDetails(somSelf, pProgDetails, &ulSize);

            if (pProgDetails)
                if (pProgDetails->pszExecutable)
                    strcpy(szTemp, pProgDetails->pszExecutable);
                else strcpy(szTemp, "");

            strrpl(pszText, "$p", szTemp);
            fCont = TRUE;
        }

        if (p = strstr(pszText, "$P"))  // program executable
        {
            if (!pProgDetails)
                if ((_wpQueryProgDetails(somSelf, (PPROGDETAILS)NULL, &ulSize)))
                    if ((pProgDetails = (PPROGDETAILS)_wpAllocMem(somSelf, ulSize, NULL)) != NULL)
                        _wpQueryProgDetails(somSelf, pProgDetails, &ulSize);

            if (pProgDetails)
                if (pProgDetails->pszParameters)
                    strcpy(szTemp, pProgDetails->pszParameters);
                else strcpy(szTemp, "");

            strrpl(pszText, "$P", szTemp);
            fCont = TRUE;
        }

        if (p = strstr(pszText, "$d"))  // program executable
        {
            if (!pProgDetails)
                if ((_wpQueryProgDetails(somSelf, (PPROGDETAILS)NULL, &ulSize)))
                    if ((pProgDetails = (PPROGDETAILS)_wpAllocMem(somSelf, ulSize, NULL)) != NULL)
                        _wpQueryProgDetails(somSelf, pProgDetails, &ulSize);

            if (pProgDetails)
                if (pProgDetails->pszStartupDir)
                    strcpy(szTemp, pProgDetails->pszStartupDir);
                else strcpy(szTemp, "");

            strrpl(pszText, "$d", szTemp);
            fCont = TRUE;
        }
    } while (fCont);

    if (pProgDetails)
        _wpFreeMem(somSelf, (PBYTE)pProgDetails);

    return (0);
}

/*
 * wpclsInitData:
 *           initialize class instance data
 */

SOM_Scope void  SOMLINK xfpgmM_wpclsInitData(M_XFldProgram *somSelf)
{
    // M_XFldProgramData *somThis = M_XFldProgramGetData(somSelf);
    M_XFldProgramMethodDebug("M_XFldProgram","xfpgmM_wpclsInitData");

    M_XFldProgram_parent_M_WPProgram_wpclsInitData(somSelf);
    M_XFldProgram_parent_M_XFldObject_wpclsInitData(somSelf);

    szWPProgramStatusBarMnemonics[0] = '\0';
}

/*
 * wpclsQueryTitle:
 *           tell the WPS the new class name: System (XFolder)
 */

SOM_Scope PSZ  SOMLINK xfpgmM_wpclsQueryTitle(M_XFldProgram *somSelf)
{
    // M_XFldProgramData *somThis = M_XFldProgramGetData(somSelf);
    M_XFldProgramMethodDebug("M_XFldProgram","xfpgmM_wpclsQueryTitle");

    /* strcpy(&(_szTitle[0]), M_XFldProgram_parent_M_WPProgram_wpclsQueryTitle(somSelf));
    strcat(&(_szTitle[0]), " (XFolder)");

    return (&(_szTitle[0])); */

    return (M_XFldProgram_parent_M_WPProgram_wpclsQueryTitle(somSelf));
}

/*
 * xfclsAddsNewStatusBarMnemonics:
 *           this method returns flags for whether this class
 *           supports specific status bar mnemonics, i.e. objects
 *           of this class (and subclasses) display different
 *           information in status bar "single-object" mode
 *           than objects of parent classes. This method is
 *           called from the "Status bar" settings page in
 *           order to find out if different mnemonics can be
 *           set for this class.
 *           ORed return values are:
 *                SBS_ADDSMNEMONICS   class has own mnemonics
 *                SBS_MODIFIABLE      these mnemonics are modifiable
 *                                    (if not: they're static)
 */

SOM_Scope ULONG  SOMLINK xfpgmM_xfclsAddsNewStatusBarMnemonics(M_XFldProgram *somSelf)
{
    // M_XFldProgramData *somThis = M_XFldProgramGetData(somSelf);
    M_XFldProgramMethodDebug("M_XFldProgram","xfpgmM_xfclsAddsNewStatusBarMnemonics");

    return ( (somSelf == _XFldProgram)
             ? (SBS_ADDSMNEMONICS | SBS_MODIFIABLE)
             : 0);
}

/*
 * xfclsQueryStatusBarMnemonics:
 *           this returns the status bar mnemonics for "single object"
 *           info for objects of this class and subclasses. This string
 *           is either what has been specified on the "Status bar"
 *           notebook page or a default string from the XFolder NLS DLL.
 *           The WPObject version returns the generic string for all
 *           objects, but this is overridden for program objects to
 *           return something more meaningful.
 */

SOM_Scope ULONG  SOMLINK xfpgmM_xfclsQueryStatusBarMnemonics(M_XFldProgram *somSelf,
                                                             PSZ pszText,
                                                             ULONG cbText)
{
    // M_XFldProgramData *somThis = M_XFldProgramGetData(somSelf);
    M_XFldProgramMethodDebug("M_XFldProgram","xfpgmM_xfclsQueryStatusBarMnemonics");

    if (szWPProgramStatusBarMnemonics[0] == '\0')
        // load string if this is the first time
        if (PrfQueryProfileString(HINI_USERPROFILE, INIAPP, INIKEY_SBTEXT_WPPROGRAM,
                     NULL, &(szWPProgramStatusBarMnemonics), sizeof(szWPProgramStatusBarMnemonics))
                == 0)
            // string not found in profile: load default from NLS resources
            WinLoadString(WinQueryAnchorBlock(HWND_DESKTOP), NLS_MODULE,
                        ID_XSSI_SBTEXTWPPROGRAM,
                        sizeof(szWPProgramStatusBarMnemonics),
                        szWPProgramStatusBarMnemonics);

    strncpy(pszText, szWPProgramStatusBarMnemonics, cbText);
    pszText[cbText-1] = '\0';

    return (cbText);
}

/*
 * xfclsSetStatusBarMnemonics:
 *           change the status bar mnemonics for "single object"
 *           info for objects of this class and subclasses to
 *           pszText. If *pszText points to null-length string, no
 *           status bar info will be displayed; if pszText is NULL,
 *           the menmonics will be reset to the default value.
 */

SOM_Scope ULONG  SOMLINK xfpgmM_xfclsSetStatusBarMnemonics(M_XFldProgram *somSelf,
                                                           PSZ pszText)
{
    // M_XFldProgramData *somThis = M_XFldProgramGetData(somSelf);
    M_XFldProgramMethodDebug("M_XFldProgram","xfpgmM_xfclsSetStatusBarMnemonics");

/*     strncpy(_szStatusBarMnemonics, pszText, sizeof(_szStatusBarMnemonics));
    _szStatusBarMnemonics[sizeof(_szStatusBarMnemonics)-1] = '\0'; */

    // provoke a reload of the settings
    // in xfclsQueryStatusBarMnemonics
    szWPProgramStatusBarMnemonics[0] = '\0';

    // set the class mnemonics in OS2.INI; if
    // pszText == NULL, the key will be deleted,
    // and xfclsQueryStatusBarMnemonics will use
    // the default value
    return (ULONG)PrfWriteProfileString(HINI_USERPROFILE, INIAPP, INIKEY_SBTEXT_WPPROGRAM,
            pszText);
}


