/*
 * xfsort.h:
 *      header file for xfsort.c, which contains the new folder
 *      sort comparison functions.
 *
 *      Copyright (C) 1997-98 Ulrich Mller.
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, in version 2 as it comes in the COPYING
 *      file of the XFolder main distribution.
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 */


/*
 * fnCompareExt:
 *      comparison function for CM_SORTRECORD msg sent when
 *      a folder is to be sorted by file name extension.
 *      Note: the toolkit docs for this function are flat out
 *      wrong. Container sort functions need to return the following:
 *          0   pmrc1 == pmrc2
 *         -1   pmrc1 <  pmrc2
 *         +1   pmrc1 >  pmrc2
 */

SHORT EXPENTRY fnCompareExt(PMINIRECORDCORE pmrc1, PMINIRECORDCORE pmrc2, PVOID pStorage);

/*
 * fnCompareFoldersFirst:
 *      comparison function for CM_SORTRECORD msg sent when
 *      a folder is to be sorted with folders first.
 */

SHORT EXPENTRY fnCompareFoldersFirst(PMINIRECORDCORE pmrc1, PMINIRECORDCORE pmrc2, PVOID pStorage);

/*
 * fnCompareName:
 *      comparison func for sort by name
 */

SHORT EXPENTRY fnCompareName(PMINIRECORDCORE pmrc1, PMINIRECORDCORE pmrc2, PVOID pStorage);

/*
 * fnCompareType:
 *      comparison func for sort by type (.TYPE EA)
 */

SHORT EXPENTRY fnCompareType(PMINIRECORDCORE pmrc1, PMINIRECORDCORE pmrc2, PVOID pStorage);

/*
 * fnCompareClass:
 *      comparison func for sort by object class
 */

SHORT EXPENTRY fnCompareClass(PMINIRECORDCORE pmrc1, PMINIRECORDCORE pmrc2, PVOID pStorage);

/*
 * fnCompareRealName:
 *      comparison func for sort by real name
 */

SHORT EXPENTRY fnCompareRealName(PMINIRECORDCORE pmrc1, PMINIRECORDCORE pmrc2, PVOID pStorage);

/*
 * fnCompareSize:
 *      comparison func for sort by size
 */

SHORT EXPENTRY fnCompareSize(PMINIRECORDCORE pmrc1, PMINIRECORDCORE pmrc2, PVOID pStorage);

/*
 * fnCompareCommonDate:
 *      common comparison func for sort by date functions below;
 *      ulWhat:
 *          1: compare write date
 *          2: compare access date
 *          3: compare creation date
 */

SHORT EXPENTRY fnCompareCommonDate(PMINIRECORDCORE pmrc1, PMINIRECORDCORE pmrc2,
            ULONG ulWhat);

SHORT EXPENTRY fnCompareLastWriteDate(PMINIRECORDCORE pmrc1, PMINIRECORDCORE pmrc2, PVOID pStorage);

SHORT EXPENTRY fnCompareLastAccessDate(PMINIRECORDCORE pmrc1, PMINIRECORDCORE pmrc2, PVOID pStorage);

SHORT EXPENTRY fnCompareCreationDate(PMINIRECORDCORE pmrc1, PMINIRECORDCORE pmrc2, PVOID pStorage);

