/*
 * xfsys.c:
 *      This file contains the following major XFolder parts:
 *
 *      -  XFldSystem SOM stuff
 *      -  XFldWPS SOM stuff
 *      -  more common functions (with a "cmn" func prefix)
 *         which are used by several XFolder routines
 *
 *      Check the other files starting with xf* for the
 *      other XFolder classes.
 *
 *      Copyright (C) 1997-98 Ulrich Mller.
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, in version 2 as it comes in the COPYING
 *      file of the XFolder main distribution.
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 */

/*
 *  This file was generated by the SOM Compiler and Emitter Framework.
 *  Generated using:
 *      SOM Emitter emitctm: 2.41
 */

#pragma langlvl(extended)

#ifndef SOM_Module_xfsys_Source
#define SOM_Module_xfsys_Source
#endif
#define xfsys_Class_Source
#define M_xfsys_Class_Source

#define INCL_DOSFILEMGR
#define INCL_DOSMODULEMGR
#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES
#define INCL_DOSEXCEPTIONS
#define INCL_DOSERRORS
#define INCL_DOSDEVICES
#define INCL_DOSDEVIOCTL
#define INCL_DOSMISC            // sysinfo etc.

// pmwin.h
#define INCL_WINWINDOWMGR
#define INCL_WINFRAMEMGR        // WM_FORMATFRAME etc.
#define INCL_WINSYS             // presparams
#define INCL_WINPOINTERS
#define INCL_WININPUT           // WM_BUTTON1DOWN etc.

#define INCL_WINSHELLDATA       // profile funcs
#define INCL_WINPROGRAMLIST     // PROGDETAILS etc.
#define INCL_WINCOUNTRY         // WinCompareStrings
#define INCL_WINTIMER
#define INCL_WINERRORS
#define INCL_WINRECTANGLES      // rcl functions
#define INCL_WINCLIPBOARD
#define INCL_WINMESSAGEMGR      // sophisticated msg funcs

// dialogs and controls therein
#define INCL_WINDIALOGS
#define INCL_WINSTATICS
#define INCL_WINMENUS
#define INCL_WINENTRYFIELDS
#define INCL_WINBUTTONS
#define INCL_WINLISTBOXES

// pmstddlg.h
#define INCL_WINSTDSPIN         // spin buttons
#define INCL_WINSTDCNR          // container
#define INCL_WINSTDBOOK         // notebooks
#define INCL_WINSTDFILE         // file dialog

// pmmle.h
#define INCL_WINMLE             // multi-line entry field

#define INCL_WINWORKPLACE

#include <os2.h>

#include "xfsys.ih"
#include "xfldr.h"
#include "xfdesk.h"
#include "xfobj.h"

#include "common.h"            // this includes other libs

#include "objdlgs.h"
#include "procstat.h"
#include "xfsort.h"
#include "apm.h"               // APM power-off for XShutdown

// #include  <pmwp.h>          // common stuff
// #include  <wpdesk.h>        // WPDesktop, already #include'd
// #include  <wptrans.h>       // WPTransient

#pragma  linkage (main, optlink)

/********************************************************************
 *                                                                  *
 *   here come the XFldSystem instance methods                      *
 *                                                                  *
 ********************************************************************/

/* first we define the configurable folder hotkeys:
   for each item in szLBEntries, there must be
   a corresponding entry in ulLBCommands; if you
   change the order in one struct, you must change
   the corresponding item in the other struct also */

// number of items: the consts are def'd in common.h
#define LBENTRYCOUNT (ID_XSSI_LB_LAST-ID_XSSI_LB_FIRST+1)
#define MAXLBENTRYLENGTH 50

CHAR  szLBEntries[LBENTRYCOUNT][MAXLBENTRYLENGTH];

// XFolder folder hotkeys
XFLDACC     XFldAccs[LBENTRYCOUNT];    // global array for storing them

ULONG szLBStringIDs[LBENTRYCOUNT] = {
         ID_XSSI_LB_REFRESHNOW          ,
         ID_XSSI_LB_SNAPTOGRID          ,
         ID_XSSI_LB_SELECTALL           ,
         ID_XSSI_LB_OPENPARENTFOLDER    ,

         ID_XSSI_LB_OPENSETTINGSNOTEBOOK,
         ID_XSSI_LB_OPENNEWDETAILSVIEW  ,
         ID_XSSI_LB_OPENNEWICONVIEW     ,
         ID_XSSI_LB_DESELECTALL         ,
         ID_XSSI_LB_OPENNEWTREEVIEW     ,

         ID_XSSI_LB_FIND                ,

         ID_XSSI_LB_PICKUP              ,
         ID_XSSI_LB_PICKUPCANCELDRAG    ,

         ID_XSSI_LB_SORTBYNAME          ,
         ID_XSSI_LB_SORTBYSIZE          ,
         ID_XSSI_LB_SORTBYTYPE          ,
         ID_XSSI_LB_SORTBYREALNAME      ,
         ID_XSSI_LB_SORTBYWRITEDATE     ,
         ID_XSSI_LB_SORTBYACCESSDATE    ,
         ID_XSSI_LB_SORTBYCREATIONDATE  ,

         ID_XSSI_LB_SWITCHTOICONVIEW    ,
         ID_XSSI_LB_SWITCHTODETAILSVIEW ,
         ID_XSSI_LB_SWITCHTOTREEVIEW    ,

         ID_XSSI_LB_ARRANGEDEFAULT      ,
         ID_XSSI_LB_ARRANGEFROMTOP      ,
         ID_XSSI_LB_ARRANGEFROMLEFT     ,
         ID_XSSI_LB_ARRANGEFROMRIGHT    ,
         ID_XSSI_LB_ARRANGEFROMBOTTOM   ,
         ID_XSSI_LB_ARRANGEPERIMETER    ,
         ID_XSSI_LB_ARRANGEHORIZONTALLY ,
         ID_XSSI_LB_ARRANGEVERTICALLY   ,

         ID_XSSI_LB_INSERT              ,

         ID_XSSI_LB_SORTBYEXTENSION     ,
         ID_XSSI_LB_OPENPARENTFOLDERANDCLOSE,

         ID_XSSI_LB_CLOSEWINDOW,
         ID_XSSI_LB_SELECTSOME,
         ID_XSSI_LB_SORTFOLDERSFIRST,
         ID_XSSI_LB_SORTBYCLASS,

         ID_XSSI_LB_CONTEXTMENU,
         ID_XSSI_LB_TASKLIST,

         ID_XSSI_LB_COPYFILENAME_SHORT,
         ID_XSSI_LB_COPYFILENAME_FULL

    };

ULONG ulLBCommands[LBENTRYCOUNT] = {
        WPMENUID_REFRESH,
        ID_XFMI_OFS_SNAPTOGRID,
        WPMENUID_SELALL,
        ID_XFMI_OFS_OPENPARENT,

        WPMENUID_PROPERTIES,
        WPMENUID_DETAILS,
        WPMENUID_ICON,
        WPMENUID_DESELALL,
        WPMENUID_TREE,

        WPMENUID_FIND,

        WPMENUID_PICKUP,
        WPMENUID_PUTDOWN_CANCEL,

        ID_WPMI_SORTBYNAME,
        ID_WPMI_SORTBYSIZE,
        ID_WPMI_SORTBYTYPE,
        ID_WPMI_SORTBYREALNAME,
        ID_WPMI_SORTBYWRITEDATE,
        ID_WPMI_SORTBYACCESSDATE,
        ID_WPMI_SORTBYCREATIONDATE,

        ID_WPMI_SHOWICONVIEW,
        ID_WPMI_SHOWDETAILSVIEW,
        ID_WPMI_SHOWTREEVIEW,

        WPMENUID_ARRANGE,
        ID_WPMI_ARRANGEFROMTOP,
        ID_WPMI_ARRANGEFROMLEFT,
        ID_WPMI_ARRANGEFROMRIGHT,
        ID_WPMI_ARRANGEFROMBOTTOM,
        ID_WPMI_ARRANGEPERIMETER,
        ID_WPMI_ARRANGEHORIZONTALLY,
        ID_WPMI_ARRANGEVERTICALLY,

        ID_WPMI_INSERT,

        ID_XFMI_OFS_SORTBYEXT,
        ID_XFMI_OFS_OPENPARENTANDCLOSE,

        ID_XFMI_OFS_CLOSE,
        ID_XFMI_OFS_SELECTSOME,
        ID_XFMI_OFS_SORTFOLDERSFIRST,
        ID_XFMI_OFS_SORTBYCLASS,

        ID_XFMI_OFS_CONTEXTMENU,
        0x8011,                     // show task list (sysmenu)

        ID_XFMI_OFS_COPYFILENAME_SHORT,
        ID_XFMI_OFS_COPYFILENAME_FULL
    };

/*
 * cmnLoadAccelerators:
 *           loads folder hotkeys from INIs
 */

void cmnLoadAccelerators(VOID)
{
    ULONG ulCopied2 = sizeof(XFldAccs);
    if (!PrfQueryProfileData(HINI_USERPROFILE, INIAPP, INIKEY_ACCELERATORS,
                &XFldAccs, &ulCopied2))
        cmnLoadDefaultAccelerators();
}

/*
 * cmnStoreAccelerators:
 *           stores folder hotkeys into INIs
 */

void cmnStoreAccelerators(VOID)
{
    SHORT i2 = 0;

    // store only the accels that are actually used
    while (XFldAccs[i2].usCommand)
        i2++;

    PrfWriteProfileData(HINI_USERPROFILE, INIAPP, INIKEY_ACCELERATORS,
        &XFldAccs, (i2+1) * sizeof(XFLDACC));
}

/*
 * cmnLoadDefaultAccelerators:
 *           resets the accels to default
 */

void cmnLoadDefaultAccelerators(VOID)
{
    // Ctrl+A: Select all
    XFldAccs[0].usKeyCode  = (USHORT)'a';
    XFldAccs[0].usFlags    = KC_CTRL;
    XFldAccs[0].usCommand  = WPMENUID_SELALL;

    // F5
    XFldAccs[1].usKeyCode  = VK_F5;
    XFldAccs[1].usFlags    = KC_VIRTUALKEY;
    XFldAccs[1].usCommand  = WPMENUID_REFRESH,

    // Backspace
    XFldAccs[2].usKeyCode  = VK_BACKSPACE;
    XFldAccs[2].usFlags    = KC_VIRTUALKEY;
    XFldAccs[2].usCommand  = ID_XFMI_OFS_OPENPARENT;

    //  Ctrl+D: De-select all
    XFldAccs[3].usKeyCode  = (USHORT)'d';
    XFldAccs[3].usFlags    = KC_CTRL;
    XFldAccs[3].usCommand  = WPMENUID_DESELALL;

    // Ctrl+Shift+D: Details view
    XFldAccs[4].usKeyCode  = (USHORT)'D';
    XFldAccs[4].usFlags    = KC_CTRL+KC_SHIFT;
    XFldAccs[4].usCommand  = WPMENUID_DETAILS;

    // Ctrl+Shift+I: Icon  view
    XFldAccs[5].usKeyCode  = (USHORT)'I';
    XFldAccs[5].usFlags    = KC_CTRL+KC_SHIFT;
    XFldAccs[5].usCommand  = WPMENUID_ICON;

    // Ctrl+Shift+S: Open Settings
    XFldAccs[6].usKeyCode  = (USHORT)'S';
    XFldAccs[6].usFlags    = KC_CTRL+KC_SHIFT;
    XFldAccs[6].usCommand  = WPMENUID_PROPERTIES;

    // Ctrl+N: Sort by name
    XFldAccs[7].usKeyCode  = (USHORT)'n';
    XFldAccs[7].usFlags    = KC_CTRL;
    XFldAccs[7].usCommand  = ID_WPMI_SORTBYNAME;

    // Ctrl+Z: Sort by size
    XFldAccs[8].usKeyCode  = (USHORT)'z';
    XFldAccs[8].usFlags    = KC_CTRL;
    XFldAccs[8].usCommand  = ID_WPMI_SORTBYSIZE;

    // Ctrl+E: Sort by extension (NPS)
    XFldAccs[9].usKeyCode  = (USHORT)'e';
    XFldAccs[9].usFlags    = KC_CTRL;
    XFldAccs[9].usCommand  = ID_XFMI_OFS_SORTBYEXT;

    // Ctrl+W: Sort by write date
    XFldAccs[10].usKeyCode  = (USHORT)'w';
    XFldAccs[10].usFlags    = KC_CTRL;
    XFldAccs[10].usCommand  = ID_WPMI_SORTBYWRITEDATE;

    // Ctrl+Y: Sort by type
    XFldAccs[11].usKeyCode  = (USHORT)'y';
    XFldAccs[11].usFlags    = KC_CTRL;
    XFldAccs[11].usCommand  = ID_WPMI_SORTBYTYPE;

    // Shift+Backspace
    XFldAccs[12].usKeyCode  = VK_BACKSPACE;
    XFldAccs[12].usFlags    = KC_VIRTUALKEY+KC_SHIFT;
    XFldAccs[12].usCommand  = ID_XFMI_OFS_OPENPARENTANDCLOSE;

    // Ctrl+S: Select by name
    XFldAccs[13].usKeyCode  = (USHORT)'s';
    XFldAccs[13].usFlags    = KC_CTRL;
    XFldAccs[13].usCommand  = ID_XFMI_OFS_SELECTSOME;

    // Ctrl+insert: copy filename (w/out path)
    XFldAccs[14].usKeyCode  = VK_INSERT;
    XFldAccs[14].usFlags    = KC_VIRTUALKEY+KC_CTRL;
    XFldAccs[14].usCommand  = ID_XFMI_OFS_COPYFILENAME_SHORT;

    XFldAccs[15].usCommand = 0;
}

/*
 * cmnProcessAccel (xfsys.c):
 *      this is called by the subclassed folder frame wnd proc to check
 *      for whether a given WM_CHAR message matches one of the folder
 *      hotkeys; we need to put this in this file because we cannot
 *      access the global XFldAccs array from xfldr.c
 */

BOOL cmnProcessAccel(HWND hwndFrame, MPARAM mp1, MPARAM mp2)
{
    USHORT  us;

    USHORT usFlags    = SHORT1FROMMP(mp1);
    USHORT usch       = SHORT1FROMMP(mp2);
    USHORT usvk       = SHORT2FROMMP(mp2);
    USHORT usKeyCode  = 0;

    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();

    /* now check if the key is relevant: filter out KEY UP
       messages and check if either a virtual key (such as F5)
       or Ctrl or Alt was pressed */
    if (    ((usFlags & KC_KEYUP) == 0)
        &&  (     ((usFlags & KC_VIRTUALKEY) != 0)
               || ((usFlags & KC_CTRL) != 0)
               || ((usFlags & KC_ALT) != 0)
               || (   ((usFlags & KC_VIRTUALKEY) == 0)
                   && (     (usch == 0xEC00)
                        ||  (usch == 0xED00)
                        ||  (usch == 0xEE00)
                      )
                  )
            )
       )
    {

        if (usFlags & KC_VIRTUALKEY)
            usKeyCode = usvk;
        else
            usKeyCode = usch;

        usFlags &= (KC_VIRTUALKEY | KC_CTRL | KC_ALT | KC_SHIFT);
        us = 0;

        #ifdef DEBUG_KEYS
            _Pmpf(("cmnProcessAccel: usKeyCode: 0x%lX, usFlags: 0x%lX", usKeyCode, usFlags));
        #endif

        // now go through the global accelerator list and check
        // if the pressed key was assigned an action to */
        while (XFldAccs[us].usCommand)
        {
            USHORT usCommand;
            if (
                   (  (XFldAccs[us].usFlags == usFlags)
                   && (XFldAccs[us].usKeyCode == usKeyCode)
                   )
/*               || (   ((usFlags & KC_VIRTUALKEY) == 0)
                   && (     (usKeyCode == 0xEC00)
                        ||  (usKeyCode == 0xED00)
                        ||  (usKeyCode == 0xEE00)
                      )
                  ) */
               )
            {   /* OK: this is a hotkey; find the corresponding
                   "command" (= menu ID) and post it to the frame
                   window, which will execute it */
                usCommand = XFldAccs[us].usCommand;
                if ( (usCommand >= WPMENUID_USER) &&
                     (usCommand < WPMENUID_USER+FIRST_VARIABLE) )
                        usCommand += pGlobalSettings->VarMenuOffset;
                WinPostMsg(hwndFrame,
                    WM_COMMAND,
                    (MPARAM)usCommand,
                    MPFROM2SHORT(CMDSRC_MENU,
                                FALSE) );     // results from keyboard operation

                #ifdef DEBUG_KEYS
                    _Pmpf(("  Posting command 0x%lX", usCommand));
                #endif

                return (TRUE);
            }
            us++;
        }
    }
    return (FALSE);
}

/*
 * cmnFindAccIndexFromLBSel:
 *          this subroutine finds an index to the global
 *          XFldAccs[] array according to the currently
 *          selected list box item; returns:
 *              -1  if LB entries do not match array strings
 *                  (should not happen)
 *              -2  if no accelerator has been defined yet
 *           other  index to XFldAccs[] array, if accelerator
 *                  has been defined;
 *          if *pusCommand is != NULL, it will contain
 *          thereafter the menu "command" of the selected
 *          LB item, such that a new accelerator can be created
 */

LONG cmnFindAccIndexFromLBSel(HWND hwndDlg, USHORT *pusCommand)
{
    SHORT               i, i2 = 0;
    CHAR                szTemp[MAXLBENTRYLENGTH];
    SHORT               sItem;
    SHORT               LBIndex = -1, AccIndex = -1;

    sItem = (SHORT)WinSendDlgItemMsg(hwndDlg, ID_XSDI_LISTBOX,
                            LM_QUERYSELECTION,
                            (MPARAM)LIT_CURSOR,
                            MPNULL);

    WinSendDlgItemMsg(hwndDlg, ID_XSDI_LISTBOX,
                            LM_QUERYITEMTEXT,
                            MPFROM2SHORT(sItem, sizeof(szTemp)),
                            (MPARAM)szTemp);
    // szTemp now contains the selected list box entry's text

    for (i = 0; i < LBENTRYCOUNT; i++)
    {
        if (strcmp(szTemp, szLBEntries[i]) == 0)
        {
            LBIndex = i;
            break;
        }
    }
    // i now contains the index in the ulLBCommands array

    if (LBIndex != -1)
    {
        while (XFldAccs[i2].usCommand)
        {
                if (XFldAccs[i2].usCommand == ulLBCommands[i])
                {
                    AccIndex = i2;
                    break;
                }
                i2++;
        }
        if ( (AccIndex == -1) && (pusCommand) )
            *pusCommand = ulLBCommands[i];
        return AccIndex;
    }
    else return -2;
}

/*
 * cmnDescribeKey:
 *          describes a pressed key in pszBuf;
 *          usFlags must contain usFlags from WM_CHAR,
 *          usKeyCode must be either usch (char code)
 *          or, with virtual keys, usvk (vk code).
 *          Returns TRUE if this was a valid key combo.
 */

BOOL cmnDescribeKey(PSZ pszBuf, USHORT usFlags, USHORT usKeyCode)
{
    BOOL rc = TRUE;

    PNLSSTRINGS pNLSStrings = cmnQueryNLSStrings();

    strcpy(pszBuf, "");
    if (usFlags & KC_CTRL)
        strcat(pszBuf, pNLSStrings->pszCtrl);
    if (usFlags & KC_SHIFT)
        strcat(pszBuf, pNLSStrings->pszShift);
    if (usFlags & KC_ALT)
        strcat(pszBuf, pNLSStrings->pszAlt);

    if (usFlags & KC_VIRTUALKEY) {
        switch (usKeyCode) {
            case VK_BACKSPACE: strcat(pszBuf, pNLSStrings->pszBackspace); break;
            case VK_TAB: strcat(pszBuf, pNLSStrings->pszTab); break;
            case VK_BACKTAB: strcat(pszBuf, pNLSStrings->pszBacktab); break;
            case VK_NEWLINE: strcat(pszBuf, pNLSStrings->pszEnter); break;
            case VK_ESC: strcat(pszBuf, pNLSStrings->pszEsc); break;
            case VK_SPACE: strcat(pszBuf, pNLSStrings->pszSpace); break;
            case VK_PAGEUP: strcat(pszBuf, pNLSStrings->pszPageup); break;
            case VK_PAGEDOWN: strcat(pszBuf, pNLSStrings->pszPagedown); break;
            case VK_END: strcat(pszBuf, pNLSStrings->pszEnd); break;
            case VK_HOME: strcat(pszBuf, pNLSStrings->pszHome); break;
            case VK_LEFT: strcat(pszBuf, pNLSStrings->pszLeft); break;
            case VK_UP: strcat(pszBuf, pNLSStrings->pszUp); break;
            case VK_RIGHT: strcat(pszBuf, pNLSStrings->pszRight); break;
            case VK_DOWN: strcat(pszBuf, pNLSStrings->pszDown); break;
            case VK_PRINTSCRN: strcat(pszBuf, pNLSStrings->pszPrintscrn); break;
            case VK_INSERT: strcat(pszBuf, pNLSStrings->pszInsert); break;
            case VK_DELETE: strcat(pszBuf, pNLSStrings->pszDelete); break;
            case VK_SCRLLOCK: strcat(pszBuf, pNLSStrings->pszScrlLock); break;
            case VK_NUMLOCK: strcat(pszBuf, pNLSStrings->pszNumLock); break;
            case VK_ENTER: strcat(pszBuf, pNLSStrings->pszEnter); break;
            case VK_F1: strcat(pszBuf, "F1"); break;
            case VK_F2: strcat(pszBuf, "F2"); break;
            case VK_F3: strcat(pszBuf, "F3"); break;
            case VK_F4: strcat(pszBuf, "F4"); break;
            case VK_F5: strcat(pszBuf, "F5"); break;
            case VK_F6: strcat(pszBuf, "F6"); break;
            case VK_F7: strcat(pszBuf, "F7"); break;
            case VK_F8: strcat(pszBuf, "F8"); break;
            case VK_F9: strcat(pszBuf, "F9"); break;
            case VK_F10: strcat(pszBuf, "F10"); break;
            case VK_F11: strcat(pszBuf, "F11"); break;
            case VK_F12: strcat(pszBuf, "F12"); break;
            case VK_F13: strcat(pszBuf, "F13"); break;
            case VK_F14: strcat(pszBuf, "F14"); break;
            case VK_F15: strcat(pszBuf, "F15"); break;
            case VK_F16: strcat(pszBuf, "F16"); break;
            case VK_F17: strcat(pszBuf, "F17"); break;
            case VK_F18: strcat(pszBuf, "F18"); break;
            case VK_F19: strcat(pszBuf, "F19"); break;
            case VK_F20: strcat(pszBuf, "F20"); break;
            case VK_F21: strcat(pszBuf, "F21"); break;
            case VK_F22: strcat(pszBuf, "F22"); break;
            case VK_F23: strcat(pszBuf, "F23"); break;
            case VK_F24: strcat(pszBuf, "F24"); break;
            default: break;
        }
    } // end virtualkeys
    else {
        switch (usKeyCode) {
            case 0xEC00: strcat(pszBuf, pNLSStrings->pszWinLeft); break;
            case 0xED00: strcat(pszBuf, pNLSStrings->pszWinRight); break;
            case 0xEE00: strcat(pszBuf, pNLSStrings->pszWinMenu); break;
            default: {
                CHAR szTemp[2];
                if (usKeyCode >= 'a')
                    szTemp[0] = (CHAR)usKeyCode-32;
                else
                    szTemp[0] = (CHAR)usKeyCode;
                szTemp[1] = '\0';
                strcat(pszBuf, szTemp);
            }
        }
    }

    #ifdef DEBUG_KEYS
        _Pmpf(("Key: %s, usKeyCode: 0x%lX, usFlags: 0x%lX", pszBuf, usKeyCode, usFlags));
    #endif

    return (rc);
}

/*
 * fnwpKeyboardEntryField:
 *          this is the window proc for the subclassed
 *          entry field on settings page 4; we will intercept
 *          all WM_CHAR messages and insert a key description
 *          instead of the character; moreover, we will
 *          update the global accelerator list accordingly
 */

PFNWP                   OldEditProc;   // for subclassed Edit field

MRESULT EXPENTRY fnwpKeyboardEntryField(HWND hwndEdit, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    MRESULT mrc = (MPARAM)FALSE; // WM_CHAR not-processed flag

    switch (msg) {
        case WM_CHAR: {
            LONG i;
            USHORT usCommand;
            USHORT usKeyCode;
            USHORT usFlags    = SHORT1FROMMP(mp1);
            USHORT usch       = SHORT1FROMMP(mp2);
            USHORT usvk       = SHORT2FROMMP(mp2);

                if (    ((usFlags & KC_KEYUP) == 0)
                    &&  (     ((usFlags & KC_VIRTUALKEY) != 0)
                           || ((usFlags & KC_CTRL) != 0)
                           || ((usFlags & KC_ALT) != 0)
                           || (   ((usFlags & KC_VIRTUALKEY) == 0)
                               && (     (usch == 0xEC00)
                                    ||  (usch == 0xED00)
                                    ||  (usch == 0xEE00)
                                  )
                              )
                        )
                   )
            {
                usFlags &= (KC_VIRTUALKEY | KC_CTRL | KC_ALT | KC_SHIFT);
                if (usFlags & KC_VIRTUALKEY)
                    usKeyCode = usvk;
                else
                    usKeyCode = usch;

                i = cmnFindAccIndexFromLBSel(WinQueryWindow(hwndEdit, QW_PARENT), &usCommand);

                #ifdef DEBUG_KEYS
                    _Pmpf(("List box index: %d", i));
                #endif

                if (i == -1)
                { // no accelerator defined yet: append a new one
                    SHORT i2 = 0;
                    while (XFldAccs[i2].usCommand)
                        i2++;
                    XFldAccs[i2].usCommand = usCommand;
                    XFldAccs[i2+1].usCommand = 0;
                    i = i2;
                }
                if (i >= 0) {
                    CHAR szKeyName[200];
                    XFldAccs[i].usFlags      = usFlags;
                    XFldAccs[i].usKeyCode    = usKeyCode;
                    #ifdef DEBUG_KEYS
                        _Pmpf(("Stored usFlags = 0x%lX, usKeyCode = 0x%lX", usFlags, usKeyCode));
                    #endif
                    cmnDescribeKey(szKeyName, usFlags, usKeyCode);
                    WinSetWindowText(hwndEdit, szKeyName);
                    WinEnableDlgItem(WinQueryWindow(hwndEdit, QW_PARENT),
                            ID_XSDI_CLEARACCEL, TRUE);

                    mrc = (MPARAM)TRUE; // WM_CHAR processed flag;
                }
            }
        break; }

        default:
            mrc = OldEditProc(hwndEdit, msg, mp1, mp2);
    }
    return (mrc);
}

/*
 * cmnAddResourceDLLToLB:
 *      this loads a given resource DLL temporarily in order to
 *      find out its language and inserts a descriptive string
 *      into a given list box (used for XFolder settings page 5)
 */

VOID cmnAddResourceDLLToLB(HWND hwndDlg, ULONG idLB, PSZ pszFileName)
{
    CHAR    szLBEntry[200],
            // szTemp[100],
            szResourceModuleName[CCHMAXPATH];
    HMODULE hmodDLL = NULLHANDLE;
    // PVOID   pProc;
    ULONG   ulCopied;
    APIRET  rc;

    #ifdef DEBUG_SETTINGS
        _Pmpf(("  Entering cmnAddResourceDLLtoLB: %s\n", pszFileName));
    #endif
    if (ulCopied = cmnQueryXFolderBasePath(szResourceModuleName,
               sizeof(szResourceModuleName)))
    {
        strcat(szResourceModuleName, "\\bin\\");
        strcat(szResourceModuleName, pszFileName);

        #ifdef DEBUG_SETTINGS
            _Pmpf(("  Loading module %s\n", szResourceModuleName));
        #endif
        rc = DosLoadModule(NULL, 0,
                      szResourceModuleName,
                      &hmodDLL);
        if (rc == NO_ERROR) {
            #ifdef DEBUG_SETTINGS
                _Pmpf(("  Testing for language string\n"));
            #endif
            if (WinLoadString(WinQueryAnchorBlock(HWND_DESKTOP), hmodDLL,
                ID_XSSI_DLLLANGUAGE, sizeof(szLBEntry), szLBEntry))
            {
                #ifdef DEBUG_SETTINGS
                    _Pmpf(("    found %s\n", szLBEntry));
                #endif
                strcat(szLBEntry, " -- ");
                strcat(szLBEntry, pszFileName);

                WinSendDlgItemMsg(hwndDlg, idLB,
                                LM_INSERTITEM,
                                (MPARAM)LIT_SORTASCENDING,
                                (MPARAM)szLBEntry);
            }

            DosFreeModule(hmodDLL);
        }
        #ifdef DEBUG_SETTINGS
            else
                _Pmpf(("    Error %d\n", rc));
        #endif
    }
}

/********************************************************************
 *                                                                  *
 *   here come the XFldSystem instance methods                      *
 *                                                                  *
 ********************************************************************/

/*
 * xfAddXFldSystemPages:
 *           this actually adds the "XFolder" pages into the System notebook
 */

SOM_Scope ULONG  SOMLINK xfsys_xfAddXFldSystemPages(XFldSystem *somSelf,
                                                 HWND hwndDlg)
{
    PAGEINFO        pi;
    HMODULE         savehmod;
    // CHAR            szXFolderVersion[100];
    PNLSSTRINGS pNLSStrings = cmnQueryNLSStrings();
    PSZ pszHelpLibrary = cmnQueryHelpLibrary();

    // XFldSystemData *somThis = XFldSystemGetData(somSelf);
    XFldSystemMethodDebug("XFldSystem","xfsys_xfAddXFldSystemPages");

    savehmod = NLS_MODULE;
    memset((PCH)&pi, 0, sizeof(PAGEINFO));

    // "Errors"
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpConfigErrors;
    pi.resid               = savehmod;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SETTINGS_ERRORS;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MAJOR;   // give major tab
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = 0; // SETTINGS_PAGE_NUMBERS;          // auto enumerate in status line
    pi.pszName             = pNLSStrings->pszErrors;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS_ERRORS;

    _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

    // "Workplace Shell"
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpConfigWPS;
    pi.resid               = savehmod;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SETTINGS_WPS;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MAJOR;   // give major tab
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = 0; // SETTINGS_PAGE_NUMBERS;          // auto enumerate in status line
    pi.pszName             = pNLSStrings->pszWPS;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS_WPS;

    _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

    // insert file-system settings pages
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpConfigFAT;
    pi.resid               = savehmod;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SETTINGS_FAT;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MAJOR;   // give major tab
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = 0; // SETTINGS_PAGE_NUMBERS;          // auto enumerate in status line
    pi.pszName             = "~FAT";

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS_HPFS;

    _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpConfigHPFS;
    pi.resid               = savehmod;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SETTINGS_HPFS;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MAJOR;   // give major tab
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = 0; // SETTINGS_PAGE_NUMBERS;          // auto enumerate in status line
    pi.pszName             = "~HPFS";

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS_HPFS;

    _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

    // "Memory"
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpConfigMemory;
    pi.resid               = savehmod;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SETTINGS_KERNEL2;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MAJOR;   // give major tab
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = 0; // SETTINGS_PAGE_NUMBERS;          // auto enumerate in status line
    pi.pszName             = pNLSStrings->pszMemory;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS_KERNEL2;

    _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

    // "Scheduler"
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpConfigScheduler;
    pi.resid               = savehmod;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SETTINGS_KERNEL1;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MAJOR;   // give major tab
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = 0; // SETTINGS_PAGE_NUMBERS;          // auto enumerate in status line
    pi.pszName             = pNLSStrings->pszScheduler;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS_KERNEL1;

    return (_wpInsertSettingsPage(somSelf, hwndDlg, &pi));
}

/*
 * All the following methods are overridden in order to
 *           suppress certain window pages
 */

SOM_Scope ULONG  SOMLINK xfsys_wpAddSystemConfirmationPage(XFldSystem *somSelf,
                                                             HWND hwndNotebook)
{
    /* XFldSystemData *somThis = XFldSystemGetData(somSelf); */
    XFldSystemMethodDebug("XFldSystem","xfsys_wpAddSystemConfirmationPage");

    return (SETTINGS_PAGE_REMOVED);
    /* return (XFldSystem_parent_WPSystem_wpAddSystemConfirmationPage(somSelf,
                                                                   hwndNotebook)); */
}

SOM_Scope ULONG  SOMLINK xfsys_wpAddSystemWindowPage(XFldSystem *somSelf,
                                                     HWND hwndNotebook)
{
    /* XFldSystemData *somThis = XFldSystemGetData(somSelf); */
    XFldSystemMethodDebug("XFldSystem","xfsys_wpAddSystemWindowPage");

    return (SETTINGS_PAGE_REMOVED);
    /* return (XFldSystem_parent_WPSystem_wpAddSystemWindowPage(somSelf,
                                                             hwndNotebook)); */
}

SOM_Scope ULONG  SOMLINK xfsys_wpAddObjectWindowPage(XFldSystem *somSelf,
                                                       HWND hwndNotebook)
{
    /* XFldSystemData *somThis = XFldSystemGetData(somSelf); */
    XFldSystemMethodDebug("XFldSystem","xfsys_wpAddObjectWindowPage");

    return (SETTINGS_PAGE_REMOVED);
    /* return (XFldSystem_parent_WPSystem_wpAddObjectWindowPage(somSelf,
                                                             hwndNotebook)); */
}

SOM_Scope ULONG  SOMLINK xfsys_wpAddSysFdrSelfClosePage(XFldSystem *somSelf,
                                                          HWND hwndNotebook)
{
    /* XFldSystemData *somThis = XFldSystemGetData(somSelf); */
    XFldSystemMethodDebug("XFldSystem","xfsys_wpAddSysFdrSelfClosePage");

    return (SETTINGS_PAGE_REMOVED);
    // return (XFldSystem_parent_WPSystem_wpAddSysFdrSelfClosePage(somSelf, hwndNotebook));
}

SOM_Scope ULONG  SOMLINK xfsys_wpAddSysFdrDefViewPage(XFldSystem *somSelf,
                                                        HWND hwndNotebook)
{
    /* XFldSystemData *somThis = XFldSystemGetData(somSelf); */
    XFldSystemMethodDebug("XFldSystem","xfsys_wpAddSysFdrDefViewPage");

    return (SETTINGS_PAGE_REMOVED);
    /* return (XFldSystem_parent_WPSystem_wpAddSysFdrDefViewPage(somSelf,
                                                              hwndNotebook)); */
}

SOM_Scope ULONG  SOMLINK xfsys_wpAddTitleConfirmationPage(XFldSystem *somSelf,
                                                            HWND hwndNotebook)
{
    /* XFldSystemData *somThis = XFldSystemGetData(somSelf); */
    XFldSystemMethodDebug("XFldSystem","xfsys_wpAddTitleConfirmationPage");

    return (SETTINGS_PAGE_REMOVED);
    /* return (XFldSystem_parent_WPSystem_wpAddTitleConfirmationPage(somSelf,
                                                                  hwndNotebook)); */
}

/*
 * wpAddSystemInputPage:
 *                this instance method is overridden in order
 *                to add the new XFolder page after the default
 *                "Window" page in the settings notebook
 */

SOM_Scope ULONG  SOMLINK xfsys_wpAddSystemInputPage(XFldSystem *somSelf,
                                                     HWND hwndNotebook)
{
    ULONG       ulRC;
    // XFldSystemData *somThis = XFldSystemGetData(somSelf);
    XFldSystemMethodDebug("XFldSystem","xfsys_wpAddSystemWindowPage");


    ulRC = XFldSystem_parent_WPSystem_wpAddSystemInputPage(somSelf, hwndNotebook);

    _xfAddXFldSystemPages(somSelf, hwndNotebook);

    return (ulRC);
}

/********************************************************************
 *                                                                  *
 *   here come the various setting dlg procedures                   *
 *                                                                  *
 ********************************************************************/

/*
 * About the settings dialog functions:
 *      Although the methods which insert the various settings
 *      notebook pages specify a different dialog function for
 *      each page, most of these then call the common dialog
 *      function, fnwpSettingsDlgCommon below, but give a constant
 *      to this common function, which specifies the settings page
 *      currently being worked on. fnwpSettingsDlgCommon then
 *      differentiates according to this constant (usSettingsPage)
 *      when neccessary.
 *
 *      fnwpSettingsDlgCommon calls the following functions for
 *      certain actions (coded below):
 *          dlgReadSettingsFromControls for updating the settings
 *                  in memory and the INI files when neccessary;
 *          dlgEnableControls for enabling / disabling controls
 *                  when they should not be accessible;
 *          dlgSetControlsFromSettings for initially setting the
 *                  controls according to the present settings.
 */

// BYTE        CurrentSettingsPage = 1;

// space for backups (UNDO button)
GLOBALSETTINGS          GlobalSettingsBackup;
CHAR                    szDefaultTitleBackup[DEFAULTTITLELENGTH];
CHAR                    szLanguageCodeBackup[LANGUAGECODELENGTH];
XFLDACC                 XFldAccsBackup[XFLDACCSLIMIT];

CHAR                    szSBTextNoneSelBackup[CCHMAXMNEMONICS],
                        szSBText1SelBackup[CCHMAXMNEMONICS],
                        szSBTextMultiSelBackup[CCHMAXMNEMONICS],
                        szSBClassSelected[256];
SOMClass                *pSBClassObjectSelected = NULL;
somId                   somidClassSelected;

// definitions for "Select Class" dialog for status bars
MRESULT EXPENTRY fncbStatusBarReturnClassAttr(HWND hwndCnr, ULONG ulscd,
                    MPARAM mpwps, MPARAM mpreccParent);

MRESULT EXPENTRY fncbStatusBarClassSelected(HWND hwndCnr,  ULONG ulNLSStrings,
                    MPARAM mpwps, MPARAM mphwndInfo);

// struct passed to callbacks
typedef struct _STATUSBARSELECTCLASS {
    HWND            hwndOKButton;
    PNLSSTRINGS     pNLSStrings;
} STATUSBARSELECTCLASS, *PSTATUSBARSELECTCLASS;

/*
 * dlgReadSettingsFromControls:
 *          this routine is called by fnwpSettingsDlgCommon
 *          and reads the status of the dialog items
 *          on the "CurrentSettingsPage" and updates
 *          GlobalSettings accordingly
 */

VOID dlgReadSettingsFromControls(HWND hwndDlg, USHORT usSettingsPage)
{
    LONG   lTemp = 0;
    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();

    #ifdef DEBUG_SETTINGS
        _Pmpf(("dlgReadSettingsFromControls, page: %d\n",
            usSettingsPage));
    #endif

    switch (usSettingsPage) {
        case SP_1GENERIC: {
            pGlobalSettings->ShowInternals = WinIsDlgItemChecked(hwndDlg, ID_XSDI_ADDINTERNALS);

            pGlobalSettings->ReplIcons = WinIsDlgItemChecked(hwndDlg, ID_XSDI_REPLICONS);
            pGlobalSettings->FullPath  = WinIsDlgItemChecked(hwndDlg, ID_XSDI_FULLPATH);
            pGlobalSettings->KeepTitle = WinIsDlgItemChecked(hwndDlg, ID_XSDI_KEEPTITLE);

            pGlobalSettings->TreeViewAutoScroll = WinIsDlgItemChecked(hwndDlg, ID_XSDI_TREEVIEWAUTOSCROLL);

            WinSendDlgItemMsg(hwndDlg, ID_XSDI_MAXPATHCHARS,
                  SPBM_QUERYVALUE,    //
                  (MPARAM)&lTemp,
                  MPFROM2SHORT(0, SPBQ_ALWAYSUPDATE));
            pGlobalSettings->MaxPathChars = lTemp;
        break; }

        case SP_2REMOVEITEMS: {
            pGlobalSettings->DefaultMenuItems = 0;
            if (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_HELP)))
                pGlobalSettings->DefaultMenuItems |= CTXT_HELP;
            if (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_CRANOTHER)))
                pGlobalSettings->DefaultMenuItems |= CTXT_CRANOTHER;
            if (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_COPY)))
                pGlobalSettings->DefaultMenuItems |= CTXT_COPY;
            if (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_MOVE)))
                pGlobalSettings->DefaultMenuItems |= CTXT_MOVE;
            if (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_SHADOW)))
                pGlobalSettings->DefaultMenuItems |= CTXT_SHADOW;
            if (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_DELETE)))
                pGlobalSettings->DefaultMenuItems |= CTXT_DELETE;
            if (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_PICKUP)))
                pGlobalSettings->DefaultMenuItems |= CTXT_PICKUP;
            if (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_FIND)))
                pGlobalSettings->DefaultMenuItems |= CTXT_FIND;
            if (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_SELECT)))
                pGlobalSettings->DefaultMenuItems |= CTXT_SELECT;
            if (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_SORT)))
                pGlobalSettings->DefaultMenuItems |= CTXT_SORT;
            if (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_ARRANGE)))
                pGlobalSettings->DefaultMenuItems |= CTXT_ARRANGE;
            if (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_PRINT)))
                pGlobalSettings->DefaultMenuItems |= CTXT_PRINT;

            pGlobalSettings->RemoveView = (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_WARP4DISPLAY)));
            pGlobalSettings->RemoveInsert = (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_INSERT)));
            pGlobalSettings->RemoveLockInPlace = (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_LOCKINPLACE)));
            pGlobalSettings->RemoveCheckDisk   = (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_CHECKDISK)));
            pGlobalSettings->RemoveFormatDisk  = (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_FORMATDISK)));

        break; }

        case SP_25ADDITEMS: {
            pGlobalSettings->ExtendSettings = WinIsDlgItemChecked(hwndDlg, ID_XSDI_EXTENDSETTINGS);
            pGlobalSettings->CopyFilename = WinIsDlgItemChecked(hwndDlg, ID_XSDI_COPYFILENAME);
            pGlobalSettings->Move4Refresh = WinIsDlgItemChecked(hwndDlg, ID_XSDI_MOVE4REFRESH);
            pGlobalSettings->SelectSome   = WinIsDlgItemChecked(hwndDlg, ID_XSDI_SELECTSOME);
            pGlobalSettings->FolderContent  = WinIsDlgItemChecked(hwndDlg, ID_XSDI_FOLDERCONTENT);
            pGlobalSettings->FCShowIcons    = WinIsDlgItemChecked(hwndDlg, ID_XSDI_FC_SHOWICONS );
        break; }

        case SP_26CONFIGITEMS: {
            pGlobalSettings->Cascade   = WinIsDlgItemChecked(hwndDlg, ID_XSDI_CASCADE);
            pGlobalSettings->RemoveX   = WinIsDlgItemChecked(hwndDlg, ID_XSDI_REMOVEX);
            pGlobalSettings->AppdParam = WinIsDlgItemChecked(hwndDlg, ID_XSDI_APPDPARAM);

            // "create from templates" settings
            if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_TPL_DONOTHING))
                pGlobalSettings->OpenSettings = 0;
            else if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_TPL_EDITTITLE))
                pGlobalSettings->OpenSettings = BM_INDETERMINATE;
            else
                pGlobalSettings->OpenSettings = BM_CHECKED;

            pGlobalSettings->TplPosition = WinIsDlgItemChecked(hwndDlg, ID_XSDI_TPL_POSITION);
        break; }

        case SP_27STATUSBAR: {
            pGlobalSettings->StatusBar    = WinIsDlgItemChecked(hwndDlg, ID_XSDI_ENABLESTATUSBAR);

            pGlobalSettings->SBForViews = 0;
            if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_SBFORICONVIEWS))
                pGlobalSettings->SBForViews |= SBV_ICON;
            if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_SBFORTREEVIEWS))
                pGlobalSettings->SBForViews |= SBV_TREE;
            if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_SBFORDETAILSVIEWS))
                pGlobalSettings->SBForViews |= SBV_DETAILS;

            if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_SBSTYLE_3RAISED))
                pGlobalSettings->SBStyle = SBSTYLE_WARP3RAISED;
            else if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_SBSTYLE_3SUNKEN))
                pGlobalSettings->SBStyle = SBSTYLE_WARP3SUNKEN;
            else if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_SBSTYLE_4RECT))
                pGlobalSettings->SBStyle = SBSTYLE_WARP4RECT;
            else
                pGlobalSettings->SBStyle = SBSTYLE_WARP4MENU;
        break; }

        case SP_28STATUSBAR2: {
            CHAR szDummy[CCHMAXMNEMONICS];
            WinQueryDlgItemText(hwndDlg, ID_XSDI_SBTEXTNONESEL,
                            sizeof(szDummy)-1, szDummy);
            cmnSetStatusBarSetting(SBS_TEXTNONESEL, szDummy);

            if (pSBClassObjectSelected == NULL) {
                somidClassSelected = somIdFromString(szSBClassSelected);
                if (somidClassSelected) {
                    // get pointer to class object (e.g. M_WPObject)
                    pSBClassObjectSelected = _somFindClass(SOMClassMgrObject, somidClassSelected, 0, 0);
                }
            }
            if (pSBClassObjectSelected) {
                WinQueryDlgItemText(hwndDlg, ID_XSDI_SBTEXT1SEL,
                                sizeof(szDummy)-1, szDummy);
                _xfclsSetStatusBarMnemonics(pSBClassObjectSelected,
                                szDummy);
            }

            WinQueryDlgItemText(hwndDlg, ID_XSDI_SBTEXTMULTISEL,
                            sizeof(szDummy)-1, szDummy);
            cmnSetStatusBarSetting(SBS_TEXTMULTISEL, szDummy);
        break; }

        case SP_3SNAPTOGRID: {
            pGlobalSettings->SnapToGrid  = WinIsDlgItemChecked(hwndDlg, ID_XSDI_SNAPTOGRID);

            // spin buttons
            WinSendDlgItemMsg(hwndDlg, ID_XSDI_GRID_X,
                  SPBM_QUERYVALUE,    //
                  (MPARAM)&lTemp,
                  MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));
            pGlobalSettings->GridX = lTemp;

            WinSendDlgItemMsg(hwndDlg, ID_XSDI_GRID_Y,
                  SPBM_QUERYVALUE,    //
                  (MPARAM)&lTemp,
                  MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));
            pGlobalSettings->GridY = lTemp;

            WinSendDlgItemMsg(hwndDlg, ID_XSDI_GRID_CX,
                  SPBM_QUERYVALUE,    //
                  (MPARAM)&lTemp,
                  MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));
            pGlobalSettings->GridCX = lTemp;

            WinSendDlgItemMsg(hwndDlg, ID_XSDI_GRID_CY,
                  SPBM_QUERYVALUE,    //
                  (MPARAM)&lTemp,
                  MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));
            pGlobalSettings->GridCY = lTemp;

        break; }

        case SP_4ACCELERATORS: {
            pGlobalSettings->Accelerators = WinIsDlgItemChecked(hwndDlg, ID_XSDI_ACCELERATORS);
            // the listbox is handled directly
        break; }

        case SP_5INTERNALS: {
            LONG   lTemp2 = 0;
            CHAR   szTemp[200], szTemp2[10];
            PSZ    p;

            pGlobalSettings->NoWorkerThread  = WinIsDlgItemChecked(hwndDlg, ID_XSDI_NOWORKERTHREAD);
            pGlobalSettings->NoSubclassing   = WinIsDlgItemChecked(hwndDlg, ID_XSDI_NOSUBCLASSING);
            pGlobalSettings->ShowXFolderAnim = WinIsDlgItemChecked(hwndDlg, ID_XSDI_XFOLDERANIMATION);

            WinQueryDlgItemText(hwndDlg, ID_XSDI_LANGUAGE,
                sizeof(szTemp),
                szTemp);
            p = stristr(szTemp, " -- XFLDR")+9; // my own case-insensitive routine
            if (p) {
                strncpy(szTemp2, p, 3);
                szTemp2[4] = '\0';
                cmnSetLanguageCode(szTemp2);
            }

            WinSendDlgItemMsg(hwndDlg, ID_XSDI_VARMENUOFFSET,
                  SPBM_QUERYVALUE,
                  (MPARAM)&lTemp2,
                  MPFROM2SHORT(0, SPBQ_ALWAYSUPDATE));
            pGlobalSettings->VarMenuOffset = lTemp2;

            WinQueryDlgItemText(hwndDlg, ID_XSDI_DEFAULTTITLE,
                             sizeof(szTemp),
                             szTemp);
            _xfclsSetDefaultTitle(_XFolder, szTemp);
        break; }

        case SP_DTP1: {
            pGlobalSettings->XShutdown = 0;
            if (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_DTM_SYSTEMSETUP)))
                pGlobalSettings->XShutdown |= XSD_DTM_SYSTEMSETUP;
            if (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_DTM_LOCKUP)))
                pGlobalSettings->XShutdown |= XSD_DTM_LOCKUP;
            if (!(WinIsDlgItemChecked(hwndDlg, ID_XSDI_DTM_SHUTDOWN)))
                pGlobalSettings->XShutdown |= XSD_DTM_SHUTDOWN;

            if WinIsDlgItemChecked(hwndDlg, ID_XSDI_SD_RESTARTWPS)
                pGlobalSettings->XShutdown |= XSD_RESTARTWPS;
            if WinIsDlgItemChecked(hwndDlg, ID_XSDI_SD_ENABLED)
                pGlobalSettings->XShutdown |= XSD_ENABLED;
            if WinIsDlgItemChecked(hwndDlg, ID_XSDI_SD_REBOOT)
                pGlobalSettings->XShutdown |= XSD_REBOOT;
            if WinIsDlgItemChecked(hwndDlg, ID_XSDI_SD_ANIMATE)
                pGlobalSettings->XShutdown |= XSD_ANIMATE;
            if WinIsDlgItemChecked(hwndDlg, ID_XSDI_SD_APMPOWEROFF)
                pGlobalSettings->XShutdown |= XSD_APMPOWEROFF;
            if WinIsDlgItemChecked(hwndDlg, ID_XSDI_SD_CONFIRM)
                pGlobalSettings->XShutdown |= XSD_CONFIRM;
            if WinIsDlgItemChecked(hwndDlg, ID_XSDI_SD_AUTOCLOSEVIO)
                pGlobalSettings->XShutdown |= XSD_AUTOCLOSEVIO;
            if WinIsDlgItemChecked(hwndDlg, ID_XSDI_SD_LOG)
                pGlobalSettings->XShutdown |= XSD_LOG;
        break; }

        case SP_DTP2: {
            pGlobalSettings->ShowStartupProgress =
                WinIsDlgItemChecked(hwndDlg, ID_XSDI_SD_SHOWSTARTUPPROGRESS);
            WinSendDlgItemMsg(hwndDlg, ID_XSDI_SD_STARTUPDELAY,
                  SPBM_QUERYVALUE,    //
                  (MPARAM)&lTemp,
                  MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));
            pGlobalSettings->StartupDelay = lTemp;
        break; }

        case SP_FILEOPS: {
            pGlobalSettings->ReplConfirms   = WinIsDlgItemChecked(hwndDlg, ID_XSDI_REPLCONFIRMS);
            pGlobalSettings->CleanupINIs    = WinIsDlgItemChecked(hwndDlg, ID_XSDI_CLEANUPINIS);
        break; }

    } // end switch;
}

/*
 * dlgSetControlsFromSettings:
 *          this routine is called by fnwpSettingsDlgCommon
 *          and sets the items in the note book page defined
 *          in CurrentSettingsPage according to the settings, which
 *          are read from OS2.INI, if (UseINI)
 */

VOID dlgSetControlsFromSettings(HWND hwndDlg, USHORT usSettingsPage, BOOL UseINI)
{
    // ULONG       ulCopied1; // , ulCopied2;
    PGLOBALSETTINGS pGlobalSettings;

    #ifdef DEBUG_SETTINGS
        _Pmpf(("dlgSetControlsFromSettings, page: %d, UseINI: %s\n",
            usSettingsPage, (UseINI ? "TRUE" : "FALSE")));
    #endif

    if (UseINI)
        cmnLoadGlobalSettings();

    pGlobalSettings = cmnQueryGlobalSettings();
    #ifdef DEBUG_SETTINGS
        _Pmpf(("  pGlobalSettings: %lX\n", pGlobalSettings));
    #endif

     // now set the dlg data according to settings
    switch (usSettingsPage) {
        case SP_1GENERIC: {
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_ADDINTERNALS, pGlobalSettings->ShowInternals);

            WinSetDlgItemChecked(hwndDlg, ID_XSDI_REPLICONS, pGlobalSettings->ReplIcons);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_FULLPATH, pGlobalSettings->FullPath);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_KEEPTITLE, pGlobalSettings->KeepTitle);

            // maximum path chars spin button
            WinSetDlgItemSpinData(hwndDlg, ID_XSDI_MAXPATHCHARS, 11, 200, pGlobalSettings->MaxPathChars);

            WinSetDlgItemChecked(hwndDlg, ID_XSDI_TREEVIEWAUTOSCROLL, pGlobalSettings->TreeViewAutoScroll);
        break; }

        case SP_2REMOVEITEMS: {
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_HELP  , (pGlobalSettings->DefaultMenuItems & CTXT_HELP) == 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_CRANOTHER, (pGlobalSettings->DefaultMenuItems & CTXT_CRANOTHER) == 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_COPY  , (pGlobalSettings->DefaultMenuItems & CTXT_COPY     ) == 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_MOVE  , (pGlobalSettings->DefaultMenuItems & CTXT_MOVE     ) == 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SHADOW, (pGlobalSettings->DefaultMenuItems & CTXT_SHADOW   ) == 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_DELETE, (pGlobalSettings->DefaultMenuItems & CTXT_DELETE   ) == 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_PICKUP, (pGlobalSettings->DefaultMenuItems & CTXT_PICKUP   ) == 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_FIND  , (pGlobalSettings->DefaultMenuItems & CTXT_FIND     ) == 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SELECT, (pGlobalSettings->DefaultMenuItems & CTXT_SELECT   ) == 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SORT  , (pGlobalSettings->DefaultMenuItems & CTXT_SORT     ) == 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_ARRANGE, (pGlobalSettings->DefaultMenuItems & CTXT_ARRANGE ) == 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_PRINT  , (pGlobalSettings->DefaultMenuItems & CTXT_PRINT   ) == 0);

            WinSetDlgItemChecked(hwndDlg, ID_XSDI_WARP4DISPLAY, !pGlobalSettings->RemoveView);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_INSERT, !pGlobalSettings->RemoveInsert);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_LOCKINPLACE, !pGlobalSettings->RemoveLockInPlace);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_CHECKDISK, !pGlobalSettings->RemoveCheckDisk);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_FORMATDISK, !pGlobalSettings->RemoveFormatDisk);
        break; }

        case SP_25ADDITEMS: {
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_EXTENDSETTINGS, pGlobalSettings->ExtendSettings);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_MOVE4REFRESH, pGlobalSettings->Move4Refresh);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_COPYFILENAME, pGlobalSettings->CopyFilename);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SELECTSOME,   pGlobalSettings->SelectSome);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_FOLDERCONTENT, pGlobalSettings->FolderContent);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_FC_SHOWICONS, pGlobalSettings->FCShowIcons);
        break; }

        case SP_26CONFIGITEMS: {
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_CASCADE, pGlobalSettings->Cascade);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_REMOVEX, pGlobalSettings->RemoveX);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_APPDPARAM, pGlobalSettings->AppdParam);

            switch (pGlobalSettings->OpenSettings) {
                case 0:  WinSetDlgItemChecked(hwndDlg, ID_XSDI_TPL_DONOTHING, 1); break;
                case 1:  WinSetDlgItemChecked(hwndDlg, ID_XSDI_TPL_OPENSETTINGS, 1); break;
                default:  WinSetDlgItemChecked(hwndDlg, ID_XSDI_TPL_EDITTITLE, 1); break;
            }
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_TPL_POSITION, pGlobalSettings->TplPosition);
        break; }

        case SP_27STATUSBAR: {
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_ENABLESTATUSBAR,
                            pGlobalSettings->StatusBar);

            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SBFORICONVIEWS,
                            (pGlobalSettings->SBForViews & SBV_ICON) != 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SBFORTREEVIEWS,
                            (pGlobalSettings->SBForViews & SBV_TREE) != 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SBFORDETAILSVIEWS,
                            (pGlobalSettings->SBForViews & SBV_DETAILS) != 0);

            if (pGlobalSettings->SBStyle == SBSTYLE_WARP3RAISED)
                WinSetDlgItemChecked(hwndDlg, ID_XSDI_SBSTYLE_3RAISED, TRUE);
            else if (pGlobalSettings->SBStyle == SBSTYLE_WARP3SUNKEN)
                WinSetDlgItemChecked(hwndDlg, ID_XSDI_SBSTYLE_3SUNKEN, TRUE);
            else if (pGlobalSettings->SBStyle == SBSTYLE_WARP4RECT)
                WinSetDlgItemChecked(hwndDlg, ID_XSDI_SBSTYLE_4RECT, TRUE);
            else
                WinSetDlgItemChecked(hwndDlg, ID_XSDI_SBSTYLE_4MENU, TRUE);
        break; }

        case SP_28STATUSBAR2: {
            CHAR    szTemp[CCHMAXMNEMONICS];

            WinSetDlgItemText(hwndDlg, ID_XSDI_SBCURCLASS, szSBClassSelected);

            // descriptive status bar strings
            WinSendDlgItemMsg(hwndDlg, ID_XSDI_SBTEXTNONESEL, EM_SETTEXTLIMIT,
                (MPARAM)(CCHMAXMNEMONICS-1), MPNULL);
            WinSetDlgItemText(hwndDlg, ID_XSDI_SBTEXTNONESEL ,
                cmnQueryStatusBarSetting(SBS_TEXTNONESEL));

            WinSendDlgItemMsg(hwndDlg, ID_XSDI_SBTEXT1SEL, EM_SETTEXTLIMIT,
                (MPARAM)(CCHMAXMNEMONICS-1), MPNULL);
            if (pSBClassObjectSelected == NULL) {
                somidClassSelected = somIdFromString(szSBClassSelected);
                if (somidClassSelected) {
                    // get pointer to class object (e.g. M_WPObject)
                    pSBClassObjectSelected = _somFindClass(SOMClassMgrObject, somidClassSelected, 0, 0);
                }
            }

            if (pSBClassObjectSelected) {
                _xfclsQueryStatusBarMnemonics(pSBClassObjectSelected,
                        szTemp,
                        sizeof(szTemp));
                WinSetDlgItemText(hwndDlg, ID_XSDI_SBTEXT1SEL, szTemp);
            }

            WinSendDlgItemMsg(hwndDlg, ID_XSDI_SBTEXTMULTISEL, EM_SETTEXTLIMIT,
                (MPARAM)(CCHMAXMNEMONICS-1), MPNULL);
            WinSetDlgItemText(hwndDlg, ID_XSDI_SBTEXTMULTISEL,
                cmnQueryStatusBarSetting(SBS_TEXTMULTISEL));

        break; }

        case SP_3SNAPTOGRID: {
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SNAPTOGRID, pGlobalSettings->SnapToGrid);
            WinSetDlgItemSpinData(hwndDlg, ID_XSDI_GRID_X, 0, 500, pGlobalSettings->GridX);
            WinSetDlgItemSpinData(hwndDlg, ID_XSDI_GRID_Y, 0, 500, pGlobalSettings->GridY);
            WinSetDlgItemSpinData(hwndDlg, ID_XSDI_GRID_CX, 1, 500, pGlobalSettings->GridCX);
            WinSetDlgItemSpinData(hwndDlg, ID_XSDI_GRID_CY, 1, 500, pGlobalSettings->GridCY);
        break; }

        case SP_4ACCELERATORS: {
            SHORT i;

            WinSetDlgItemChecked(hwndDlg, ID_XSDI_ACCELERATORS, pGlobalSettings->Accelerators);

            WinSendDlgItemMsg(hwndDlg, ID_XSDI_LISTBOX, LM_DELETEALL, 0, 0);
            WinSetDlgItemText(hwndDlg, ID_XSDI_DESCRIPTION, "");

            for (i = 0; i < LBENTRYCOUNT; i++)
            {
                if (szLBEntries[i])
                {
                    WinSendDlgItemMsg(hwndDlg, ID_XSDI_LISTBOX,
                        LM_INSERTITEM,
                        (MPARAM)LIT_SORTASCENDING,
                        (MPARAM)szLBEntries[i]);
                }
                else break;
            }
        break; }

        case SP_5INTERNALS: {
            CHAR          szSearchMask[CCHMAXPATH];
            HDIR          hdirFindHandle = HDIR_SYSTEM;
            FILEFINDBUF3  FindBuffer     = {0};      // Returned from FindFirst/Next
            ULONG         ulResultBufLen = sizeof(FILEFINDBUF3);
            ULONG         ulFindCount    = 1;        // Look for 1 file at a time
            APIRET        rc             = NO_ERROR; // Return code
            ULONG         ulCopied;

            // variable menu ID offset spin button
            WinSetDlgItemSpinData(hwndDlg, ID_XSDI_VARMENUOFFSET, 100, 2000, pGlobalSettings->VarMenuOffset);

            // default class title entry field
            WinSetDlgItemText(hwndDlg, ID_XSDI_DEFAULTTITLE,
                             _wpclsQueryTitle(_XFolder));

            WinSetDlgItemChecked(hwndDlg, ID_XSDI_NOWORKERTHREAD, pGlobalSettings->NoWorkerThread);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_NOSUBCLASSING,  pGlobalSettings->NoSubclassing);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_XFOLDERANIMATION,  pGlobalSettings->ShowXFolderAnim);

            // language drop-down box
            WinSendDlgItemMsg(hwndDlg, ID_XSDI_LANGUAGE, LM_DELETEALL, 0, 0);

            ulCopied = cmnQueryXFolderBasePath(szSearchMask, sizeof(szSearchMask));
            if (ulCopied) {
                strcat(szSearchMask, "\\bin\\xfldr*.dll");

                #ifdef DEBUG_SETTINGS
                    _Pmpf(("  szSearchMask: %s\n", szSearchMask));
                    _Pmpf(("  DosFindFirst\n"));
                #endif
                rc = DosFindFirst( szSearchMask,          // File pattern
                                    &hdirFindHandle,      // Directory search handle
                                    FILE_NORMAL,          // Search attribute
                                    &FindBuffer,          // Result buffer
                                    ulResultBufLen,       // Result buffer length
                                    &ulFindCount,         // Number of entries to find
                                    FIL_STANDARD);        // Return level 1 file info

                if (rc != NO_ERROR) {
                    DebugBox("XFolder", "XFolder was unable to find any National Language Support DLLs. You need to re-install XFolder.");
                    break;
                } // else continue

                #ifdef DEBUG_SETTINGS
                    _Pmpf(("  Adding: %s\n", FindBuffer.achName));
                #endif
                cmnAddResourceDLLToLB(hwndDlg, ID_XSDI_LANGUAGE, FindBuffer.achName);

                // Keep finding the next file until there are no more files
                while (rc != ERROR_NO_MORE_FILES) {
                    ulFindCount = 1;                      // Reset find count.

                    rc = DosFindNext(hdirFindHandle,      // Directory handle
                                     &FindBuffer,         // Result buffer
                                     ulResultBufLen,      // Result buffer length
                                     &ulFindCount);       // Number of entries to find

                    if (rc == NO_ERROR) {
                        cmnAddResourceDLLToLB(hwndDlg, ID_XSDI_LANGUAGE, FindBuffer.achName);
                        #ifdef DEBUG_SETTINGS
                            _Pmpf(("  Found next: %s\n", FindBuffer.achName));
                        #endif
                    }
                } // endwhile

                rc = DosFindClose(hdirFindHandle);    // close our find handle
                if (rc != NO_ERROR) {
                    DebugBox("XFolder", "DosFindClose error");
                }

                #ifdef DEBUG_SETTINGS
                    _Pmpf(("  Selecting: %s\n", cmnQueryLanguageCode()));
                #endif
                WinSendDlgItemMsg(hwndDlg, ID_XSDI_LANGUAGE,
                    LM_SELECTITEM,
                    WinSendDlgItemMsg(hwndDlg, ID_XSDI_LANGUAGE, // find matching item
                        LM_SEARCHSTRING,
                        MPFROM2SHORT(LSS_SUBSTRING, LIT_FIRST),
                        (MPARAM)cmnQueryLanguageCode()),
                    (MPARAM)TRUE); // select
            }
        break; }

        case SP_DTP1: {
            CHAR szAPMVersion[30];
            sprintf(szAPMVersion, "APM %s", apmQueryVersion());
            WinSetDlgItemText(hwndDlg, ID_XSDI_SD_APMVERSION, szAPMVersion);

            WinSetDlgItemChecked(hwndDlg, ID_XSDI_DTM_SYSTEMSETUP,
                (pGlobalSettings->XShutdown & XSD_DTM_SYSTEMSETUP) == 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_DTM_LOCKUP  ,
                (pGlobalSettings->XShutdown & XSD_DTM_LOCKUP) == 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_DTM_SHUTDOWN,
                (pGlobalSettings->XShutdown & XSD_DTM_SHUTDOWN) == 0);

            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SD_RESTARTWPS,
                (pGlobalSettings->XShutdown & XSD_RESTARTWPS) != 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SD_ENABLED,
                (pGlobalSettings->XShutdown & XSD_ENABLED) != 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SD_REBOOT,
                (pGlobalSettings->XShutdown & XSD_REBOOT) != 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SD_ANIMATE,
                (pGlobalSettings->XShutdown & XSD_ANIMATE) != 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SD_APMPOWEROFF,
                (apmPowerOffSupported())
                    ? ((pGlobalSettings->XShutdown & XSD_APMPOWEROFF) != 0)
                    : FALSE
                );
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SD_CONFIRM,
                (pGlobalSettings->XShutdown & XSD_CONFIRM) != 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SD_AUTOCLOSEVIO,
                (pGlobalSettings->XShutdown & XSD_AUTOCLOSEVIO) != 0);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SD_LOG,
                (pGlobalSettings->XShutdown & XSD_LOG) != 0);
        break; }

        case SP_DTP2: {
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SD_SHOWSTARTUPPROGRESS,
                pGlobalSettings->ShowStartupProgress);
            WinSetDlgItemSpinData(hwndDlg, ID_XSDI_SD_STARTUPDELAY, 500, 10000, pGlobalSettings->StartupDelay);
        break; }

        case SP_FILEOPS: {
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_CLEANUPINIS,    pGlobalSettings->CleanupINIs);
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_REPLCONFIRMS,   pGlobalSettings->ReplConfirms);
        break; }
    } // end switch;
    #ifdef DEBUG_SETTINGS
        _Pmpf(("End dlgSetControlsFromSettings\n"));
    #endif
}

/*
 * dlgEnableControls:
 *      this routine is called by fnwpSettingsDlgCommon
 *      for every settings page for enabling /
 *      disabling controls
 */

VOID dlgEnableControls(HWND hwndDlg, USHORT usSettingsPage)
{
    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();

    #ifdef DEBUG_SETTINGS
        _Pmpf(("dlgEnableControls, page: %d\n", usSettingsPage));
    #endif

    switch (usSettingsPage) {
        case SP_1GENERIC: {
            WinEnableDlgItem(hwndDlg, ID_XSDI_TREEVIEWAUTOSCROLL, !(pGlobalSettings->NoWorkerThread));
        break; }

        case SP_2REMOVEITEMS: {
        break; }

        case SP_25ADDITEMS: {
            WinEnableDlgItem(hwndDlg, ID_XSDI_FOLDERCONTENT, !(pGlobalSettings->NoSubclassing));
            WinEnableDlgItem(hwndDlg, ID_XSDI_FC_SHOWICONS,  !(pGlobalSettings->NoSubclassing));
        break; }

        case SP_26CONFIGITEMS: {
        break; }

        case SP_27STATUSBAR: {
            WinEnableDlgItem(hwndDlg, ID_XSDI_ENABLESTATUSBAR, !(pGlobalSettings->NoSubclassing));
            WinEnableDlgItem(hwndDlg, ID_XSDI_SBSTYLE_3RAISED, !(pGlobalSettings->NoSubclassing));
            WinEnableDlgItem(hwndDlg, ID_XSDI_SBSTYLE_3SUNKEN, !(pGlobalSettings->NoSubclassing));
            WinEnableDlgItem(hwndDlg, ID_XSDI_SBSTYLE_4MENU,   !(pGlobalSettings->NoSubclassing));
            WinEnableDlgItem(hwndDlg, ID_XSDI_SBSTYLE_4RECT,   !(pGlobalSettings->NoSubclassing));
        break; }

        case SP_28STATUSBAR2: {
            WinEnableDlgItem(hwndDlg, ID_XSDI_SBTEXTNONESEL,   !(pGlobalSettings->NoSubclassing));
            WinEnableDlgItem(hwndDlg, ID_XSDI_SBTEXT1SEL,      !(pGlobalSettings->NoSubclassing));
            WinEnableDlgItem(hwndDlg, ID_XSDI_SBTEXTMULTISEL,  !(pGlobalSettings->NoSubclassing));
        break; }

        case SP_3SNAPTOGRID: {
        break; }

        case SP_4ACCELERATORS: {
            if (pGlobalSettings->NoSubclassing) {
                WinEnableDlgItem(hwndDlg, ID_XSDI_ACCELERATORS, FALSE);
                WinEnableDlgItem(hwndDlg, ID_XSDI_LISTBOX, FALSE);
                WinEnableDlgItem(hwndDlg, ID_XSDI_CLEARACCEL, FALSE);
            }
        break; }

        case SP_5INTERNALS: {
        break; }

        case SP_DTP1: {
            BOOL fXShutdownValid =
                    (   ((pGlobalSettings->XShutdown & XSD_DTM_SHUTDOWN) == 0)
                     && (pGlobalSettings->NoWorkerThread == 0)
                    );
            BOOL fXShutdownEnabled =
                    (   (fXShutdownValid)
                     && (pGlobalSettings->XShutdown & XSD_ENABLED)
                    );
            BOOL fXShutdownOrWPSValid =
                    (   (   ((pGlobalSettings->XShutdown & (XSD_DTM_SHUTDOWN | XSD_ENABLED)) == XSD_ENABLED)
                         || (pGlobalSettings->XShutdown & XSD_RESTARTWPS)
                        )
                     && (pGlobalSettings->NoWorkerThread == 0)
                    );

            WinEnableDlgItem(hwndDlg, ID_XSDI_SD_ENABLED, fXShutdownValid);
            WinEnableDlgItem(hwndDlg, ID_XSDI_SD_REBOOT,  fXShutdownEnabled);
            WinEnableDlgItem(hwndDlg, ID_XSDI_SD_REBOOTEXT, fXShutdownEnabled);
            WinEnableDlgItem(hwndDlg, ID_XSDI_SD_ANIMATE, fXShutdownEnabled);
            WinEnableDlgItem(hwndDlg, ID_XSDI_SD_APMPOWEROFF,
                        ( fXShutdownEnabled && (apmPowerOffSupported()) )
                    );

            WinEnableDlgItem(hwndDlg, ID_XSDI_SD_CONFIRM, fXShutdownOrWPSValid);
            WinEnableDlgItem(hwndDlg, ID_XSDI_SD_AUTOCLOSEVIO, fXShutdownOrWPSValid);
            WinEnableDlgItem(hwndDlg, ID_XSDI_SD_AUTOCLOSEDETAILS, fXShutdownOrWPSValid);
            WinEnableDlgItem(hwndDlg, ID_XSDI_SD_LOG, fXShutdownOrWPSValid);
        break; }

        case SP_DTP2: {
            WinEnableDlgItem(hwndDlg, ID_XSDI_SD_SHOWSTARTUPPROGRESS,
                    (   (pGlobalSettings->NoWorkerThread == 0)
                     && (pGlobalSettings->NoSubclassing == 0)
                    )
                );
            WinEnableDlgItem(hwndDlg, ID_XSDI_SD_STARTUPDELAY,
                    (   (pGlobalSettings->NoWorkerThread == 0)
                     && (pGlobalSettings->NoSubclassing == 0)
                    )
                );
        break; }
    } // end switch;
}

/*
 * dlgItemChanged:
 *      this allows you to react to changes for certain controls;
 *      it is called upon receiving WM_CONTROL or WM_COMMAND; the
 *      respective item ID is passed in ulItemChanged. For most
 *      controls, this func will then call dlgReadSettingsFromControls.
 */

VOID dlgItemChanged(HWND hwndDlg, USHORT usSettingsPage, USHORT usItemChanged, USHORT usNotifyCode)
{
    #ifdef DEBUG_SETTINGS
        _Pmpf(("dlgItemChanged, page: %d\n", usSettingsPage));
    #endif

    switch (usItemChanged) {
        /* upon receiving WM_CONTROL, we might need to save the dialog
           status in the Global Settings and into OS2.INI; this is
           neccessary in the following situations:
           -- a checkbox has been clicked upon;
           -- an entry field loses focus;
           -- a spin button changes its value. */

        case ID_XSDI_DEFAULTTITLE: // "XFolder"
        case ID_XSDI_DESCRIPTION:{ // key description for folder hotkeys
            if (usNotifyCode == EN_KILLFOCUS) {
                dlgReadSettingsFromControls(hwndDlg, usSettingsPage);
                cmnStoreGlobalSettings();
            }
        break; }

        // status bar
        case ID_XSDI_ENABLESTATUSBAR: {
            if (usNotifyCode == BN_CLICKED) {
                dlgReadSettingsFromControls(hwndDlg, usSettingsPage);
                cmnStoreGlobalSettings();
                cmnPostWorkerMsg(WOM_UPDATEALLSTATUSBARS,
                            (MPARAM)1, // show/hide flag
                            MPNULL);
            }
        break; }

        case ID_XSDI_SBSTYLE_3RAISED:
        case ID_XSDI_SBSTYLE_3SUNKEN:
        case ID_XSDI_SBSTYLE_4MENU:
        case ID_XSDI_SBSTYLE_4RECT: {
            if (usNotifyCode == BN_CLICKED) {
                dlgReadSettingsFromControls(hwndDlg, usSettingsPage);
                cmnStoreGlobalSettings();
                cmnPostWorkerMsg(WOM_UPDATEALLSTATUSBARS,
                        (MPARAM)2, // update display
                        MPNULL);
            }
        break; }

        case ID_XSDI_SBTEXTNONESEL:
        case ID_XSDI_SBTEXT1SEL:
        case ID_XSDI_SBTEXTMULTISEL: {
            if (usNotifyCode == EN_KILLFOCUS)
            {
                dlgReadSettingsFromControls(hwndDlg, usSettingsPage);
                cmnStoreGlobalSettings();
                cmnPostWorkerMsg(WOM_UPDATEALLSTATUSBARS,
                        (MPARAM)2, // update display
                        MPNULL);
            }
        break; }

        // folder hotkey from listbox selected
        case ID_XSDI_LISTBOX: {
            if (usNotifyCode == LN_SELECT)
            {
                LONG l;
                CHAR                    szKeyName[200];

                /* if from listbox: update the Edit field with new
                   key description, but do NOT save settings yet */
                l = cmnFindAccIndexFromLBSel(hwndDlg, NULL);
                if (l >= 0L)
                {
                    cmnDescribeKey(szKeyName, XFldAccs[l].usFlags,
                                                  XFldAccs[l].usKeyCode);
                    WinEnableDlgItem(hwndDlg, ID_XSDI_CLEARACCEL, TRUE);
                }
                else { // not found: "not defined"
                    strcpy(szKeyName,
                        (cmnQueryNLSStrings())->pszNotDefined);

                    WinEnableDlgItem(hwndDlg, ID_XSDI_CLEARACCEL, FALSE);
                }

                // set edit field to description text
                WinSetDlgItemText(hwndDlg, ID_XSDI_DESCRIPTION,
                            szKeyName);
                // enable previously disabled items
                WinEnableDlgItem(hwndDlg, ID_XSDI_DESCRIPTION, TRUE);
                WinEnableDlgItem(hwndDlg, ID_XSDI_DESCRIPTION_TX1, TRUE);
            }
        break; }

        // language drop-down box: load/unload resource modules
        case ID_XSDI_LANGUAGE: {
            if (usNotifyCode == LN_SELECT)
            {
                CHAR    szOldLanguageCode[LANGUAGECODELENGTH];

                strcpy(szOldLanguageCode, cmnQueryLanguageCode());

                dlgReadSettingsFromControls(hwndDlg, usSettingsPage);
                cmnStoreGlobalSettings();

                if (strcmp(szOldLanguageCode, cmnQueryLanguageCode()) != 0)
                {
                    // enforce reload of resource DLL
                    if (cmnQueryNLSModuleHandle(
                                TRUE        // reload flag
                       ) == NULLHANDLE)
                    {
                        // error occured loading the module: restore
                        //   old settings
                        cmnSetLanguageCode(szOldLanguageCode);
                        dlgSetControlsFromSettings(hwndDlg,
                            usSettingsPage, TRUE); // load from INI
                    }
                    else {
                        HWND      hwndSystemFrame,
                                  hwndCurrent = hwndDlg;
                        HWND      hwndDesktop = WinQueryDesktopWindow(
                                    WinQueryAnchorBlock(HWND_DESKTOP), NULLHANDLE);

                        // "closing system window"
                        cmnMessageBoxMsg(HWND_DESKTOP,
                                102, 103,
                                MB_OK);

                        // find system object frame window handle
                        while ((hwndCurrent) && (hwndCurrent != hwndDesktop)) {
                            hwndSystemFrame = hwndCurrent;
                            hwndCurrent = WinQueryWindow(hwndCurrent, QW_PARENT);
                        }
                        if (hwndCurrent)
                            WinPostMsg(hwndSystemFrame,
                                WM_SYSCOMMAND,
                                (MPARAM)SC_CLOSE,
                                MPFROM2SHORT(0, 0));
                    }
                } // end if (strcmp(szOldLanguageCode, szLanguageCode) != 0)
            } // end if (usNotifyCode == LN_SELECT)
        break; } // end case ID_XSDI_LANGUAGE

        /* case ID_XSDI_SD_ENABLED: {
            PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
            dlgReadSettingsFromControls(hwndDlg, usSettingsPage);
            cmnStoreGlobalSettings();
            if (pGlobalSettings->XShutdown & XSD_ENABLED)
                DebugBox("XShutdown Warning",
                      "Warning: The XShutdown feature is still in beta stage. The author "
                      "has tested it intensively, but problems may arise on your system, "
                      "depending on your configuration.\nDo not use XShutdown on production "
                      "machines at this development stage.\nIt is also unknown how XShutdown "
                      "reacts on network machines, e.g. if they will log off properly.\n"
                      "Most importantly, make a WPS backup before using this feature, in"
                      "case something does go wrong.");
        break; } */

        case ID_XSDI_FC_SHOWICONS: {
            PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
            dlgReadSettingsFromControls(hwndDlg, usSettingsPage);
            cmnStoreGlobalSettings();
            if (pGlobalSettings->FCShowIcons)
                cmnMessageBoxMsg(hwndDlg, 116, 117, MB_OK);
        break; }

        // full path: update all frame window titles
        case ID_XSDI_FULLPATH:
        case ID_XSDI_KEEPTITLE:
            if (usNotifyCode == BN_CLICKED) {
                dlgReadSettingsFromControls(hwndDlg, usSettingsPage);
                cmnPostWorkerMsg(WOM_REFRESHFOLDERVIEWS,
                        (MPARAM)NULL, // update all, not just children
                        MPNULL);
            }
        break;

        // max path chars spin button lost focus: update also
        case ID_XSDI_MAXPATHCHARS:
            if (usNotifyCode == SPBN_KILLFOCUS) {
                dlgReadSettingsFromControls(hwndDlg, usSettingsPage);
                cmnPostWorkerMsg(WOM_REFRESHFOLDERVIEWS,
                        (MPARAM)NULL, // update all, not just children
                        MPNULL);
            }
        break;

        // snap2grid spin buttons lost focus: update also
        case ID_XSDI_GRID_X:
        case ID_XSDI_GRID_Y:
        case ID_XSDI_GRID_CX:
        case ID_XSDI_GRID_CY:
            if (usNotifyCode == SPBN_KILLFOCUS) {
                #ifdef DEBUG_SETTINGS
                    _Pmpf(("snap2grid spin buttons\n"));
                #endif
                dlgReadSettingsFromControls(hwndDlg, usSettingsPage);
                cmnStoreGlobalSettings();
            }
        break;

        // all other controls: filter out irrelevant notifications;
        // if relevant, update settings
        default:
            if (usNotifyCode == BN_CLICKED) // == SBPN_VALUECHANGED or something like that
            {
                // all other controls -> update settings
                dlgReadSettingsFromControls(hwndDlg, usSettingsPage);
                cmnStoreGlobalSettings();
            }
        break;
    } // end switch
}

/*
 * fnwpSettingsDlgCommon:
 *           common dlg function for all the new settings pages
 *           which deal with the XFolder Global Settings.
 *           XFolder uses _one_ global dlg func for all the notebook
 *           settings pages for the Global Settings to simplify
 *           handling all those WM_COMMAND etc. messages. The
 *           settings page we're actually dealing with is passed
 *           in the usSettingsPage parameter, which is passed to
 *           this function by the "real" dlg funcs just below.
 *           This parameter must be one of the SP_XXX constants
 *           def'd in common.h.
 *           This routine calls the dlgXXX functions above for
 *           certain events.
 */

HWND                    hwndHelp, hwndFocus;

// default help panels for settings pages
ULONG                   DefaultPanelID[ ] = { 0, // there's no page 0
                                                ID_XSH_SETTINGS1,       // XFolder
                                                ID_XSH_SETTINGS1+1,     // Remove items
                                                ID_XSH_SETTINGS1+2,     // Add items
                                                ID_XSH_SETTINGS_CFGM,   // Config folder items
                                                ID_XSH_SETTINGS1+3,     // status bar 1
                                                ID_XSH_SETTINGS1+4,     // snap2grid
                                                ID_XSH_SETTINGS1+5,     // folder hotkeys
                                                ID_XSH_SETTINGS1+6,     // XFolder internals
                                                ID_XSH_SETTINGS_DTP1,   // XDesktop 1
                                                ID_XSH_SETTINGS_DTP1+1, // XDesktop 2
                                                ID_XSH_SETTINGS_SB2,    // status bar 2
                                                ID_XSH_SETTINGS_FILEOPS // file operations
                                            };

MRESULT EXPENTRY fnwpSettingsDlgCommon(HWND hwndDlg, USHORT usSettingsPage,
                        ULONG msg, MPARAM mp1, MPARAM mp2)
{
    MRESULT             mrc = NULL;
    LONG                i;
    HOBJECT             hObj;
    // WPObject            *pObject;
    CHAR                szSetup[1000]; // , szPath[CCHMAXPATH];

    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();

    switch(msg)
    {
        /*
         * WM_INITDLG:
         *      set up the settings page, prepare certain data,
         *      then call dlgSetControlsFromSettings
         */

        case WM_INITDLG: {
            #ifdef DEBUG_SETTINGS
                _Pmpf(("fnwpSettingsDlgCommon, WM_INITDLG, page: %d\n", usSettingsPage));
            #endif

            // save somSelf in window words
            WinSetWindowPtr(hwndDlg, QWL_USER, (SOMAny*)mp2);

            // backup page for UNDO
            GlobalSettingsBackup = *pGlobalSettings;
            strcpy(szDefaultTitleBackup, _wpclsQueryTitle(_XFolder));
            for (i = 0; i < XFLDACCSLIMIT-1; i++)
                XFldAccsBackup[i] = XFldAccs[i];

            if (usSettingsPage == SP_2REMOVEITEMS)
            {   /* on page 2, we need to disable one control if
                   we're running on Warp 4 */
                if (DosIsWarp4()) {
                    WinEnableDlgItem(hwndDlg, ID_XSDI_SELECT, FALSE);
                } else {
                    WinEnableDlgItem(hwndDlg, ID_XSDI_LOCKINPLACE, FALSE);
                    WinEnableDlgItem(hwndDlg, ID_XSDI_WARP4DISPLAY, FALSE);
                    WinEnableDlgItem(hwndDlg, ID_XSDI_INSERT, FALSE);
                }
            }
            else if (usSettingsPage == SP_28STATUSBAR2) {
                strcpy(szSBTextNoneSelBackup,
                            cmnQueryStatusBarSetting(SBS_TEXTNONESEL));
                strcpy(szSBTextMultiSelBackup,
                            cmnQueryStatusBarSetting(SBS_TEXTMULTISEL));
                // status bar settings page: get last selected
                // class from INIs (for single-object mode)
                // and query the SOM class object from this string
                PrfQueryProfileString(HINI_USER, INIAPP,
                        INIKEY_SB_LASTCLASS, "XFldDataFile",
                        szSBClassSelected, sizeof(szSBClassSelected));
                if (pSBClassObjectSelected == NULL) {
                    somidClassSelected = somIdFromString(szSBClassSelected);
                    if (somidClassSelected) {
                        // get pointer to class object (e.g. M_WPObject)
                        pSBClassObjectSelected = _somFindClass(SOMClassMgrObject, somidClassSelected, 0, 0);
                    }
                }
                if (pSBClassObjectSelected) {
                    _xfclsQueryStatusBarMnemonics(pSBClassObjectSelected,
                            szSBText1SelBackup,
                            sizeof(szSBText1SelBackup));
                }
            }
            else if (usSettingsPage == SP_4ACCELERATORS)
            {   // on page 4, subclass the Edit field (Key description)
                HAB     habDesktop = WinQueryAnchorBlock(HWND_DESKTOP);
                HWND    hwndEditField = WinWindowFromID(hwndDlg, ID_XSDI_DESCRIPTION);

                for (i = 0; i < LBENTRYCOUNT; i++)
                {
                    if (WinLoadString(habDesktop, NLS_MODULE,
                            szLBStringIDs[i], sizeof(szLBEntries[i]), szLBEntries[i]) == 0)
                    {
                        DebugBox("XFolder", "Unable to load strings.");
                        break;
                    }
                }

                OldEditProc = WinSubclassWindow(hwndEditField, fnwpKeyboardEntryField);
            }
            else if (usSettingsPage == SP_DTP2)
            {
                if (WinQueryObject(XFOLDER_STARTUPID))
                    WinEnableDlgItem(hwndDlg, ID_XSDI_SD_CREATESTARTUPFLDR, FALSE);
                if (WinQueryObject(XFOLDER_SHUTDOWNID))
                    WinEnableDlgItem(hwndDlg, ID_XSDI_SD_CREATESHUTDOWNFLDR, FALSE);
            }

            // now get settings and set dlg items accordingly
            dlgSetControlsFromSettings(hwndDlg, usSettingsPage, TRUE); // load from INI
            // enable/disable controls according to settings
            dlgEnableControls(hwndDlg, usSettingsPage);
            #ifdef DEBUG_SETTINGS
                _Pmpf(("End fnwpSettingsDlgCommon, WM_INITDLG, page: %d\n", usSettingsPage));
            #endif
        break; } // end of case WM_INITDLG

        /*
         * WM_CONTROL:
         *      call dlgItemChanged, which can react by calling
         *      dlgReadSettingsFromControls and cmnStoreGlobalSettings,
         *      if this is desired for a control
         */

        case WM_CONTROL: {
            dlgItemChanged(hwndDlg, usSettingsPage, SHORT1FROMMP(mp1), SHORT2FROMMP(mp1));
                // this will also update the respective settings
            dlgEnableControls(hwndDlg, usSettingsPage);
            mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);
        break; }

        /*
         * WM_COMMAND:
         *      react to buttons pressed
         */

        case WM_COMMAND: {
            switch (SHORT1FROMMP(mp1)) {

                // "Undo" on every settings page:
                // restore backed up settings for this current page
                case DID_UNDO: { // exists on every page
                    *pGlobalSettings = GlobalSettingsBackup;  // backup stuff for UNDO

                    if (usSettingsPage == SP_4ACCELERATORS)
                        for (i = 0; i < XFLDACCSLIMIT-1; i++)
                            XFldAccs[i] = XFldAccsBackup[i];
                    else if (usSettingsPage == SP_5INTERNALS)
                        _xfclsSetDefaultTitle(_XFolder, szDefaultTitleBackup);
                    else if (usSettingsPage == SP_28STATUSBAR2) {
                        cmnSetStatusBarSetting(SBS_TEXTNONESEL,
                                szSBTextNoneSelBackup);
                        cmnSetStatusBarSetting(SBS_TEXTMULTISEL,
                                szSBTextMultiSelBackup);

                        if (pSBClassObjectSelected == NULL) {
                            somidClassSelected = somIdFromString(szSBClassSelected);
                            if (somidClassSelected) {
                                // get pointer to class object (e.g. M_WPObject)
                                pSBClassObjectSelected = _somFindClass(SOMClassMgrObject, somidClassSelected, 0, 0);
                            }
                        }
                        if (pSBClassObjectSelected) {
                            _xfclsSetStatusBarMnemonics(pSBClassObjectSelected,
                                            szSBText1SelBackup);
                        }
                    }

                    dlgSetControlsFromSettings(hwndDlg, usSettingsPage,
                            FALSE); // don't load from INI
                    dlgEnableControls(hwndDlg, usSettingsPage);
                    cmnStoreGlobalSettings(); // update INI

                    if (    (usSettingsPage == SP_27STATUSBAR)
                         || (usSettingsPage == SP_28STATUSBAR2)
                       )
                        cmnPostWorkerMsg(WOM_UPDATEALLSTATUSBARS,
                                (MPARAM)2, // update display
                                MPNULL);
                break; }

                // "Default" on every settings page:
                // restore default settings for this current page
                case DID_DEFAULT: {
                    cmnSetDefaultSettings(usSettingsPage);
                    if (usSettingsPage == SP_4ACCELERATORS)
                        cmnLoadDefaultAccelerators();
                    else if (usSettingsPage == SP_5INTERNALS)
                        _xfclsSetDefaultTitle(_XFolder, "XFolder");
                    else if (usSettingsPage == SP_28STATUSBAR2) {
                        cmnSetStatusBarSetting(SBS_TEXTNONESEL, NULL);  // load default
                        cmnSetStatusBarSetting(SBS_TEXTMULTISEL, NULL); // load default

                        if (pSBClassObjectSelected == NULL) {
                            somidClassSelected = somIdFromString(szSBClassSelected);
                            if (somidClassSelected) {
                                // get pointer to class object (e.g. M_WPObject)
                                pSBClassObjectSelected = _somFindClass(SOMClassMgrObject, somidClassSelected, 0, 0);
                            }
                        }
                        if (pSBClassObjectSelected) {
                            _xfclsSetStatusBarMnemonics(pSBClassObjectSelected,
                                            NULL);  // load default
                        }
                    }

                    dlgSetControlsFromSettings(hwndDlg, usSettingsPage, FALSE); // don't load from INI
                    dlgEnableControls(hwndDlg, usSettingsPage);
                    cmnStoreGlobalSettings(); // update INI

                    if (    (usSettingsPage == SP_27STATUSBAR)
                         || (usSettingsPage == SP_28STATUSBAR2)
                       )
                        cmnPostWorkerMsg(WOM_UPDATEALLSTATUSBARS,
                                (MPARAM)2, // update display
                                MPNULL);
                break; }

                // "Clear" button on accelerators page
                case ID_XSDI_CLEARACCEL: {
                    USHORT usCommand;
                    i = cmnFindAccIndexFromLBSel(hwndDlg, &usCommand);
                    if (i >= 0) { // accelerator defined
                        while (XFldAccs[i].usCommand)
                        {
                            // in order to delete the marked accelerator,
                            // move all following accelerators in the global
                            // accelerator table one position ahead */
                            XFldAccs[i] = XFldAccs[i+1];
                            i++;
                        }
                        WinSetDlgItemText(hwndDlg, ID_XSDI_DESCRIPTION,
                                    (cmnQueryNLSStrings())->pszNotDefined);
                        WinPostMsg(hwndDlg,
                            WM_CONTROL,
                            MPFROM2SHORT(ID_XSDI_DESCRIPTION, EN_KILLFOCUS), // enfore save settings
                            MPNULL);
                        WinEnableDlgItem(hwndDlg, ID_XSDI_CLEARACCEL, FALSE);
                    }
                break; }

                // Reboot Actions (Desktop page 1)
                case ID_XSDI_SD_REBOOTEXT: {
                    cmnSetHelpPanel(ID_XFH_REBOOTEXT);
                    WinDlgBox(HWND_DESKTOP,         // parent is desktop
                          hwndDlg,             // owner is desktop
                          (PFNWP)fnwpRebootExt,    // dialog procedure
                          NLS_MODULE,  // from resource file
                          ID_XSD_REBOOTEXT,        // dialog resource id
                          (PVOID)NULL);            // no dialog parameters
                break; }

                // Auto-close details (Desktop page 1)
                case ID_XSDI_SD_AUTOCLOSEDETAILS: {
                    cmnSetHelpPanel(ID_XFH_AUTOCLOSEDETAILS);
                    WinDlgBox(HWND_DESKTOP,         // parent is desktop
                          hwndDlg,             // owner is desktop
                          (PFNWP)fnwpAutoCloseDetails,    // dialog procedure
                          NLS_MODULE,  // from resource file
                          ID_XSD_AUTOCLOSE,        // dialog resource id
                          (PVOID)NULL);            // no dialog parameters
                break; }

                // "Create startup folder" (Desktop page 2)
                case ID_XSDI_SD_CREATESTARTUPFLDR:
                    sprintf(szSetup,
                        "DEFAULTVIEW=ICON;ICONVIEW=NONFLOWED,MINI;"
                        "OBJECTID=%s;",
                        XFOLDER_STARTUPID);
                    if (hObj = WinCreateObject("XFldStartup", "XFolder Startup",
                            szSetup,
                            "<WP_DESKTOP>",
                            CO_UPDATEIFEXISTS))
                        WinEnableDlgItem(hwndDlg, ID_XSDI_SD_CREATESTARTUPFLDR, FALSE);
                    else
                        cmnMessageBoxMsg(HWND_DESKTOP, 104, 105, MB_OK);
                break;

                // "Create shutdown folder" (Desktop page 2)
                case ID_XSDI_SD_CREATESHUTDOWNFLDR:
                    // cmnQueryXFolderPath(szPath, sizeof(szPath));
                    sprintf(szSetup,
                        "DEFAULTVIEW=ICON;ICONVIEW=NONFLOWED,MINI;"
                        // "ICONFILE=%s\\xfshut1.ico;ICONNFILE=1,%s\\xfshut2.ico;"
                        "OBJECTID=%s;",
                        XFOLDER_SHUTDOWNID);
                    if (hObj = WinCreateObject("XFldShutdown", "XFolder Shutdown",
                            szSetup,
                            "<WP_DESKTOP>",
                            CO_UPDATEIFEXISTS))
                        WinEnableDlgItem(hwndDlg, ID_XSDI_SD_CREATESHUTDOWNFLDR, FALSE);
                    else
                        cmnMessageBoxMsg(HWND_DESKTOP, 104, 106, MB_OK);
                break;

                // "Select class" on "Status Bars" page:
                // set up WPS classes dialog
                case ID_XSDI_SBSELECTCLASS: {
                    SELECTCLASSDATA         scd;
                    STATUSBARSELECTCLASS    sbsc;

                    CHAR szTitle[100] = "title";
                    CHAR szIntroText[2000] = "intro";

                    cmnGetMessage(NULL, 0, szTitle, sizeof(szTitle), 112);
                    cmnGetMessage(NULL, 0, szIntroText, sizeof(szIntroText), 113);
                    scd.pszDlgTitle = szTitle;
                    scd.pszIntroText = szIntroText;
                    scd.pszRootClass = "WPObject";
                    scd.pszOrphans = NULL;
                    strcpy(scd.szClassSelected, szSBClassSelected);

                    // these callback funcs are defined way more below
                    scd.pfnwpReturnAttrForClass = fncbStatusBarReturnClassAttr;
                    scd.pfnwpClassSelected = fncbStatusBarClassSelected;
                    // the folllowing data will be passed to the callbacks
                    // so the callback can display NLS messages
                    sbsc.pNLSStrings = cmnQueryNLSStrings();
                    scd.ulUserClassSelected = (ULONG)&sbsc;

                    scd.pszHelpLibrary = cmnQueryHelpLibrary();
                    scd.ulHelpPanel = ID_XFH_SELECTCLASS;

                    if (cmnSelectWpsClass(hwndDlg,
                            NLS_MODULE, ID_XSD_SELECTCLASS,
                            &scd) == DID_OK)
                    {
                        strcpy(szSBClassSelected, scd.szClassSelected);
                        WinSetDlgItemText(hwndDlg, ID_XSDI_SBCURCLASS, szSBClassSelected);
                        PrfWriteProfileString(HINI_USER, INIAPP, INIKEY_SB_LASTCLASS,
                                    szSBClassSelected);
                        if (pSBClassObjectSelected) {
                            SOMFree(somidClassSelected);
                            pSBClassObjectSelected = NULL;
                            // this will provoke the following func to re-read
                            // the class's status bar mnemonics
                        }

                        dlgSetControlsFromSettings(hwndDlg, usSettingsPage,
                                    FALSE); // don't use INI

                        // refresh the "Undo" data for this
                        _xfclsQueryStatusBarMnemonics(pSBClassObjectSelected,
                                szSBText1SelBackup,
                                sizeof(szSBText1SelBackup));

                    }
                }
            }
        break; } // end of case WM_COMMAND

        case WM_HELP: {
            cmnDisplayFocusHelp(DefaultPanelID[usSettingsPage]);
        break; }

        /*
         * WM_DESTROY:
         *      clean up this page
         */

        case WM_DESTROY: {
            dlgReadSettingsFromControls(hwndDlg, usSettingsPage);
            cmnStoreGlobalSettings();

            // on "Status bar" page 2, clean up the SOM stuff
            // we messed up earlier too
            if (usSettingsPage == SP_28STATUSBAR2) {
                if (pSBClassObjectSelected) {
                    SOMFree(somidClassSelected);
                    pSBClassObjectSelected = NULL;
                }
            }
            mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);
        break; }  // end of case WM_DESTROY

        default:
            mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);
    }

    return (mrc);
}

/*
 * fnwpSettingsXFolder1:
 *           dlg function for "XFolder" page 1
 */

MRESULT EXPENTRY fnwpSettingsXFolder1(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpSettingsDlgCommon(hwndDlg, SP_1GENERIC, msg, mp1, mp2));
}

/*
 * fnwpSettingsRemoveMenus:
 *           dlg function for "Remove menu items" page
 */

MRESULT EXPENTRY fnwpSettingsRemoveMenus(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpSettingsDlgCommon(hwndDlg, SP_2REMOVEITEMS, msg, mp1, mp2));
}

/*
 * fnwpSettingsAddMenus:
 *           dlg function for "Add menu items" page
 */

MRESULT EXPENTRY fnwpSettingsAddMenus(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpSettingsDlgCommon(hwndDlg, SP_25ADDITEMS, msg, mp1, mp2));
}

/*
 * fnwpSettingsAddMenus:
 *           dlg function for "Config folder menu items" page
 */

MRESULT EXPENTRY fnwpSettingsConfigFolderMenus(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpSettingsDlgCommon(hwndDlg, SP_26CONFIGITEMS, msg, mp1, mp2));
}

/*
 * fnwpSettingsStatusBars1:
 *           dlg function for "Status bars" page 1
 */

MRESULT EXPENTRY fnwpSettingsStatusBars1(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpSettingsDlgCommon(hwndDlg, SP_27STATUSBAR, msg, mp1, mp2));
}

/*
 * fnwpSettingsStatusBars2:
 *           dlg function for "Status bars" page 2
 */

MRESULT EXPENTRY fnwpSettingsStatusBars2(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpSettingsDlgCommon(hwndDlg, SP_28STATUSBAR2, msg, mp1, mp2));
}

/*
 * fnwpSettingsSnapToGrid:
 *           dlg function for "Snap to grid" page
 */

MRESULT EXPENTRY fnwpSettingsSnapToGrid(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpSettingsDlgCommon(hwndDlg, SP_3SNAPTOGRID, msg, mp1, mp2));
}

/*
 * fnwpSettingsAccels:
 *           dlg function for "Folder hotkeys" page
 */

MRESULT EXPENTRY fnwpSettingsAccels(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpSettingsDlgCommon(hwndDlg, SP_4ACCELERATORS, msg, mp1, mp2));
}

/*
 * fnwpSettingsXFolderInternals:
 *           dlg function for "XFolder internals" page
 */

MRESULT EXPENTRY fnwpSettingsXFolderInternals(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpSettingsDlgCommon(hwndDlg, SP_5INTERNALS, msg, mp1, mp2));
}

/*
 * fnwpSettingsFileOperations:
 *           dlg function for "File Operations" page
 */

MRESULT EXPENTRY fnwpSettingsFileOperations(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpSettingsDlgCommon(hwndDlg, SP_FILEOPS, msg, mp1, mp2));
}

/*
 * fnwpSettingsDlg_Desktop1:
 *           dlg function for XDesktop settings page
 */

MRESULT EXPENTRY fnwpSettingsDlg_Desktop1(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpSettingsDlgCommon(hwndDlg, SP_DTP1, msg, mp1, mp2));
}

/*
 * fnwpSettingsDlg_Desktop2:
 *           dlg function for XDesktop settings page 2
 */

MRESULT EXPENTRY fnwpSettingsDlg_Desktop2(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpSettingsDlgCommon(hwndDlg, SP_DTP2, msg, mp1, mp2));
}

/*
 * strParseDescription:
 *      searches pszBuf for pszSrch0 ; if found, the line containing
 *      pszSrch is parsed as follows:
 *          <pszSrch0 > <ulFlags> <RestOfLine>
 *             PSZ       hex str     PSZ
 *      Returns length of what was copied to pszDescription or
 *      zero on errors.
 *      This is used for explaing a certain WPS class when it is
 *      being selected in the "WPS classes" notebook page.
 *      This returns TRUE if pszSrch0 was found.
 */

BOOL strParseDescription(PSZ pszBuf, PSZ pszSrch0, PULONG pulFlags, PSZ pszDescription)
{
    BOOL brc = FALSE;
    PSZ p1, p2;

    // create search string for beginning of line
    PSZ pszSrch2 = malloc(strlen(pszSrch0) + 4);
    strcpy(pszSrch2, "\r\n");
    strcat(pszSrch2, pszSrch0);

    p1 = strstr(pszBuf, pszSrch2);
    if (p1) {
        p1 += 2; // skip \r\n
        p1 = strchr(p1, ' ');
        if (p1) {
            // p1 now has ulFlags
            sscanf(p1, "%lX ", pulFlags);
            p1 = strchr(p1+1, ' ');
            if (p1) {
                brc = TRUE;
                // p1 now has beginning of description
                p2 = strstr(p1, "\r\n");
                if (p2) {
                    // p2 now has end of description
                    strncpy(pszDescription, p1+1, (p2-p1-1));
                } else
                    strncat(pszDescription, p1+1, 200);
            }
        }
    }
    return (brc);
}

PSZ pszClassInfo = NULL;
HWND hwndClassInfo = NULLHANDLE;

/*
 * cmnUpdateClassInfo:
 *      this is called every time a new class gets selected
 *      in the "WPS classes" page: update the infos
 */

VOID cmnUpdateClassInfo(HWND hwndDlg, PCLASSRECORDCORE pRecordSelected)
{
    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
    HWND hwndIcon = NULLHANDLE;
    HPOINTER hClassIcon = NULLHANDLE;

    if (pGlobalSettings->WpsShowClassInfo) {
        PWPSLISTITEM pwps = pRecordSelected->pwps;
        CHAR szInfo[1000] = "", szInfo2[256] = "";
        BOOL fCreate = FALSE;
        PNLSSTRINGS pNLSStrings = cmnQueryNLSStrings();

        if (hwndClassInfo)
            fCreate = !(WinIsWindow(
                    WinQueryAnchorBlock(HWND_DESKTOP),
                    hwndClassInfo));
        if (    (hwndClassInfo == NULLHANDLE)
             || (fCreate)
           )
        {
            hwndClassInfo = WinLoadDlg(HWND_DESKTOP, hwndDlg,
                              fnwpDlgGeneric,
                              NLS_MODULE, ID_XSD_SETTINGS_WPSCL_INFO,
                              NULL);
            hwndIcon = WinWindowFromID(hwndClassInfo, ID_XSDI_SC_ICON);
            WinAnimatedIconFromStatic(hwndIcon);
        }

        if (pwps) {
                /* WinSendDlgItemMsg(hwndDlg, ID_XSDI_SC_CLASSICON,
                        SM_SETHANDLE,
                        (MPARAM)_ wpclsQueryIcon(pwps->pClassObject),
                        MPNULL); */
            // dll name
            WinSetDlgItemText(hwndClassInfo, ID_XSDI_SC_CLASSMODULE, pwps->pszModName);

            // class name
            strcpy(szInfo, pwps->pszClassName);
            WinSetDlgItemText(hwndClassInfo, ID_XSDI_SC_CLASSNAME, szInfo);

            // "replaced by"
            WinSetDlgItemText(hwndClassInfo, ID_XSDI_SC_REPLACEDBY, pwps->szReplacedByClass);

            // class icon
            hwndIcon = WinWindowFromID(hwndClassInfo, ID_XSDI_SC_ICON);
            if (pwps->pClassObject)
                hClassIcon = _wpclsQueryIcon(pwps->pClassObject);
            WinSendMsg(hwndIcon,
                       SM_SETHANDLE,
                       (MPARAM)hClassIcon,  // NULLHANDLE if error -> hide
                       MPNULL);

            // class title
            if (pwps->pClassObject) {
                PSZ pszClassTitle = _wpclsQueryTitle(
                                pwps->pClassObject);
                if (pszClassTitle)
                    sprintf(szInfo2,
                        "\"%s\"",
                        pszClassTitle);
                else
                    strcpy(szInfo2, "?");
            } else
                strcpy(szInfo2, pNLSStrings->pszWpsClassLoadingFailed);
            WinSetDlgItemText(hwndClassInfo, ID_XSDI_SC_CLASSTITLE, szInfo2);

            // class information
            if (pszClassInfo) {
                ULONG ulFlags;
                if (!strParseDescription(pszClassInfo,
                            pwps->pszClassName,
                            &ulFlags,
                            szInfo))
                {
                    // not found: search for "UnknownClass"
                    strParseDescription(pszClassInfo,
                            "UnknownClass",
                            &ulFlags,
                            szInfo);
                }
            }
        } // end if (pwps)
        else {
            // if (pwps == NULL), the "Orphans" item has been
            // selected: give info for this
            strcpy(szInfo, pNLSStrings->pszWpsClassOrphansInfo);
            WinSetDlgItemText(hwndClassInfo, ID_XSDI_SC_CLASSMODULE, "");
            WinSetDlgItemText(hwndClassInfo, ID_XSDI_SC_CLASSNAME, "");
            WinSetDlgItemText(hwndClassInfo, ID_XSDI_SC_REPLACEDBY, "");
            WinSetDlgItemText(hwndClassInfo, ID_XSDI_SC_CLASSTITLE, "");

            hwndIcon = WinWindowFromID(hwndClassInfo, ID_XSDI_SC_ICON);
            WinSendMsg(hwndIcon,
                       SM_SETHANDLE,
                       (MPARAM)NULLHANDLE,  // hide icon
                       MPNULL);
        }

        // give MLE new text
        WinSetDlgItemText(hwndClassInfo, ID_XSDI_SC_TEXT2, szInfo);
        // scroll MLE to top
        WinSendDlgItemMsg(hwndClassInfo, ID_XSDI_SC_TEXT2,
                MLM_SETFIRSTCHAR,
                (MPARAM)0,
                MPNULL);

        WinShowWindow(hwndClassInfo, TRUE);
    } // end if (pGlobalSettings->WpsShowClassInfo)
    else {
        if (hwndClassInfo)
            if (WinIsWindow(
                    WinQueryAnchorBlock(HWND_DESKTOP),
                    hwndClassInfo))
                WinShowWindow(hwndClassInfo, FALSE);
    }
}

/*
 * fncbReturnWPSClassAttr:
 *      this callback function is called for every single
 *      record core which represents a WPS class; we need
 *      to return the record core attributes
 */

MRESULT EXPENTRY fncbReturnWPSClassAttr(HWND hwndCnr,
                    ULONG ulscd,   // SELECTCLASSDATA struct
                    MPARAM mpwps,  // current WPSLISTITEM struct
                    MPARAM mpreccParent) // parent record core
{
    USHORT          usAttr = CRA_RECORDREADONLY | CRA_COLLAPSED;
    PWPSLISTITEM     pwps = (PWPSLISTITEM)mpwps;
    PSELECTCLASSDATA pscd = (PSELECTCLASSDATA)ulscd;
    PRECORDCORE     preccParent = NULL;

    if (pwps) {
        #ifdef DEBUG_SETTINGS
            _Pmpf(("Checking %s\n", pwps->pszClassName));
        #endif
        // if the class to be inserted is an XFolder class,
        // expand all the parent records of the new record
        // so that all XFolder classes are initially visible
        if (strncmp(pwps->pszClassName, "XFld", 4) == 0)
        {
            preccParent = (PRECORDCORE)mpreccParent;
            while (preccParent)
            {
                WinSendMsg(hwndCnr, CM_EXPANDTREE, (MPARAM)preccParent, MPNULL);

                preccParent = WinSendMsg(hwndCnr, CM_QUERYRECORD,
                        preccParent,
                        MPFROM2SHORT(CMA_PARENT, CMA_ITEMORDER));

                if (preccParent == (PRECORDCORE)-1) {
                    preccParent = NULL;
                }
            }
        }
    }
    return (MPARAM)(usAttr);
}

/*
 * fncbReplaceClassSelected:
 *      callback func for class selected in the "Replace
 *      with subclass" dlg;
 *      mphwndInfo has been set to the static control hwnd.
 *      Returns TRUE if the selection is valid; the dlg func
 *      will then enable the OK button.
 */

MRESULT EXPENTRY fncbReplaceClassSelected(HWND hwndCnr, ULONG ulpsbsc,
                    MPARAM mpwps, MPARAM mphwndInfo)
{
    PWPSLISTITEM pwps = (PWPSLISTITEM)mpwps;
    PSTATUSBARSELECTCLASS psbsc = (PSTATUSBARSELECTCLASS)ulpsbsc;
    PSZ pszClassTitle;
    CHAR szInfo[2000] = "";

    if (pwps->pClassObject) {
        if (pszClassInfo) {
            ULONG ulFlags;
            if (!strParseDescription(pszClassInfo,
                        pwps->pszClassName,
                        &ulFlags,
                        szInfo))
            {
                // not found: search for "UnknownClass"
                strParseDescription(pszClassInfo,
                        "UnknownClass",
                        &ulFlags,
                        szInfo);
            }
        }
    }

    WinSetWindowText((HWND)mphwndInfo, szInfo);

    return (MRESULT)TRUE;
}

/*
 * fnwpSettingsWpsClasses:
 *      dlg func for "WPS Classes" notebook page; this does
 *      _not_ use fnwpSettingsDlgCommon, because it's too
 *      different
 */

BOOL fFillingCnr = FALSE;

MRESULT EXPENTRY fnwpSettingsWpsClasses(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    MRESULT mrc = MPNULL;
    PSELECTCLASSDATA pscd = (PSELECTCLASSDATA)WinQueryWindowULong(hwndDlg, QWL_USER);

    switch(msg) {

        /*
         * WM_INITDLG:
         *      set up the container data and colors
         */

        case WM_INITDLG: {
            CNRINFO CnrInfo;

            mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);

            pscd = (PSELECTCLASSDATA)malloc(sizeof(SELECTCLASSDATA));
            WinSetWindowULong(hwndDlg, QWL_USER, (ULONG)pscd);

            // setup container
            pscd->hwndCnr = WinWindowFromID(hwndDlg, ID_XSDI_SC_CNR);
            WinSendMsg(pscd->hwndCnr, CM_QUERYCNRINFO, &CnrInfo, (MPARAM)sizeof(CnrInfo));
            CnrInfo.pSortRecord = (PVOID)fnCompareName;
            CnrInfo.flWindowAttr =
                    CV_TREE | CA_TREELINE | CV_TEXT;
            CnrInfo.cxTreeIndent = 30;
            WinSendMsg(pscd->hwndCnr, CM_SETCNRINFO,
                    &CnrInfo,
                    (MPARAM)(CMA_PSORTRECORD | CMA_FLWINDOWATTR | CMA_CXTREEINDENT));

            WinPostMsg(hwndDlg, WM_SETTINGS2DLG, MPNULL, MPNULL);

            // fill container later
            fFillingCnr = FALSE;
            WinPostMsg(hwndDlg, WM_FILLCNR, MPNULL, MPNULL);
        break; }

        /*
         * WM_FILLCNR:
         *      this fills the cnr with all the WPS classes
         */

        case WM_FILLCNR: {
            HPOINTER hptrOld = WinQueryPointer(HWND_DESKTOP);
            CHAR szClassInfoFile[CCHMAXPATH];
            ULONG ulCopied;
            PNLSSTRINGS pNLSStrings = cmnQueryNLSStrings();

            WinSetPointer(HWND_DESKTOP,
                    WinQuerySysPointer(HWND_DESKTOP, SPTR_WAIT, FALSE));
            fFillingCnr = TRUE;

            pscd->pszRootClass = "WPObject";
            strcpy(pscd->szClassSelected, "WPObject");

            pscd->pfnwpReturnAttrForClass = fncbReturnWPSClassAttr;
            pscd->pfnwpClassSelected = NULL; // fncbStatusBarClassSelected;
            // scd.ulUserClassSelected = (ULONG)&sbsc;

            ulCopied = cmnQueryXFolderBasePath(szClassInfoFile, sizeof(szClassInfoFile));
            if (ulCopied)
            {
                sprintf(szClassInfoFile+strlen(szClassInfoFile),
                        "\\help\\xfcls%s.txt",
                        cmnQueryLanguageCode());
                // _Pmpf(("Class info file: %s", szClassInfoFile));
                pszClassInfo = DosReadTextFile(szClassInfoFile, 100);
            } else
                return (NULL);

            // add orphans; this is done by setting the title
            // for the "Orphans" recc tree
            pscd->pszOrphans = pNLSStrings->pszWpsClassOrphans;

            // fill container with WPS data (objdlgs.c)
            pscd->pwpsc = cmnWpsClasses2Cnr(pscd->hwndCnr, pscd->pszRootClass,
                    NULL, NULL,
                    pscd);  // also contains callback

            fFillingCnr = FALSE;
            WinSetPointer(HWND_DESKTOP, hptrOld);
        break; }

        case WM_SETTINGS2DLG: {
            PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
            WinSetDlgItemChecked(hwndDlg, ID_XSDI_SC_BOOTUPSTATUS, pGlobalSettings->ShowBootupStatus);
        break; }

        case WM_DLG2SETTINGS: {
            PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
            pGlobalSettings->ShowBootupStatus = WinIsDlgItemChecked(hwndDlg, ID_XSDI_SC_BOOTUPSTATUS);
            cmnStoreGlobalSettings(); // update INI
        break; }

        /*
         * WM_TIMER:
         *      timer for tree view auto-scroll (we dont'
         *      use the Worker thread here)
         */

        case WM_TIMER: {
            if ( ( pscd->preccExpanded->flRecordAttr & CRA_EXPANDED) != 0 ) {
                PRECORDCORE     preccLastChild;
                WinStopTimer(WinQueryAnchorBlock(hwndDlg),
                        hwndDlg,
                        1);
                // scroll the tree view properly
                preccLastChild = WinSendMsg(pscd->hwndCnr,
                        CM_QUERYRECORD,
                        pscd->preccExpanded,   // expanded PRECORDCORE from CN_EXPANDTREE
                    MPFROM2SHORT(CMA_LASTCHILD, CMA_ITEMORDER));
                if (preccLastChild) {
                    // ULONG ulrc;
                    WinCnrScrollToRecord(pscd->hwndCnr,
                            (PRECORDCORE)preccLastChild,
                            CMA_TEXT,   // record text rectangle only
                            TRUE);      // keep parent visible
                }
            }
        }

        /*
         * WM_CONTROL:
         *      capture cnr notifications
         */

        case WM_CONTROL: {
            if (SHORT1FROMMP(mp1) == ID_XSDI_SC_BOOTUPSTATUS) {
                WinPostMsg(hwndDlg, WM_DLG2SETTINGS, MPNULL, MPNULL);
            } else if (SHORT1FROMMP(mp1) == ID_XSDI_SC_CNR) {
                switch (SHORT2FROMMP(mp1)) { // notify code

                    /*
                     * CN_EXPANDTREE:
                     *      tree view has been expanded:
                     *      do cnr auto-scroll if we're
                     *      not initially filling the cnr
                     */

                    case CN_EXPANDTREE: {
                        if (!fFillingCnr) {
                            PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
                            if (pGlobalSettings->TreeViewAutoScroll) {
                                pscd->preccExpanded = (PRECORDCORE)mp2;
                                WinStartTimer(WinQueryAnchorBlock(hwndDlg),
                                        hwndDlg,
                                        1,
                                        100);
                            }
                        }
                        mrc = MPNULL;
                    break; }

                    /*
                     * CN_CONTEXTMENU:
                     *      context menu requested
                     */

                    case CN_CONTEXTMENU: {
                        POINTL ptl;
                        HWND   hPopupMenu;
                        PCLASSRECORDCORE preccSelected = (PCLASSRECORDCORE)mp2;
                        PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
                        ULONG ulFlagsSelected = 0;
                        CHAR szDummy[2000];

                        if (preccSelected) {
                            // we have a selection
                            LONG lrc2;
                            hPopupMenu = WinLoadMenu(hwndDlg, NLS_MODULE,
                                    ID_XSM_WPSCLASSES_SEL);
                            // allow deregistering?
                            if (preccSelected->pwps) {
                                if (pszClassInfo)
                                    if (strParseDescription(pszClassInfo,
                                            preccSelected->pwps->pszClassName,
                                            &ulFlagsSelected,
                                            szDummy))
                                        if (ulFlagsSelected == 0)
                                            // disable "Deregister" menu item
                                            WinEnableMenuItem(hPopupMenu,
                                                ID_XSMI_WPS_DEREGISTER, FALSE);
                                // allow replacements only if the
                                // class has subclasses
                                lrc2 = (LONG)WinSendMsg(
                                    pscd->hwndCnr, CM_QUERYRECORD,
                                        (MPARAM)preccSelected,
                                        MPFROM2SHORT(CMA_FIRSTCHILD, CMA_ITEMORDER));
                                if ((lrc2 == 0) || (lrc2 == -1))
                                    WinEnableMenuItem(hPopupMenu,
                                        ID_XSMI_WPS_REPLACE, FALSE);
                                // allow de-replacement only if the
                                // replaces another class
                                if (strlen(preccSelected->pwps->szReplacesClass) == 0)
                                    WinEnableMenuItem(hPopupMenu,
                                        ID_XSMI_WPS_UNREPLACE, FALSE);

                            } else {
                                WinEnableMenuItem(hPopupMenu,
                                    ID_XSMI_WPS_DEREGISTER, FALSE);
                                WinEnableMenuItem(hPopupMenu,
                                    ID_XSMI_WPS_REPLACE, FALSE);
                                WinEnableMenuItem(hPopupMenu,
                                    ID_XSMI_WPS_UNREPLACE, FALSE);
                            }

                        } else {
                            // no selection: different menu
                            hPopupMenu = WinLoadMenu(hwndDlg, NLS_MODULE,
                                    ID_XSM_WPSCLASSES_NOSEL);
                        }

                        if (hwndClassInfo) {
                            if (!WinIsWindow(
                                    WinQueryAnchorBlock(hwndDlg),
                                    hwndClassInfo))
                                pGlobalSettings->WpsShowClassInfo = FALSE;
                        } else
                            pGlobalSettings->WpsShowClassInfo = FALSE;

                        // check "info" menu item?
                        WinSetMenuItemChecked(hPopupMenu,
                                ID_XSMI_WPS_INFO,
                                (pGlobalSettings->WpsShowClassInfo));

                        WinQueryPointerPos(HWND_DESKTOP, &ptl);
                        WinPopupMenu(HWND_DESKTOP, hwndDlg,
                                hPopupMenu,
                                (SHORT)ptl.x,
                                (SHORT)ptl.y,
                                0,
                                PU_NONE | PU_MOUSEBUTTON1 | PU_KEYBOARD
                                | PU_HCONSTRAIN | PU_VCONSTRAIN);
                    break; }

                    /*
                     * CN_EMPHASIS:
                     *      selection changed: call cmnUpdateClassInfo
                     */

                    case CN_EMPHASIS: {
                        // get cnr notification struct
                        PNOTIFYRECORDEMPHASIS pnre = (PNOTIFYRECORDEMPHASIS)mp2;

                        if (pnre)
                            if (    (pnre->fEmphasisMask & CRA_SELECTED)
                                 && (pnre->pRecord)
                               )
                            {
                                pscd->pRecordSelected = (PCLASSRECORDCORE)(pnre->pRecord);
                                cmnUpdateClassInfo(hwndDlg, pscd->pRecordSelected);
                            }
                    break; }
                }
            } // end if (SHORT1FROMMP(mp1) == ID_XSDI_SC_CNR) {
        break; }

        /*
         * WM_ACTIVATE:
         *      notebook page is shown or hidden
         */

        /* case WM_ACTIVATE: {
            mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);
            if (hwndClassInfo)
                if (WinIsWindow(
                                WinQueryAnchorBlock(hwndDlg),
                                hwndClassInfo))
                {
                    PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
                    if ((BOOL)mp1)
                    {
                        if ( pGlobalSettings->WpsShowClassInfo)
                            WinShowWindow(hwndClassInfo, TRUE);
                    } else
                        if ( ((HWND)mp2) != hwndClassInfo )
                            WinShowWindow(hwndClassInfo, FALSE);
                }
        break; } */

        case WM_WINDOWPOSCHANGED: {
            PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();
            PSWP pswpNew = (PSWP)mp1;
            // PSWP pswpOld = pswpNew + 1;
            mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);
            if (pswpNew->fl & SWP_SHOW) {
                if ( pGlobalSettings->WpsShowClassInfo)
                    WinShowWindow(hwndClassInfo, TRUE);
            } else if (pswpNew->fl & SWP_HIDE)
                // if ( ((HWND)mp2) != hwndClassInfo )
                    WinShowWindow(hwndClassInfo, FALSE);
        }

        /*
         * WM_COMMAND:
         *
         */

        case WM_COMMAND: {
            PGLOBALSETTINGS pGlobalSettings = cmnQueryGlobalSettings();

            switch (SHORT1FROMMP(mp1)) {

                // "Information" menu command
                case ID_XSMI_WPS_INFO: {
                    if (pGlobalSettings->WpsShowClassInfo) {
                        pGlobalSettings->WpsShowClassInfo = FALSE;
                    } else {
                        pGlobalSettings->WpsShowClassInfo = TRUE;
                    }
                    cmnStoreGlobalSettings();
                    cmnUpdateClassInfo(hwndDlg, pscd->pRecordSelected);
                break; }

                // "Register" menu command
                case ID_XSMI_WPS_REGISTER: {
                    REGISTERCLASSDATA rcd;
                    rcd.pszHelpLibrary = cmnQueryHelpLibrary();
                    rcd.ulHelpPanel = ID_XFH_REGISTERCLASS;
                    if (WinDlgBox(HWND_DESKTOP, hwndDlg,
                                             fnwpRegisterClass,
                                             NLS_MODULE, ID_XSD_SETTINGS_WPSCL_REGISTER,
                                             &rcd) == DID_OK)
                    {
                        PSZ pTable[1];
                        HPOINTER hptrOld = WinQueryPointer(HWND_DESKTOP);
                        pTable[0] = rcd.szClassName;
                        WinSetPointer(HWND_DESKTOP,
                                WinQuerySysPointer(HWND_DESKTOP, SPTR_WAIT, FALSE));
                        WinSendMsg(pscd->hwndCnr,
                                    CM_REMOVERECORD,
                                    (MPARAM)NULL,
                                    MPFROM2SHORT(0, // remove all records
                                            CMA_FREE | CMA_INVALIDATE));
                        cmnCleanupWpsClasses(pscd->pwpsc);
                        WinSetPointer(HWND_DESKTOP, hptrOld);
                        free(pszClassInfo);
                        pszClassInfo = NULL;

                        if (WinRegisterObjectClass(rcd.szClassName, rcd.szModName))
                            // success
                            cmnMessageBoxMsgExt(hwndDlg,
                                    121,
                                    pTable, 1, 131,
                                    MB_OK);
                        else
                            // error
                            cmnMessageBoxMsgExt(hwndDlg,
                                    104,
                                    pTable, 1, 132,
                                    MB_OK);

                        // fill cnr again
                        WinPostMsg(hwndDlg, WM_FILLCNR, MPNULL, MPNULL);
                    }
                break; }

                // "Deregister" menu command
                case ID_XSMI_WPS_DEREGISTER: {
                    if (pscd->pRecordSelected)
                        if (pscd->pRecordSelected->pwps) {
                            BOOL fAllow = FALSE;
                            CHAR szTemp[CCHMAXPATH];
                            PSZ pTable[2];
                            pTable[0] = szTemp;
                            pTable[1] = pscd->pRecordSelected->pwps->szReplacedByClass;

                            strcpy(szTemp, pscd->pRecordSelected->pwps->pszClassName);
                                // save for later

                            // do not allow deregistering if the class is currently
                            // replaced by another class
                            if ( strlen(pscd->pRecordSelected->pwps->szReplacedByClass)
                                 > 0)
                            {
                                // show warning
                                cmnMessageBoxMsgExt(hwndDlg,
                                            116,
                                            pTable, 2, 139,
                                            MB_OK);
                                // and stop
                                break;
                            }

                            if (strncmp(pscd->pRecordSelected->pwps->pszClassName,
                                            "XFld", 4) == 0) {
                                // XFolder class
                                if (cmnMessageBoxMsgExt(hwndDlg,
                                            116,
                                            pTable, 1, 120,
                                            MB_YESNO | MB_DEFBUTTON2)
                                        == MBID_YES)
                                    fAllow = TRUE;
                            } else
                                if (cmnMessageBoxMsgExt(hwndDlg,
                                            116,
                                            pTable, 1, 118,
                                            MB_YESNO | MB_DEFBUTTON2)
                                        == MBID_YES)
                                    fAllow = TRUE;

                            if (fAllow) {
                                /* HPOINTER hptrOld = WinQueryPointer(HWND_DESKTOP);
                                WinSetPointer(HWND_DESKTOP,
                                        WinQuerySysPointer(HWND_DESKTOP, SPTR_WAIT, FALSE));
                                WinSendMsg(pscd->hwndCnr,
                                            CM_REMOVERECORD,
                                            (MPARAM)NULL,
                                            MPFROM2SHORT(0, // remove all records
                                                    CMA_FREE | CMA_INVALIDATE));
                                cmnCleanupWpsClasses(pscd->pwpsc);
                                free(pszClassInfo);
                                pszClassInfo = NULL;
                                WinSetPointer(HWND_DESKTOP, hptrOld); */

                                /* if (pscd->pRecordSelected->pwps->pClassObject)
                                    SOMFree(pscd->pRecordSelected->pwps->somid); */

                                if (WinDeregisterObjectClass(pscd->pRecordSelected->pwps->pszClassName))
                                {
                                    // success
                                    lstRemoveItem((PLISTITEM*)(&(pscd->pwpsc->pwpsRoot)), NULL,
                                        (PLISTITEM)pscd->pRecordSelected->pwps, // remove item from list
                                        0, 0);

                                    // free(pscd->pRecordSelected->pwps);

                                    WinSendMsg(pscd->hwndCnr,
                                                CM_REMOVERECORD,
                                                (MPARAM)&(pscd->pRecordSelected),
                                                MPFROM2SHORT(1, // remove one record
                                                        CMA_FREE | CMA_INVALIDATE));

                                    cmnMessageBoxMsgExt(hwndDlg,
                                            121,
                                            pTable, 1, 122,
                                            MB_OK);
                                } else
                                    // error
                                    cmnMessageBoxMsgExt(hwndDlg,
                                            104,
                                            pTable, 1, 119,
                                            MB_OK);

                                // fill cnr again
                                // WinPostMsg(hwndDlg, WM_FILLCNR, MPNULL, MPNULL);
                            }
                        }
                break; }

                // "Replace class" menu command:
                // show yet another WPS classes dlg
                case ID_XSMI_WPS_REPLACE: {
                    if (pscd->pRecordSelected)
                        if (pscd->pRecordSelected->pwps) {
                            SELECTCLASSDATA         scd;
                            STATUSBARSELECTCLASS    sbsc;
                            PSZ                     pszClassName =
                                        pscd->pRecordSelected->pwps->pszClassName;

                            CHAR szTitle[CCHMAXPATH] = "title";
                            CHAR szIntroText[2000] = "intro";

                            cmnGetMessage(NULL, 0,
                                    szTitle, sizeof(szTitle), 112);
                            // replace "%1" by class name which is to be
                            // replaced
                            cmnGetMessage(&pszClassName, 1,
                                    szIntroText, sizeof(szIntroText), 123);
                            scd.pszDlgTitle = szTitle;
                            scd.pszIntroText = szIntroText;
                            scd.pszRootClass = pszClassName;
                            scd.pszOrphans = NULL;
                            strcpy(scd.szClassSelected, scd.pszRootClass);

                            scd.pfnwpReturnAttrForClass = NULL; // fncbStatusBarReturnClassAttr;
                            scd.pfnwpClassSelected = fncbReplaceClassSelected;
                            // the folllowing data will be passed to the callbacks
                            // so the callback can display NLS messages
                            sbsc.pNLSStrings = cmnQueryNLSStrings();
                            scd.ulUserClassSelected = (ULONG)&sbsc;

                            scd.pszHelpLibrary = cmnQueryHelpLibrary();
                            scd.ulHelpPanel = 0;

                            if (cmnSelectWpsClass(hwndDlg,
                                    NLS_MODULE, ID_XSD_SELECTCLASS,
                                    &scd) == DID_OK)
                            {
                                PSZ pTable[2];
                                pTable[0] = pscd->pRecordSelected->pwps->pszClassName;
                                pTable[1] = scd.szClassSelected;
                                if (cmnMessageBoxMsgExt(hwndDlg,
                                            116,
                                            pTable, 2, 124,
                                            MB_YESNO | MB_DEFBUTTON2)
                                        == MBID_YES)
                                    if (WinReplaceObjectClass(
                                            pscd->pRecordSelected->pwps->pszClassName,
                                            scd.szClassSelected,
                                            TRUE))
                                        // success
                                        cmnMessageBoxMsgExt(hwndDlg,
                                                121,
                                                pTable, 2, 129,
                                                MB_OK);
                                    else
                                        // error
                                        cmnMessageBoxMsgExt(hwndDlg,
                                                104,
                                                pTable, 2, 130,
                                                MB_OK);
                            }
                        }
                break; }

                // "Unreplace class" menu command
                case ID_XSMI_WPS_UNREPLACE: {
                    if (pscd->pRecordSelected)
                        if (pscd->pRecordSelected->pwps) {
                            BOOL fAllow = FALSE;
                            PSZ pTable[2];
                            pTable[0] = pscd->pRecordSelected->pwps->szReplacesClass;
                            pTable[1] = pscd->pRecordSelected->pwps->pszClassName;

                            if (strncmp(pscd->pRecordSelected->pwps->pszClassName,
                                            "XFld", 4) == 0) {
                                // XFolder class
                                if (cmnMessageBoxMsgExt(hwndDlg,
                                            116,
                                            pTable, 2, 125,
                                            MB_YESNO | MB_DEFBUTTON2)
                                        == MBID_YES)
                                    fAllow = TRUE;
                            } else
                                if (cmnMessageBoxMsgExt(hwndDlg,
                                            116,
                                            pTable, 2, 126,
                                            MB_YESNO | MB_DEFBUTTON2)
                                        == MBID_YES)
                                    fAllow = TRUE;

                            if (fAllow) {
                                if (WinReplaceObjectClass(
                                        pscd->pRecordSelected->pwps->szReplacesClass,
                                        pscd->pRecordSelected->pwps->pszClassName,
                                        FALSE))
                                    // success
                                    cmnMessageBoxMsgExt(hwndDlg,
                                            121,
                                            pTable, 2, 127,
                                            MB_OK);
                                else
                                    // error
                                    cmnMessageBoxMsgExt(hwndDlg,
                                            104,
                                            pTable, 2, 128,
                                            MB_OK);
                            }
                        }
                break; }
            }
        break; }

        /*
         * WM_DESTROY:
         *      clean up big time
         */

        case WM_DESTROY: {
            HPOINTER hptrOld = WinQueryPointer(HWND_DESKTOP);
            WinSetPointer(HWND_DESKTOP,
                    WinQuerySysPointer(HWND_DESKTOP, SPTR_WAIT, FALSE));
            if (hwndClassInfo) {
                WinDestroyWindow(hwndClassInfo);
                hwndClassInfo = NULLHANDLE;
            }
            // free cnr records
            WinSendMsg(pscd->hwndCnr,
                        CM_REMOVERECORD,
                        (MPARAM)NULL,
                        MPFROM2SHORT(0, // remove all records
                                CMA_FREE | CMA_INVALIDATE));

            // cleanup allocated WPS data (objdlgs.c)
            cmnCleanupWpsClasses(pscd->pwpsc);
            free(pscd);
            free(pszClassInfo);
            pszClassInfo = NULL;
            mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);
            WinSetPointer(HWND_DESKTOP, hptrOld);
        break; }

        default:
            mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);
    }
    return (mrc);
}

/*
 * DosEnumDrives:
 *      this copies the drive letters of the drives on the
 *      system to pszBuffer which match the pszFileSystem
 *      string (for example, "HPFS"); if pszFileSystem
 *      is NULL, all drives are enumerated
 */

VOID DosEnumDrives(PSZ pszBuffer, PSZ pszFileSystem)
{
    CHAR szDrives[] = " ABCDEFGHIJKLMNOPQRSTUVWXYZ",
         szName[5] = "";
    ULONG ulLogicalDrive = 3, // start with drive C:
          ulFound = 0;        // found drives count
    APIRET arc             = NO_ERROR; // return code

    // go thru the drives, start with C: (== 3)
    do {
        UCHAR nonRemovable=0;
        ULONG parmSize=2;
        ULONG dataLen=1;
        struct
        {
            UCHAR dummy,drive;
        } parms;

        parms.drive=(UCHAR)(ulLogicalDrive-1);
        arc = DosDevIOCtl((HFILE)-1,
                        IOCTL_DISK,
                        DSK_BLOCKREMOVABLE,
                        &parms,
                        parmSize,
                        &parmSize,
                        &nonRemovable,
                        1,
                        &dataLen);

        if (arc == NO_ERROR)
        {
            if (nonRemovable) {
                ULONG  ulOrdinal       = 0;     // ordinal of entry in name list
                BYTE   fsqBuffer[sizeof(FSQBUFFER2) + (3 * CCHMAXPATH)] = {0};
                ULONG  cbBuffer   = sizeof(fsqBuffer);        // Buffer length)
                PFSQBUFFER2 pfsqBuffer = (PFSQBUFFER2)fsqBuffer;

                szName[0] = szDrives[ulLogicalDrive];
                szName[1] = ':';
                szName[2] = '\0';

                arc = DosQueryFSAttach(
                                szName,          // logical drive of attached FS
                                ulOrdinal,       // ignored for FSAIL_QUERYNAME
                                FSAIL_QUERYNAME, // return data for a Drive or Device
                                pfsqBuffer,      // returned data
                                &cbBuffer);      // returned data length

                if (arc == NO_ERROR)
                {
                    // The data for the last three fields in the FSQBUFFER2
                    // structure are stored at the offset of fsqBuffer.szName.
                    // Each data field following fsqBuffer.szName begins
                    // immediately after the previous item.
                    PSZ pszFSDName = pfsqBuffer->szName + pfsqBuffer->cbName + 1;
                    if (pszFileSystem == NULL) {
                        // enum-all mode: always copy
                        pszBuffer[ulFound] = szName[0]; // drive letter
                        ulFound++;
                    } else if (strcmp(pszFSDName, pszFileSystem) == 0) {
                        pszBuffer[ulFound] = szName[0]; // drive letter
                        ulFound++;
                    }
                }
            }
            ulLogicalDrive++;
        }
    } while ( arc == NO_ERROR );

    pszBuffer[ulFound] = '\0';
}

/*
 * fnwpConfigCommon:
 *      while fnwpSettingsDlgCommon is the common dlg func for
 *      those pages dealing with the XFolder Global Settings,
 *      this one is used by all the pages dealing with
 *      CONFIG.SYS settings in the "OS/2 Kernel" object. It
 *      contains all the common logic for parsing and changing
 *      CONFIG.SYS settings.
 */

ULONG   ulTimer = 0;
CHAR    szOrigSwapPath[CCHMAXPATH] = "";
CHAR    szConfigSys[CCHMAXPATH];
CHAR    aszAllDrives[30][5];  // 30 strings with 5 chars each for spin button
PSZ     apszAllDrives[30];

MRESULT EXPENTRY fnwpConfigCommon(HWND hwndDlg, USHORT usSettingsPage,
                                            ULONG msg, MPARAM mp1, MPARAM mp2)
{
    MRESULT mrc = (MPARAM)TRUE;
    // APIRET  rc;
    // ULONG   ulAction, ulLocal, ulSizeOfConfigSys;
    XFldWPS *somSelf = (XFldWPS*)WinQueryWindowPtr(hwndDlg, QWL_USER);

    switch(msg)
    {
        case WM_INITDLG: {
            HPOINTER hptrOld = WinQueryPointer(HWND_DESKTOP);
            HPOINTER hptrWait = WinQuerySysPointer(HWND_DESKTOP,
                        SPTR_WAIT, FALSE);
            WinSetPointer(HWND_DESKTOP, hptrWait);

            somSelf = (SOMAny*)mp2;
            WinSetWindowPtr(hwndDlg, QWL_USER, somSelf);

            sprintf(szConfigSys, "%c:\\config.sys", DosQueryBootDrive());

            if (    (usSettingsPage == SP_SCHEDULER)
                ||  (usSettingsPage == SP_MEMORY)
               )
            {
                ulTimer = WinStartTimer(WinQueryAnchorBlock(hwndDlg),
                        hwndDlg, 1, 2000);
                // let's not wait 2 secs for the first timer msg
                WinPostMsg(hwndDlg, WM_TIMER, MPNULL, MPNULL);
            }

            WinSendMsg(hwndDlg, WM_SETTINGS2DLG, 0, 0);

            mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);

            WinSetPointer(HWND_DESKTOP, hptrOld);

            WinEnableDlgItem(hwndDlg, DID_APPLY, FALSE);

            // on the "HPFS" page:
            // if the system has any HPFS drives,
            // we disable the "HPFS installed" item
            if (usSettingsPage == SP_HPFS) {
                CHAR szHPFSDrives[30];
                DosEnumDrives(szHPFSDrives, "HPFS");
                if (strlen(szHPFSDrives) > 0)
                    WinEnableDlgItem(hwndDlg, ID_XSDI_OS_FSINSTALLED, FALSE);
            }
            else if (usSettingsPage == SP_ERRORS) {
                CHAR szAllDrives[30];
                PSZ p = szAllDrives;
                ULONG ul = 0;
                DosEnumDrives(szAllDrives, NULL); // all drives

                while (*p) {
                    aszAllDrives[ul][0] = szAllDrives[ul];
                    aszAllDrives[ul][1] = '\0';
                    apszAllDrives[ul] = &(aszAllDrives[ul][0]);
                    p++;
                    ul++;
                }
                WinSendDlgItemMsg(hwndDlg, ID_XSDI_OS_SUPRESSP_DRIVE,
                        SPBM_SETARRAY,
                        (MPARAM)apszAllDrives,
                        (MPARAM)ul);
            }
        break; }

        /*
         * WM_SETTINGS2DLG:
         *      read CONFIG.SYS from disk and set dlg items
         */

        case WM_SETTINGS2DLG: {
            PSZ     pszConfigSys = NULL;
            pszConfigSys = DosReadTextFile(szConfigSys, 1000);
            if (pszConfigSys == NULL)
                DebugBox(szConfigSys, "XFolder was unable to open the CONFIG.SYS file.");

            if (pszConfigSys) {
                PSZ     p;
                ULONG   ul;

                switch (usSettingsPage) {
                    case SP_SCHEDULER: {
                        if (p = strGetParameter(pszConfigSys, "THREADS=", NULL, 0)) {
                            sscanf(p, "%d", &ul);
                        } else // default
                            ul = 64;
                        WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_MAXTHREADS, 128, 4096, ul);

                        if (p = strGetParameter(pszConfigSys, "MAXWAIT=", NULL, 0)) {
                            sscanf(p, "%d", &ul);
                        } else // default
                            ul = 3;
                        WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_MAXWAIT, 1, 10, ul);

                        if (p = strGetParameter(pszConfigSys, "PRIORITY_DISK_IO=", NULL, 0)) {
                            WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_PRIORITYDISKIO,
                                (strncmp(p, "YES", 3) == 0));
                        } else // default
                            WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_PRIORITYDISKIO,
                                TRUE);
                    break; }

                    case SP_MEMORY: {
                        // installed physical memory
                        CHAR szMemory[30];
                        ULONG   aulSysInfo[QSV_MAX] = {0};
                        DosQuerySysInfo(1L, QSV_MAX,
                                            (PVOID)aulSysInfo, sizeof(ULONG)*QSV_MAX);
                        sprintf(szMemory, "%d",
                                   (aulSysInfo[QSV_TOTPHYSMEM-1] + (512*1000)) / 1024 / 1024);
                        WinSetDlgItemText(hwndDlg, ID_XSDI_OS_PHYSICALMEMORY, szMemory);

                        // parse SWAPPATH command
                        if (p = strGetParameter(pszConfigSys, "SWAPPATH=", NULL, 0)) {
                            CHAR    szSwapPath[CCHMAXPATH] = "Error";
                            ULONG   ulMinFree = 2048, ulMinSize = 2048;
                            // int     iScanned;
                            sscanf(p, "%s %d %d",
                                        &szSwapPath, &ulMinFree, &ulMinSize);

                            WinSetDlgItemText(hwndDlg, ID_XSDI_OS_SWAPPATH, szSwapPath);
                            WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_MINSWAPSIZE,
                                    2, 100, (ulMinSize / 1024));
                            WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_MINSWAPFREE,
                                    2, 1000, (ulMinFree / 1024));

                            if (strlen(szOrigSwapPath) == 0) {
                                if (szSwapPath[strlen(szSwapPath)-1] != '\\')
                                    sprintf(szOrigSwapPath, "%s\\swapper.dat", szSwapPath);
                                else
                                    sprintf(szOrigSwapPath, "%sswapper.dat", szSwapPath);
                            }
                        }
                    break; }

                    case SP_HPFS: {
                        CHAR    szParameter[300] = "",
                                // szTemp[300] = "",
                                szSearchKey[100],
                                szAutoCheck[200] = "";
                        ULONG   ulCacheSize = 0,
                                ulThreshold = 4,
                                ulMaxAge = 5000,
                                ulDiskIdle = 1000,
                                ulBufferIdle = 500;
                        BOOL    fLazyWrite = TRUE;

                        szAutoCheck[0] = DosQueryBootDrive();  // default value

                        // evaluate IFS=...\HPFS.IFS
                        sprintf(szSearchKey, "IFS=%c:\\OS2\\HPFS.IFS ", DosQueryBootDrive());
                        p = strGetParameter(pszConfigSys, szSearchKey,
                                szParameter, sizeof(szParameter));

                        if (p) {
                            PSZ p2;
                            if (p2 = strstr(szParameter, "/CACHE:"))
                                sscanf(p2+7, "%d", &ulCacheSize);
                            if (p2 = strstr(szParameter, "/CRECL:"))
                                sscanf(p2+7, "%d", &ulThreshold);
                            if (p2 = strstr(szParameter, "/AUTOCHECK:"))
                                sscanf(p2+11, "%s", &szAutoCheck);
                        }

                        WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_FSINSTALLED,
                                    (p != 0));
                        WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_CACHESIZE_AUTO,
                                    (ulCacheSize == 0));
                        WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHESIZE,
                                    0, 2048, ulCacheSize);
                        WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHE_THRESHOLD,
                                    4, 64, ulThreshold);
                        WinSetDlgItemText(hwndDlg, ID_XSDI_OS_AUTOCHECK, szAutoCheck);

                        // evaluate
                        // RUN=...\CACHE.EXE /MAXAGE:60000 /DISKIDLE:1000 /BUFFERIDLE:40000
                        sprintf(szSearchKey, "RUN=%c:\\OS2\\CACHE.EXE ", DosQueryBootDrive());
                        p = strGetParameter(pszConfigSys, szSearchKey,
                                    szParameter, sizeof(szParameter));

                        if (p) {
                            PSZ p2;
                            if (p2 = strstr(szParameter, "/MAXAGE:"))
                                sscanf(p2+8,  "%d", &ulMaxAge);
                            if (p2 = strstr(szParameter, "/DISKIDLE:"))
                                sscanf(p2+10, "%d", &ulDiskIdle);
                            if (p2 = strstr(szParameter, "/BUFFERIDLE:"))
                                sscanf(p2+12, "%d", &ulBufferIdle);
                            if (strstr(szParameter, "/LAZY:OFF"))
                                fLazyWrite = FALSE;
                        }

                        WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_CACHE_LAZYWRITE,
                                    fLazyWrite);
                        WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHE_MAXAGE,
                                    500, 100*1000, ulMaxAge);
                        WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHE_BUFFERIDLE,
                                    500, 100*1000, ulBufferIdle);
                        WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHE_DISKIDLE,
                                    500, 100*1000, ulDiskIdle);

                    break; }

                    case SP_FAT: {
                        CHAR    szParameter[300] = "",
                                // szTemp[300] = "",
                                szAutoCheck[200] = "";
                        ULONG   ulCacheSize = 512,
                                ulThreshold = 4;
                        PSZ     p2;

                        // evaluate DISKCACHE
                        p = strGetParameter(pszConfigSys, "DISKCACHE=",
                                szParameter, sizeof(szParameter));

                        // enable "Cache installed" item if DISKCACHE= found
                        WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_FSINSTALLED,
                                    (p != NULL));

                        // now set the other items according to the DISKCACHE
                        // parameters; if that was not found, the default values
                        // above will be used
                        if (szParameter[0] == 'D')
                            WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_CACHESIZE_AUTO,
                                        TRUE);
                        else
                            sscanf(szParameter, "%d", &ulCacheSize);

                        p2 = strchr(szParameter, ','); // get next parameter
                        // optional "LW" parameter (lazy write)
                        if (p2) {
                            if (strncmp(p2+1, "LW", 2) == 0) {
                                WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_CACHE_LAZYWRITE,
                                            TRUE);
                                p2 = strchr(p2+1, ','); // get next parameter
                            }
                        }
                        // optional threshold parameter
                        if (p2) {
                            sscanf(p2+1, "%d", &ulThreshold);
                            p2 = strchr(p2+1, ','); // get next parameter
                        }
                        // optional "autocheck" parameter
                        if (p2) {
                            if (strncmp(p2+1, "AC:", 3) == 0)
                                strcpy(szAutoCheck, p2+4);
                        }

                        WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHESIZE,
                                    0, 14400, ulCacheSize);
                        // the threshold param is in sectors of 512 bytes
                        // each, so for getting KB, we need to divide by 2
                        WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHE_THRESHOLD,
                                    4, 64, ulThreshold / 2);
                        WinSetDlgItemText(hwndDlg, ID_XSDI_OS_AUTOCHECK, szAutoCheck);

                    break; }

                    case SP_WPS: {
                        CHAR    szParameter[300] = "";
                        PSZ p = strGetParameter(pszConfigSys, "SET AUTOSTART=",
                                szParameter, sizeof(szParameter));
                        BOOL fAutoRefreshFolders = TRUE;
                        if (p) {
                            WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_PROGRAMS,
                                (stristr(szParameter, "PROGRAMS") != NULL));
                            WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_TASKLIST,
                                (stristr(szParameter, "TASKLIST") != NULL));
                            WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_CONNECTIONS,
                                (stristr(szParameter, "CONNECTIONS") != NULL));
                            WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_LAUNCHPAD,
                                (stristr(szParameter, "LAUNCHPAD") != NULL));
                            WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_WARPCENTER,
                                (stristr(szParameter, "WARPCENTER") != NULL));
                        }

                        p = strGetParameter(pszConfigSys, "SET RESTARTOBJECTS=",
                                szParameter, sizeof(szParameter));
                        if ( (p == NULL) || (stristr(szParameter, "YES")) )
                            WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_RESTART_YES, TRUE);
                        else if (stristr(szParameter, "NO"))
                            WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_RESTART_NO, TRUE);
                        else if (stristr(szParameter, "STARTUPFOLDERSONLY"))
                            WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_RESTART_FOLDERS, TRUE);

                        if (stristr(szParameter, "REBOOTONLY"))
                            WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_RESTART_REBOOT, TRUE);

                        // auto-refresh folders: cannot be disabled on Warp 3
                        p = strGetParameter(pszConfigSys, "SET AUTOREFRESHFOLDERS=",
                                szParameter, sizeof(szParameter));
                        if (p)
                            if (stristr(szParameter, "NO"))
                                fAutoRefreshFolders = FALSE;
                        WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTOREFRESHFOLDERS,
                                    fAutoRefreshFolders);
                    break; }

                    case SP_ERRORS: {
                        CHAR    szParameter[300] = "";
                        BOOL fAutoFail = FALSE,
                             fReIPL = FALSE;
                        PSZ p = strGetParameter(pszConfigSys, "AUTOFAIL=",
                                szParameter, sizeof(szParameter));
                        if (p)
                            if (stristr(szParameter, "YES"))
                                fAutoFail = TRUE;
                        WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTOFAIL, fAutoFail);

                        p = strGetParameter(pszConfigSys, "REIPL=",
                                szParameter, sizeof(szParameter));
                        if (p)
                            if (stristr(szParameter, "YES"))
                                fReIPL = TRUE;
                        WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_REIPL, fReIPL);

                        p = strGetParameter(pszConfigSys, "SUPPRESSPOPUPS=",
                                szParameter, sizeof(szParameter));
                        WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_SUPRESSPOPUPS,
                                (p != NULL));
                        if (p) {
                        }

                    break; }
                } // end switch

                free(pszConfigSys);
                pszConfigSys = NULL;
            }
            WinPostMsg(hwndDlg, WM_ENABLEITEMS, MPNULL, MPNULL);

        break; }

        /*
         * WM_DLG2SETTINGS:
         *      here, update CONFIG.SYS on disk according
         *      the settings page's dlg items
         */

        case WM_DLG2SETTINGS: {
            PSZ     pszConfigSys = NULL;
            if (pszConfigSys == NULL) {
                pszConfigSys = DosReadTextFile(szConfigSys, 1000);
                if (pszConfigSys == NULL)
                    DebugBox(szConfigSys, "XFolder was unable to open the CONFIG.SYS file.");
            }

            if (pszConfigSys) {
                // PSZ     p;
                ULONG   ul = 0, ulMinFree = 0, ulMinSize = 0;
                CHAR    szTemp[CCHMAXPATH];
                CHAR    szSwapPath[CCHMAXPATH];

                switch (usSettingsPage) {
                    case SP_SCHEDULER: {
                        WinSendDlgItemMsg(hwndDlg, ID_XSDI_OS_MAXTHREADS,
                              SPBM_QUERYVALUE,
                              (MPARAM)&ul,
                              MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));
                        sprintf(szTemp, "%d", ul);
                        strSetParameter(pszConfigSys, "THREADS=", szTemp);

                        WinSendDlgItemMsg(hwndDlg, ID_XSDI_OS_MAXWAIT,
                              SPBM_QUERYVALUE,
                              (MPARAM)&ul,
                              MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));
                        sprintf(szTemp, "%d", ul);
                        strSetParameter(pszConfigSys, "MAXWAIT=", szTemp);

                        strSetParameter(pszConfigSys, "PRIORITY_DISK_IO=",
                                (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_PRIORITYDISKIO)
                                        ? "YES" : "NO")
                            );
                    break; }

                    case SP_MEMORY: {
                        WinQueryDlgItemText(hwndDlg, ID_XSDI_OS_SWAPPATH,
                                        sizeof(szSwapPath)-1, szSwapPath);
                        WinSendDlgItemMsg(hwndDlg, ID_XSDI_OS_MINSWAPSIZE,
                              SPBM_QUERYVALUE,
                              (MPARAM)&ulMinSize,
                              MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));
                        WinSendDlgItemMsg(hwndDlg, ID_XSDI_OS_MINSWAPFREE,
                              SPBM_QUERYVALUE,
                              (MPARAM)&ulMinFree,
                              MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));
                        sprintf(szTemp, "%s %d %d", szSwapPath, ulMinFree*1024, ulMinSize*1024);
                        strSetParameter(pszConfigSys, "SWAPPATH=", szTemp);

                    }

                    case SP_HPFS: {
                        CHAR    szTemp[300] = "",
                                szAutoCheck[200] = "",
                                szSearchKey[100] = "";
                        ULONG   ulCacheSize = 0,
                                ulThreshold = 4,
                                ulMaxAge = 5000,
                                ulDiskIdle = 1000,
                                ulBufferIdle = 500;
                        // BOOL    fLazyWrite = TRUE;

                        WinSendDlgItemMsg(hwndDlg, ID_XSDI_OS_CACHE_THRESHOLD,
                              SPBM_QUERYVALUE,
                              (MPARAM)&ulThreshold,
                              MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));
                        WinQueryDlgItemText(hwndDlg, ID_XSDI_OS_AUTOCHECK,
                                        sizeof(szAutoCheck)-1, szAutoCheck);

                        if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_CACHESIZE_AUTO)) {
                            // auto-size cache: leave out /CACHE
                            sprintf(szTemp,
                                    "/CRECL:%d /AUTOCHECK:%s",
                                    DosQueryBootDrive(),
                                    ulThreshold,
                                    szAutoCheck);
                        } else {
                            // no auto-size cache
                            WinSendDlgItemMsg(hwndDlg, ID_XSDI_OS_CACHESIZE,
                                  SPBM_QUERYVALUE,
                                  (MPARAM)&ulCacheSize,
                                  MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));
                            sprintf(szTemp,
                                    "/CACHE:%d /CRECL:%d /AUTOCHECK:%s",
                                    ulCacheSize,
                                    ulThreshold,
                                    szAutoCheck);
                        }
                        sprintf(szSearchKey, "IFS=%c:\\OS2\\HPFS.IFS ", DosQueryBootDrive());
                        strSetParameter(pszConfigSys, szSearchKey, szTemp);

                        if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_CACHE_LAZYWRITE)) {
                            WinSendDlgItemMsg(hwndDlg, ID_XSDI_OS_CACHE_MAXAGE,
                                  SPBM_QUERYVALUE,
                                  (MPARAM)&ulMaxAge,
                                  MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));
                            WinSendDlgItemMsg(hwndDlg, ID_XSDI_OS_CACHE_DISKIDLE,
                                  SPBM_QUERYVALUE,
                                  (MPARAM)&ulDiskIdle,
                                  MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));
                            WinSendDlgItemMsg(hwndDlg, ID_XSDI_OS_CACHE_BUFFERIDLE,
                                  SPBM_QUERYVALUE,
                                  (MPARAM)&ulBufferIdle,
                                  MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));
                            sprintf(szTemp,
                                    "/MAXAGE:%d /DISKIDLE:%d /BUFFERIDLE:%d /READAHEAD:ON LAZY:1",
                                    ulMaxAge,
                                    ulDiskIdle,
                                    ulBufferIdle);
                        } else {
                            strcpy(szTemp, "/LAZY:OFF");
                        }
                        // compose the key with CACHE;
                        sprintf(szSearchKey, "RUN=%c:\\OS2\\CACHE.EXE ", DosQueryBootDrive());
                        strSetParameter(pszConfigSys, szSearchKey, szTemp);

                    break; }

                    case SP_FAT: {
                        // "Cache installed" checked?
                        if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_FSINSTALLED)) {
                            CHAR    // szParameter[300] = "",
                                    szTemp[300] = "",
                                    szAutoCheck[200] = "";
                            ULONG   ulCacheSize = 512,
                                    ulThreshold = 4;
                            // PSZ     p2;

                            if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_CACHESIZE_AUTO))
                                strcpy(szTemp, "D");
                            else {
                                // no auto-size cache
                                WinSendDlgItemMsg(hwndDlg, ID_XSDI_OS_CACHESIZE,
                                      SPBM_QUERYVALUE,
                                      (MPARAM)&ulCacheSize,
                                      MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));
                                sprintf(szTemp, "%d", ulCacheSize);
                            }

                            if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_CACHE_LAZYWRITE))
                                strcat(szTemp, ",LW");

                            WinSendDlgItemMsg(hwndDlg, ID_XSDI_OS_CACHE_THRESHOLD,
                                  SPBM_QUERYVALUE,
                                  (MPARAM)&ulThreshold,
                                  MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));
                            // again, convert KB to sectors for the threshold
                            sprintf(szTemp+strlen(szTemp), ",%d", ulThreshold*2);

                            WinQueryDlgItemText(hwndDlg, ID_XSDI_OS_AUTOCHECK,
                                            sizeof(szAutoCheck)-1, szAutoCheck);
                            if (strlen(szAutoCheck))
                                sprintf(szTemp+strlen(szTemp), ",AC:%s", szAutoCheck);

                            strSetParameter(pszConfigSys, "DISKCACHE=", szTemp);

                        } else {
                            // no "Cache installed":
                            strDeleteLine(pszConfigSys, "DISKCACHE=");
                        }
                    break; }

                    case SP_WPS: {
                        CHAR   szTemp[300] = "";
                        BOOL   fCopied = FALSE;
                        if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_PROGRAMS)) {
                            strcpy(szTemp, "PROGRAMS");
                            fCopied = TRUE;
                        }
                        if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_TASKLIST)) {
                            if (fCopied)
                                strcat(szTemp, ",");
                            strcat(szTemp, "TASKLIST");
                            fCopied = TRUE;
                        }
                        if (fCopied)
                            strcat(szTemp, ",");
                        strcat(szTemp, "FOLDERS");
                        if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_CONNECTIONS)) {
                            strcat(szTemp, ",CONNECTIONS");
                        }
                        if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_LAUNCHPAD)) {
                            strcat(szTemp, ",LAUNCHPAD");
                        }
                        if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_WARPCENTER)) {
                            strcat(szTemp, ",WARPCENTER");
                        }
                        strSetParameter(pszConfigSys, "SET AUTOSTART=", szTemp);

                        if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_RESTART_FOLDERS))
                            strcpy(szTemp, "STARTUPFOLDERSONLY");
                        else if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_RESTART_NO))
                            strcpy(szTemp, "NO");
                        else
                            strcpy(szTemp, "YES");
                        if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_RESTART_REBOOT))
                            strcat(szTemp, ",REBOOTONLY");
                        strSetParameter(pszConfigSys, "SET RESTARTOBJECTS=", szTemp);

                        if (DosIsWarp4())
                            if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTOREFRESHFOLDERS))
                                strDeleteLine(pszConfigSys, "SET AUTOREFRESHFOLDERS=");
                            else
                                strSetParameter(pszConfigSys, "SET AUTOREFRESHFOLDERS=",
                                        "NO");
                    break; }

                    case SP_ERRORS: {
                        if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTOFAIL))
                            strSetParameter(pszConfigSys, "AUTOFAIL=", "YES");
                        else
                            strDeleteLine(pszConfigSys, "AUTOFAIL=");

                        if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_REIPL))
                            strSetParameter(pszConfigSys, "REIPL=", "YES");
                        else
                            strDeleteLine(pszConfigSys, "REIPL=");

                        if (WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_SUPRESSPOPUPS)) {
                            CHAR szSpinButtonValue[5];
                            WinSendDlgItemMsg(hwndDlg, ID_XSDI_OS_SUPRESSP_DRIVE,
                                    SPBM_QUERYVALUE,
                                    (MPARAM)szSpinButtonValue,
                                    MPFROM2SHORT(sizeof(szSpinButtonValue)-1,
                                        SPBQ_UPDATEIFVALID));
                            strSetParameter(pszConfigSys, "SUPPRESSPOPUPS=",
                                    szSpinButtonValue);
                        } else
                            strDeleteLine(pszConfigSys, "SUPPRESSPOPUPS=");


                    break; }
                } // end switch

                sprintf(szConfigSys, "%c:\\config.sys", DosQueryBootDrive());
                DosWriteTextFile(szConfigSys, pszConfigSys, TRUE);

                cmnMessageBoxMsg(hwndDlg, 100, 136, MB_OK);

                if (pszConfigSys) {
                    free(pszConfigSys);
                    pszConfigSys = NULL;
                }
            }
        break; }

        case WM_ENABLEITEMS: {
            if (    (usSettingsPage == SP_HPFS)
               )
            {
                BOOL fLazyWrite = WinIsDlgItemChecked(hwndDlg,
                                ID_XSDI_OS_CACHE_LAZYWRITE);
                WinEnableDlgItem(hwndDlg,
                            ID_XSDI_OS_CACHE_MAXAGE, fLazyWrite);
                WinEnableDlgItem(hwndDlg,
                            ID_XSDI_OS_CACHE_BUFFERIDLE, fLazyWrite);
                WinEnableDlgItem(hwndDlg,
                            ID_XSDI_OS_CACHE_DISKIDLE, fLazyWrite);
            }

            if (    (usSettingsPage == SP_HPFS)
                ||  (usSettingsPage == SP_FAT)
               )
            {
                WinEnableDlgItem(hwndDlg, ID_XSDI_OS_CACHESIZE,
                            !WinIsDlgItemChecked(hwndDlg,
                                ID_XSDI_OS_CACHESIZE_AUTO));
            }
            else if (usSettingsPage == SP_WPS)
            {
                WinEnableDlgItem(hwndDlg, ID_XSDI_OS_AUTO_WARPCENTER, (DosIsWarp4()));
                WinEnableDlgItem(hwndDlg, ID_XSDI_OS_AUTOREFRESHFOLDERS, (DosIsWarp4()));
            }
            else if (usSettingsPage == SP_ERRORS)
                WinEnableDlgItem(hwndDlg, ID_XSDI_OS_SUPRESSP_DRIVE,
                    WinIsDlgItemChecked(hwndDlg, ID_XSDI_OS_SUPRESSPOPUPS));
        break; }

        /*
         * WM_OPTIMIZE:
         *      this is posted after WM_COMMAND has been
         *      received for the "Optimize" button; we will
         *      now set the controls for optimized values
         */

        case WM_OPTIMIZE: {
            switch (usSettingsPage) {
                case SP_SCHEDULER: {
                    // THREADS=
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_MAXTHREADS,
                            128, 4096,
                            // get current thread count, add 50% for safety,
                            // and round up to the next multiple of 128
                            (( ((qpsQueryThreadCount() * 3) / 2) + 127 ) / 128) * 128
                    );

                    // MAXWAIT=2
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_MAXWAIT, 1, 10,
                        2);

                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_PRIORITYDISKIO,
                        TRUE);
                break; }

                case SP_MEMORY: {
                    // minsize: get current size, add 50% and
                    // round up to the next multiple of 2 MB
                    if (strlen(szOrigSwapPath) != 0) {
                        ULONG ulSize = DosQueryPathSize(szOrigSwapPath)/1024/1024;
                        WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_MINSWAPSIZE,
                                2, 100,
                                ( (((ulSize*3)/2)+1) / 2 ) * 2
                        );
                    }

                    // minfree = 2
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_MINSWAPFREE,
                            2, 1000,
                            2);
                break; }

                case SP_HPFS: {
                    ULONG   aulSysInfo[QSV_MAX] = {0},
                            ulInstalledMB;
                    CHAR szHPFSDrives[30];
                    DosQuerySysInfo(1L, QSV_MAX,
                                        (PVOID)aulSysInfo, sizeof(ULONG)*QSV_MAX);
                    ulInstalledMB =
                               (aulSysInfo[QSV_TOTPHYSMEM-1] + (512*1000)) / 1024 / 1024;
                    DosEnumDrives(szHPFSDrives, "HPFS");

                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_FSINSTALLED,
                                (strlen(szHPFSDrives) > 0));
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_CACHESIZE_AUTO,
                                FALSE);
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHESIZE,
                                0, 2048,
                                (ulInstalledMB > 16) ? 2048 : 1024);
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHE_THRESHOLD,
                                4, 64, 64);
                    WinSetDlgItemText(hwndDlg, ID_XSDI_OS_AUTOCHECK, szHPFSDrives);

                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_CACHE_LAZYWRITE,
                                TRUE);
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHE_MAXAGE,
                                500, 100*1000, 60*1000);
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHE_BUFFERIDLE,
                                500, 100*1000, 30*1000);
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHE_DISKIDLE,
                                500, 100*1000, 60*1000);

                break; }

                case SP_FAT: {
                    ULONG   aulSysInfo[QSV_MAX] = {0},
                            ulInstalledMB;
                    CHAR szFATDrives[30];
                    DosQuerySysInfo(1L, QSV_MAX,
                                        (PVOID)aulSysInfo, sizeof(ULONG)*QSV_MAX);
                    ulInstalledMB =
                               (aulSysInfo[QSV_TOTPHYSMEM-1] + (512*1000)) / 1024 / 1024;
                    DosEnumDrives(szFATDrives, "FAT");

                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_FSINSTALLED,
                                (strlen(szFATDrives) > 0));

                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_CACHESIZE_AUTO, FALSE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_CACHE_LAZYWRITE, TRUE);
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHESIZE,
                                0, 14400,
                                (ulInstalledMB > 16) ? 2048 : 1024);
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHE_THRESHOLD,
                                4, 64, 64);
                    // do not auto-check FAT drives
                    WinSetDlgItemText(hwndDlg, ID_XSDI_OS_AUTOCHECK, "");

                break; }

                case SP_WPS: {
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_PROGRAMS, TRUE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_TASKLIST, TRUE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_CONNECTIONS, TRUE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_LAUNCHPAD, FALSE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_WARPCENTER, FALSE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_RESTART_FOLDERS, TRUE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_RESTART_REBOOT, FALSE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTOREFRESHFOLDERS,
                                FALSE);
                break; }

                case SP_ERRORS: {
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTOFAIL, TRUE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_REIPL, FALSE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_SUPRESSPOPUPS, FALSE);
                break; }
            } // end switch

            WinPostMsg(hwndDlg, WM_ENABLEITEMS, MPNULL, MPNULL);
        break; }

        /*
         * WM_DEFAULT:
         *      this is posted after WM_COMMAND has been
         *      received for the "Default" button; we will
         *      now set the controls for default values
         */

        case WM_DEFAULT: {
            switch (usSettingsPage) {
                case SP_SCHEDULER: {
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_MAXTHREADS,
                            128, 4096, (DosIsWarp4()) ? 512 : 256);
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_MAXWAIT, 1, 10,
                        3);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_PRIORITYDISKIO,
                        TRUE);
                break; }

                case SP_MEMORY: {
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_MINSWAPSIZE,
                            2, 100, 2);
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_MINSWAPFREE,
                            2, 1000, 2);
                break; }

                case SP_HPFS: {
                    CHAR szHPFSDrives[30];
                    DosEnumDrives(szHPFSDrives, "HPFS");

                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_FSINSTALLED, TRUE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_CACHESIZE_AUTO, FALSE);
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHESIZE,
                                0, 2048, 1024);
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHE_THRESHOLD,
                                4, 64, 4);
                    WinSetDlgItemText(hwndDlg, ID_XSDI_OS_AUTOCHECK, szHPFSDrives);

                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_CACHE_LAZYWRITE,
                                TRUE);
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHE_MAXAGE,
                                500, 100*1000, 5*1000);
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHE_BUFFERIDLE,
                                500, 100*1000, 500);
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHE_DISKIDLE,
                                500, 100*1000, 1000);

                break; }

                case SP_FAT: {
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_FSINSTALLED, TRUE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_CACHESIZE_AUTO, TRUE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_CACHE_LAZYWRITE, TRUE);
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHESIZE,
                                0, 14400, 1024);
                    WinSetDlgItemSpinData(hwndDlg, ID_XSDI_OS_CACHE_THRESHOLD,
                                4, 64, 4);
                    WinSetDlgItemText(hwndDlg, ID_XSDI_OS_AUTOCHECK, "");
                break; }

                case SP_WPS: {
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_PROGRAMS, TRUE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_TASKLIST, TRUE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_CONNECTIONS, TRUE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_LAUNCHPAD, TRUE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTO_WARPCENTER,
                                    (DosIsWarp4()));
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_RESTART_YES, TRUE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_RESTART_REBOOT, FALSE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTOREFRESHFOLDERS,
                                    (DosIsWarp4()));
                break; }

                case SP_ERRORS: {
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_AUTOFAIL, FALSE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_REIPL, FALSE);
                    WinSetDlgItemChecked(hwndDlg, ID_XSDI_OS_SUPRESSPOPUPS, FALSE);
                break; }
            } // end switch

            WinPostMsg(hwndDlg, WM_ENABLEITEMS, MPNULL, MPNULL);
        break; }

        /*
         * WM_CONTROL:
         *      intercept control notifications
         */

        case WM_CONTROL:
        {
            switch (SHORT2FROMMP(mp1)) {

                /*
                 * SPBN_UP/DOWNARROW:
                 *      for certain spin buttons, we will
                 *      make sure that pressing the up/down
                 *      buttons will not only change the
                 *      value by 1, but by something more
                 *      helpful
                 */

                case SPBN_UPARROW:
                case SPBN_DOWNARROW: {
                    LONG    lValue;
                    LONG    lGrid = 0;

                    switch (SHORT1FROMMP(mp1)) {
                        case ID_XSDI_OS_MAXTHREADS:
                            // "Scheduler" page; 64 steps
                            lGrid = 64;
                        break;

                        case ID_XSDI_OS_MINSWAPSIZE:
                        case ID_XSDI_OS_MINSWAPFREE:
                            lGrid = 2;
                        break;

                        case ID_XSDI_OS_CACHESIZE:
                            // HPFS and FAT pages; 64 KB steps
                            lGrid = 64;
                        break;

                        case ID_XSDI_OS_CACHE_THRESHOLD:
                            // HPFS and FAT pages; 4 KB steps
                            lGrid = 4;
                        break;

                        case ID_XSDI_OS_CACHE_MAXAGE:
                        case ID_XSDI_OS_CACHE_BUFFERIDLE:
                        case ID_XSDI_OS_CACHE_DISKIDLE:
                            // HPFS page; 1000 ms steps
                            lGrid = 1000;
                        break;
                    }

                    if (lGrid != 0) {
                        LONG lBottom, lTop;
                        // get value, which has already increased /
                        // decreased by 1
                        WinSendDlgItemMsg(hwndDlg, SHORT1FROMMP(mp1),
                              SPBM_QUERYVALUE,
                              (MPARAM)&lValue,
                              MPFROM2SHORT(0, SPBQ_UPDATEIFVALID));

                        // snap to the nearest grid
                        lValue = (lValue / lGrid) * lGrid;
                        // add /subtract grid
                        if (SHORT2FROMMP(mp1) == SPBN_UPARROW)
                            lValue += lGrid;
                        // else we'll have -= lGrid already

                        // balance with spin button limits
                        WinSendDlgItemMsg(hwndDlg, SHORT1FROMMP(mp1),
                              SPBM_QUERYLIMITS,
                              (MPARAM)&lTop,
                              (MPARAM)&lBottom);
                        if (lValue < lBottom)
                            lValue = lTop;
                        else if (lValue > lTop)
                            lValue = lBottom;

                        WinSendDlgItemMsg(hwndDlg, SHORT1FROMMP(mp1),
                              SPBM_SETCURRENTVALUE,
                              (MPARAM)(lValue),
                              MPNULL);
                    }
                break; }

                case EN_CHANGE: {
                    if (    (SHORT1FROMMP(mp1) == ID_XSDI_OS_SWAPPATH)
                         || (SHORT1FROMMP(mp1) == ID_XSDI_OS_AUTOCHECK)
                       )
                        WinEnableDlgItem(hwndDlg, DID_APPLY, TRUE); // "CONFIG.SYS" button
                break; }

                case SPBN_CHANGE:
                case BN_CLICKED: {
                    if (    (SHORT1FROMMP(mp1) != ID_XSDI_OS_SWAPPATH)
                         && (SHORT1FROMMP(mp1) != ID_XSDI_OS_AUTOCHECK)
                       )
                        WinEnableDlgItem(hwndDlg, DID_APPLY, TRUE); // "CONFIG.SYS" button

                    WinPostMsg(hwndDlg, WM_ENABLEITEMS, mp1, mp2);
                break; }

            } // end switch
            return WinDefDlgProc(hwndDlg, msg, mp1, mp2);
        } // end of WM_CONTROL

        /*
         * WM_COMMAND:
         *      button pressed
         */

        case WM_COMMAND: {
            switch (SHORT1FROMMP(mp1)) {
                case DID_APPLY: { // "Apply" button
                    if (    cmnMessageBoxMsg(hwndDlg,
                            100, 101,
                            MB_YESNO | MB_DEFBUTTON2)
                         == MBID_YES)
                    {
                        WinPostMsg(hwndDlg, WM_DLG2SETTINGS, MPNULL, MPNULL);
                        // disable "Apply" button
                        WinEnableDlgItem(hwndDlg, DID_APPLY, FALSE);
                    }
                break; }

                case DID_OPTIMIZE: { // "Optimize" button
                    WinPostMsg(hwndDlg, WM_OPTIMIZE, MPNULL, MPNULL);
                    // enable "Apply" button
                    WinEnableDlgItem(hwndDlg, DID_APPLY, TRUE);
                break; }

                case DID_DEFAULT: { // "Default" button
                    WinPostMsg(hwndDlg, WM_DEFAULT, MPNULL, MPNULL);
                    // enable "Apply" button
                    WinEnableDlgItem(hwndDlg, DID_APPLY, TRUE);
                break; }

                case ID_XSDI_OS_AUTOCHECK_PROPOSE: {
                    // "Propose" button for auto-chkdsk (HPFS/FAT pages):
                    // enumerate all HPFS or FAT drives on the system
                    CHAR szHPFSDrives[30];
                    DosEnumDrives(szHPFSDrives,
                            (usSettingsPage == SP_HPFS) ? "HPFS" : "FAT");
                    WinSetDlgItemText(hwndDlg, ID_XSDI_OS_AUTOCHECK, szHPFSDrives);
                    // enable "Apply" button
                    WinEnableDlgItem(hwndDlg, DID_APPLY, TRUE);
                break; }
            }
        break; } // end of WM_COMMAND

        case WM_HELP: {
            PSZ pszHelpLibrary = cmnQueryHelpLibrary();
            // always display help for the whole page, not for single items
            if (!_wpDisplayHelp(somSelf,
                    (usSettingsPage == SP_SCHEDULER) ? ID_XSH_SETTINGS_KERNEL1
                    : (usSettingsPage == SP_MEMORY) ? ID_XSH_SETTINGS_KERNEL2
                    : (usSettingsPage == SP_WPS) ? ID_XSH_SETTINGS_WPS
                    : (usSettingsPage == SP_ERRORS) ? ID_XSH_SETTINGS_ERRORS
                    : (usSettingsPage == SP_HPFS) ? ID_XSH_SETTINGS_HPFS
                    : ID_XSH_SETTINGS_FAT,
                    pszHelpLibrary))
            {
                cmnMessageBoxMsg(HWND_DESKTOP, 104, 134, MB_OK);
            }
        break; }

        /*
         * WM_TIMER:
         *      update thread count and swapper size
         */

        case WM_TIMER: {
            CHAR szTemp[20];

            switch (usSettingsPage) {
                case SP_SCHEDULER: {
                    sprintf(szTemp, "%d", qpsQueryThreadCount());
                    WinSetDlgItemText(hwndDlg, ID_XSDI_OS_CURRENTTHREADS, szTemp);
                break; }

                case SP_MEMORY: {
                    if (strlen(szOrigSwapPath) != 0) {
                        ULONG ulSize = DosQueryPathSize(szOrigSwapPath)/1024/1024;
                        if (ulSize) {
                            sprintf(szTemp, "%d", ulSize);
                            WinSetDlgItemText(hwndDlg, ID_XSDI_OS_CURRENTSWAPSIZE,
                                (szTemp));
                        } else
                            WinSetDlgItemText(hwndDlg, ID_XSDI_OS_CURRENTSWAPSIZE, "???");
                    }
                break; }
            }

            mrc = (MPARAM)0;
        break; }

        case WM_DESTROY: {
            WinStopTimer(WinQueryAnchorBlock(hwndDlg),
                    hwndDlg, 1);
            mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);
        break; }

        default:
            mrc = WinDefDlgProc(hwndDlg, msg, mp1, mp2);
    }
    return (mrc);
}

/*
 * fnwpConfigScheduler:
 *      dlg func for first "Kernel" settings page (scheduler etc.)
 */

MRESULT EXPENTRY fnwpConfigScheduler(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpConfigCommon(hwndDlg, SP_SCHEDULER, msg, mp1, mp2));
}

/*
 * fnwpConfigMemory:
 *      dlg func for second "Kernel" settings page (memory, swapper etc.)
 */

MRESULT EXPENTRY fnwpConfigMemory(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpConfigCommon(hwndDlg, SP_MEMORY, msg, mp1, mp2));
}

/*
 * fnwpConfigHPFS:
 *      dlg func for "HPFS" settings page
 */

MRESULT EXPENTRY fnwpConfigHPFS(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpConfigCommon(hwndDlg, SP_HPFS, msg, mp1, mp2));
}

/*
 * fnwpConfigFAT:
 *      dlg func for "FAT" settings page
 */

MRESULT EXPENTRY fnwpConfigFAT(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpConfigCommon(hwndDlg, SP_FAT, msg, mp1, mp2));
}

/*
 * fnwpConfigErrors:
 *      dlg func for "Errors" settings page (AUTOFAIL etc.)
 */

MRESULT EXPENTRY fnwpConfigErrors(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpConfigCommon(hwndDlg, SP_ERRORS, msg, mp1, mp2));
}

/*
 * fnwpConfigWPS:
 *      dlg func for "WPS" settings page (autostart etc.)
 */

MRESULT EXPENTRY fnwpConfigWPS(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    return(fnwpConfigCommon(hwndDlg, SP_WPS, msg, mp1, mp2));
}

/********************************************************************
 *                                                                  *
 *   callback funcs for "Select Statusbar Class" dlg                *
 *                                                                  *
 ********************************************************************/

/*
 * All these funcs are called from the dialog funcs in
 * objdlgs.c, which are in turn called when the "Select class"
 * button is pressed on the "Status bars" settings page.
 *
 */

/*
 * fncbStatusBarReturnClassAttr:
 *      this callback function is called for every single
 *      record core which represents a WPS class; we need
 *      to return the record core attributes
 */

MRESULT EXPENTRY fncbStatusBarReturnClassAttr(HWND hwndCnr,
                    ULONG ulscd,   // SELECTCLASSDATA struct
                    MPARAM mpwps,  // current WPSLISTITEM struct
                    MPARAM mpreccParent) // parent record core
{
    USHORT          usAttr = CRA_RECORDREADONLY | CRA_COLLAPSED | CRA_DISABLED;
    PWPSLISTITEM     pwps = (PWPSLISTITEM)mpwps;
    PSELECTCLASSDATA pscd = (PSELECTCLASSDATA)ulscd;
    PRECORDCORE     preccParent = NULL;

    if (pwps) {
        #ifdef DEBUG_SETTINGS
            _Pmpf(("Checking %s\n", pwps->pszClassName));
        #endif
        if (pwps->pClassObject) {

            // now check if the class supports new sort mnemonics
            if (somResolveByName(pwps->pClassObject, "xfclsAddsNewStatusBarMnemonics"))
                if (    ((_xfclsAddsNewStatusBarMnemonics(pwps->pClassObject) & SBS_MODIFIABLE) != 0)
                     && (strlen(pwps->szReplacedByClass) == 0)
                   )
                {
                    // class _does_ support mnemonics: give the
                    // new recc attr the "in use" flag
                    usAttr = CRA_RECORDREADONLY | CRA_COLLAPSED | CRA_INUSE;

                    // and select it if the settings notebook wants it
                    if (strcmp(pwps->pszClassName, pscd->szClassSelected) == 0)
                        usAttr |= CRA_SELECTED;

                    // expand all the parent records of the new record
                    // so that classes with status bar mnemonics are
                    // all initially visible in the container
                    preccParent = (PRECORDCORE)mpreccParent;
                    while (preccParent)
                    {
                        WinSendMsg(hwndCnr, CM_EXPANDTREE, (MPARAM)preccParent, MPNULL);

                        preccParent = WinSendMsg(hwndCnr, CM_QUERYRECORD,
                                preccParent,
                                MPFROM2SHORT(CMA_PARENT, CMA_ITEMORDER));

                        if (preccParent == (PRECORDCORE)-1) {
                            preccParent = NULL;
                        }
                    }
                }

        } // end if if (pwps->pClassObject)
        else {
            // invalid class: hide in cnr
            usAttr = CRA_FILTERED;
        }
    }
    return (MPARAM)(usAttr);
}

/*
 * fncbStatusBarClassSelected:
 *      callback func for class selected;
 *      mphwndInfo has been set to the static control hwnd.
 *      Returns TRUE if the selection is valid; the dlg func
 *      will then enable the OK button.
 */

MRESULT EXPENTRY fncbStatusBarClassSelected(HWND hwndCnr, ULONG ulpsbsc,
                    MPARAM mpwps, MPARAM mphwndInfo)
{
    PWPSLISTITEM pwps = (PWPSLISTITEM)mpwps;
    PSTATUSBARSELECTCLASS psbsc = (PSTATUSBARSELECTCLASS)ulpsbsc;
    CHAR szInfo[2000];
    MRESULT mrc = (MPARAM)FALSE;
    PSZ pszClassTitle;

    strcpy(szInfo, pwps->pszClassName);

    if (pwps->pClassObject) {
        pszClassTitle = _wpclsQueryTitle(pwps->pClassObject);
        if (pszClassTitle)
            sprintf(szInfo, "%s (\"%s\")\n",
                    pwps->pszClassName,
                    pszClassTitle);
    }

    if (pwps->pRecord->flRecordAttr & CRA_INUSE) {
        strcat(szInfo, (psbsc->pNLSStrings)->pszSBClassMnemonics );
        strcat(szInfo, "\n");
        _xfclsQueryStatusBarMnemonics(pwps->pClassObject,
                &(szInfo[strlen(szInfo)]), 256);
        mrc = (MPARAM)TRUE;
    } else {
        strcat(szInfo,
                psbsc->pNLSStrings->pszSBClassNotSupported);
    }

    WinSetWindowText((HWND)mphwndInfo, szInfo);

    return (mrc);
}

/********************************************************************
 *                                                                  *
 *   here come the XFldSystem class methods                         *
 *                                                                  *
 ********************************************************************/

/*
 * wpclsSetSetting:
 *            this WPAbstract method sets the class object
 *            settings in the settings notebook via setup
 *            strings. WPSystem defines the WPS-wide system
 *            setting strings here, and XFolder needs to
 *            introduce its own settings here also.
 */

SOM_Scope BOOL  SOMLINK xfsysM_wpclsSetSetting(M_XFldSystem *somSelf,
                                               PSZ pszSetting,
                                               PVOID pValue)
{
    // M_XFldSystemData *somThis = M_XFldSystemGetData(somSelf);
    M_XFldSystemMethodDebug("M_XFldSystem","xfsysM_wpclsSetSetting");

    return (M_XFldSystem_parent_M_WPSystem_wpclsSetSetting(somSelf,
                                                           pszSetting,
                                                           pValue));
}

/*
 * wpclsQueryIconData:
 *           give the WPS object a new icon
 */

SOM_Scope ULONG  SOMLINK xfsysM_wpclsQueryIconData(M_XFldSystem *somSelf,
                                                   PICONINFO pIconInfo)
{
    // M_XFldSystemData *somThis = M_XFldSystemGetData(somSelf);
    M_XFldSystemMethodDebug("M_XFldSystem","xfsysM_wpclsQueryIconData");

    if (pIconInfo) {
       pIconInfo->fFormat = ICON_RESOURCE;
       pIconInfo->resid   = ID_ICONSYS;
       pIconInfo->hmod    = _xfclsQueryModuleHandle(_XFldObject);
    }

    return (sizeof(ICONINFO));

    /* return (M_XFldSystem_parent_M_WPSystem_wpclsQueryIconData(somSelf,
                                                              pIconInfo)); */
}

/*
 * wpclsQueryTitle:
 *           tell the WPS the new class name: System (XFolder)
 */

SOM_Scope PSZ  SOMLINK xfsysM_wpclsQueryTitle(M_XFldSystem *somSelf)
{
    M_XFldSystemData *somThis = M_XFldSystemGetData(somSelf);
    M_XFldSystemMethodDebug("M_XFldSystem","xfsysM_wpclsQueryTitle");

    strcpy(&(_szTitle[0]), M_XFldSystem_parent_M_WPSystem_wpclsQueryTitle(somSelf));
    strcat(&(_szTitle[0]), " (XFolder)");

    return (&(_szTitle[0]));
}

/********************************************************************
 *                                                                  *
 *   here come the XFldWPS instance methods                         *
 *                                                                  *
 ********************************************************************/

/*
 * xfAddXFldWPSPages:
 *           this actually adds the XFolder pages into the "Workplace Shell" notebook
 */

SOM_Scope ULONG  SOMLINK xfwps_xfAddXFldWPSPages(XFldWPS *somSelf,
                                                   HWND hwndDlg)
{
    PAGEINFO        pi;
    HMODULE         savehmod;
    CHAR            szXFolderVersion[100];
    PNLSSTRINGS pNLSStrings = cmnQueryNLSStrings();
    PSZ pszHelpLibrary = cmnQueryHelpLibrary();
    /* XFldWPSData *somThis = XFldWPSGetData(somSelf); */
    XFldWPSMethodDebug("XFldWPS","xfwps_xfAddXFldWPSPages");
    savehmod = NLS_MODULE;
    strcpy(szXFolderVersion, "~XFolder ");
    strcat(szXFolderVersion, XFOLDER_VERSION);
    memset((PCH)&pi, 0, sizeof(PAGEINFO));

    // insert "WPS Classes" page
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpSettingsWpsClasses;
    pi.resid               = NLS_MODULE;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SETTINGS_WPSCLASSES;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MAJOR;   // major tab;
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = 0; // don't enumerate in status line
    pi.pszName             = pNLSStrings->pszWpsClasses;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS_WPSCLASSES;

    _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

    // insert "Sort" page
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpSettingsDlg_FldrSort;
    pi.resid               = NLS_MODULE;
    pi.pCreateParams       = NULL;                      // NULL means global settings
    pi.dlgid               = ID_XSD_SETTINGS_FLDRSORT;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MAJOR;   // major tab;
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = 0; // don't enumerate in status line
    pi.pszName             = pNLSStrings->pszSort;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS_FLDRSORT;

    _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

    // insert "Hotkeys" page
    memset((PCH)&pi, 0, sizeof(PAGEINFO));
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpSettingsAccels;
    pi.resid               = savehmod;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SET4ACCELS;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MAJOR;               // no major tabs
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = 0; // SETTINGS_PAGE_NUMBERS;          // auto enumerate in status line
    pi.pszName             = pNLSStrings->psz4Accelerators;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS1+5;

    _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

    // insert "Snap to grid" page
    memset((PCH)&pi, 0, sizeof(PAGEINFO));
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpSettingsSnapToGrid;
    pi.resid               = savehmod;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SET3SNAPTOGRID;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MAJOR;               // no major tabs
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = 0; // SETTINGS_PAGE_NUMBERS;          // auto enumerate in status line
    pi.pszName             = pNLSStrings->psz3SnapToGrid;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS1+4;

    _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

    /*
     * "Status bar" pages
     */

    // insert "Status bar" page 2
    memset((PCH)&pi, 0, sizeof(PAGEINFO));
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpSettingsStatusBars2;
    pi.resid               = savehmod;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SET28STATUSBARS2;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON;               // no major tabs
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = SETTINGS_PAGE_NUMBERS;          // auto enumerate in status line
    pi.pszName             = pNLSStrings->psz27StatusBar;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS_SB2;

    _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

    // insert "Status bar" page 1
    memset((PCH)&pi, 0, sizeof(PAGEINFO));
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpSettingsStatusBars1;
    pi.resid               = savehmod;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SET27STATUSBARS;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MAJOR;               // no major tabs
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = SETTINGS_PAGE_NUMBERS;          // auto enumerate in status line
    pi.pszName             = pNLSStrings->psz27StatusBar;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS1+3;

    _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

    /*
     * "Menu items" pages
     */

    // insert "Remove Menu Items"
    memset((PCH)&pi, 0, sizeof(PAGEINFO));
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpSettingsRemoveMenus;
    pi.resid               = savehmod;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SET2REMOVEMENUS;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MINOR;               // no major tabs
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = SETTINGS_PAGE_NUMBERS;          // auto enumerate in status line
    pi.pszName             = pNLSStrings->psz2RemoveItems;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS1+1;

    _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

    // insert "Config folder menu items" page
    memset((PCH)&pi, 0, sizeof(PAGEINFO));
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpSettingsConfigFolderMenus;
    pi.resid               = savehmod;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SET26CONFIGMENUS;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MINOR;
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = SETTINGS_PAGE_NUMBERS;          // auto enumerate in status line
    pi.pszName             = pNLSStrings->psz26ConfigFolderMenus;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS_CFGM;

    _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

    // insert "Add Menu Items" page
    memset((PCH)&pi, 0, sizeof(PAGEINFO));
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpSettingsAddMenus;
    pi.resid               = savehmod;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SET25ADDMENUS;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MAJOR;
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = SETTINGS_PAGE_NUMBERS;          // auto enumerate in status line
    pi.pszName             = pNLSStrings->psz25AddItems;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS1+2;

    _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

    /*
     * "File Operations" page
     */

    memset((PCH)&pi, 0, sizeof(PAGEINFO));
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpSettingsFileOperations;
    pi.resid               = savehmod;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SETTINGS_FILEOPS;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MAJOR;                // no major tabs
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = SETTINGS_PAGE_NUMBERS;          // auto enumerate in status line
    pi.pszName             = pNLSStrings->pszFileOps;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS_FILEOPS;

    _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

    /*
     * "XFolder" pages
     */

    // insert "Internals" settings page
    memset((PCH)&pi, 0, sizeof(PAGEINFO));
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpSettingsXFolderInternals;
    pi.resid               = savehmod;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SET5INTERNALS;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MINOR;                // no major tabs
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = SETTINGS_PAGE_NUMBERS;          // auto enumerate in status line
    pi.pszName             = pNLSStrings->psz5Internals;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS1+6;

    _wpInsertSettingsPage(somSelf, hwndDlg, &pi);

    // insert XFolder settings page 1
    memset((PCH)&pi, 0, sizeof(PAGEINFO));
    pi.cb                  = sizeof(PAGEINFO);
    pi.hwndPage            = NULLHANDLE;
    pi.pfnwp               = fnwpSettingsXFolder1;
    pi.resid               = savehmod;
    pi.pCreateParams       = somSelf;
    pi.dlgid               = ID_XSD_SET1XFOLDER;
    pi.usPageStyleFlags    = BKA_STATUSTEXTON | BKA_MAJOR;   // give major tab
    pi.usPageInsertFlags   = BKA_FIRST;
    pi.usSettingsFlags     = SETTINGS_PAGE_NUMBERS;          // auto enumerate in status line
    pi.pszName             = szXFolderVersion;

    pi.pszHelpLibraryName  = pszHelpLibrary;
    pi.idDefaultHelpPanel  = ID_XSH_SETTINGS1;

    return (_wpInsertSettingsPage(somSelf, hwndDlg, &pi));
}

/*
 * wpAddSettingsPages:
 *                this instance method is overridden in order
 *                to add the new XFolder pages after the default
 *                "Window" page in the settings notebook
 */

SOM_Scope BOOL  SOMLINK xfwps_wpAddSettingsPages(XFldWPS *somSelf,
                                                   HWND hwndNotebook)
{
    /* XFldWPSData *somThis = XFldWPSGetData(somSelf); */
    XFldWPSMethodDebug("XFldWPS","xfwps_wpAddSettingsPages");

    // we do _not_ call the parent method, but call the
    // methods which insert the WPS pages directly; this
    // way we suppress the pages which we don't want to
    // see in the "Workplace Shell" object

    /* XFldWPS_parent_WPSystem_wpAddSettingsPages(somSelf,
                                                       hwndNotebook); */

    _xfAddObjectInternalsPage(somSelf, hwndNotebook);
    _wpAddObjectGeneralPage(somSelf, hwndNotebook);

    _wpAddSystemConfirmationPage(somSelf, hwndNotebook);

    _wpAddSysFdrSelfClosePage(somSelf, hwndNotebook);
    _wpAddSysFdrDefViewPage(somSelf, hwndNotebook);
    _wpAddSystemWindowPage(somSelf, hwndNotebook);

    _wpAddTitleConfirmationPage(somSelf, hwndNotebook);

    // add XFolder pages on top
    _xfAddXFldWPSPages(somSelf, hwndNotebook);

    return (TRUE);
}

/********************************************************************
 *                                                                  *
 *   here come the XFldWPS class methods                            *
 *                                                                  *
 ********************************************************************/

/*
 * wpclsSetSetting:
 *           this WPAbstract method sets the class object
 *           settings in the settings notebook via setup
 *           strings. WPSystem defines the WPS-wide system
 *           setting strings here, and XFolder needs to
 *           introduce its own settings here also.
 */

SOM_Scope BOOL  SOMLINK xfwpsM_wpclsSetSetting(M_XFldWPS *somSelf,
                                                 PSZ pszSetting,
                                                 PVOID pValue)
{
    // M_XFldWPSData *somThis = M_XFldWPSGetData(somSelf);
    M_XFldWPSMethodDebug("M_XFldWPS","xfwpsM_wpclsSetSetting");

    return (M_XFldWPS_parent_M_WPSystem_wpclsSetSetting(somSelf,
                                                        pszSetting,
                                                        pValue));
}

/*
 * wpclsQueryIconData:
 *           give the WPS object a new icon
 */

SOM_Scope ULONG  SOMLINK xfwpsM_wpclsQueryIconData(M_XFldWPS *somSelf,
                                                   PICONINFO pIconInfo)
{
    // M_XFldWPSData *somThis = M_XFldWPSGetData(somSelf);
    M_XFldWPSMethodDebug("M_XFldWPS","xfwpsM_wpclsQueryIconData");

    if (pIconInfo) {
       pIconInfo->fFormat = ICON_RESOURCE;
       pIconInfo->resid   = ID_ICONWPS;
       pIconInfo->hmod    = _xfclsQueryModuleHandle(_XFldObject);
    }

    return (sizeof(ICONINFO));

    /* return (M_XFldWPS_parent_M_WPSystem_wpclsQueryIconData(somSelf,
                                                           pIconInfo)); */
}

/*
 * wpclsQueryTitle:
 *           tell the WPS the new class name: "Workplace Shell"
 */

SOM_Scope PSZ  SOMLINK xfwpsM_wpclsQueryTitle(M_XFldWPS *somSelf)
{
    // M_XFldWPSData *somThis = M_XFldWPSGetData(somSelf);
    M_XFldWPSMethodDebug("M_XFldWPS","xfwpsM_wpclsQueryTitle");

    return ("Workplace Shell");
}

